#include "boostmath-exports.h"
#include "scc-core.h"
#include "../system/supervisorinterface.h"
# line 4 "../../../../Macaulay2/d/boostmath.dd"
#include <iostream>
  #include <boost/multiprecision/mpfr.hpp>
  #include <boost/math/special_functions/beta.hpp>
  #include <boost/math/special_functions/erf.hpp>
  #include <boost/math/special_functions/gamma.hpp>

  #define RR_TO_BOOST(x) boost::multiprecision::mpfr_float(x)

  #define BOOST_MATH_CALL(f, prec, ...)                                  \
  try {                                                                  \
    boost::multiprecision::mpfr_float::default_precision(                \
	boost::multiprecision::detail::digits2_2_10(prec));              \
    return gmp_toRR(boost::math::f(__VA_ARGS__).backend().data(), prec); \
  } catch (const std::exception& e) {                                    \
    std::cout << e.what() << std::endl;                                  \
    return nullptr;                                                      \
  }
static M2_string str_;
# line 23 "../../../../Macaulay2/d/boostmath.dd"
static parse_Expr handleBoostError(gmp_RRorNull x){
  # line 23 "../../../../Macaulay2/d/boostmath.dd"
  mpfr_srcptr y;
  # line 23 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp_;
  # line 23 "../../../../Macaulay2/d/boostmath.dd"
  if (0 == x) goto L1_;
  # line 23 "../../../../Macaulay2/d/boostmath.dd"
  goto L0_;
  # line 23 "../../../../Macaulay2/d/boostmath.dd"
  L1_:;
  # line 24 "../../../../Macaulay2/d/boostmath.dd"
  tmp_ = expr_buildErrorPacket(str_);
  # line 24 "../../../../Macaulay2/d/boostmath.dd"
  goto L2_;
  # line 24 "../../../../Macaulay2/d/boostmath.dd"
  L0_:;
  # line 23 "../../../../Macaulay2/d/boostmath.dd"
  y = ((mpfr_srcptr)x);
  # line 25 "../../../../Macaulay2/d/boostmath.dd"
  tmp_ = util_toExpr_15(y);
  # line 25 "../../../../Macaulay2/d/boostmath.dd"
  goto L2_;
  # line 25 "../../../../Macaulay2/d/boostmath.dd"
  L2_:;
  # line 25 "../../../../Macaulay2/d/boostmath.dd"
  return tmp_;
  # line 25 "../../../../Macaulay2/d/boostmath.dd"
  }
# line 29 "../../../../Macaulay2/d/boostmath.dd"
static gmp_RRorNull inverseErf(mpfr_srcptr p){
  # line 29 "../../../../Macaulay2/d/boostmath.dd"
  unsigned long prec;
  # line 29 "../../../../Macaulay2/d/boostmath.dd"
  prec = gmp_precision(p);
  # line 30 "../../../../Macaulay2/d/boostmath.dd"
  BOOST_MATH_CALL(erf_inv, prec, RR_TO_BOOST(p));
  # line 30 "../../../../Macaulay2/d/boostmath.dd"
  }
# line 33 "../../../../Macaulay2/d/boostmath.dd"
static parse_Expr inverseErf_1(parse_Expr e){
  # line 33 "../../../../Macaulay2/d/boostmath.dd"
  gmp_RRcell p_1;
  # line 33 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__1;
  # line 33 "../../../../Macaulay2/d/boostmath.dd"
  switch (e->type_) {;
    # line 33 "../../../../Macaulay2/d/boostmath.dd"
    case 51:;
    # line 33 "../../../../Macaulay2/d/boostmath.dd"
    p_1 = ((gmp_RRcell)e);
    # line 33 "../../../../Macaulay2/d/boostmath.dd"
    tmp__1 = handleBoostError(inverseErf(p_1->v));
    # line 33 "../../../../Macaulay2/d/boostmath.dd"
    break;
    # line 33 "../../../../Macaulay2/d/boostmath.dd"
    default:;
    # line 34 "../../../../Macaulay2/d/boostmath.dd"
    tmp__1 = expr_WrongArgRR();
    # line 34 "../../../../Macaulay2/d/boostmath.dd"
    break;
    # line 34 "../../../../Macaulay2/d/boostmath.dd"
    };
  # line 34 "../../../../Macaulay2/d/boostmath.dd"
  return tmp__1;
  # line 34 "../../../../Macaulay2/d/boostmath.dd"
  }
# line 34 "../../../../Macaulay2/d/boostmath.dd"
static M2_string str__1;
# line 39 "../../../../Macaulay2/d/boostmath.dd"
static gmp_RRorNull regularizedGamma(mpfr_srcptr a,mpfr_srcptr z){
  # line 39 "../../../../Macaulay2/d/boostmath.dd"
  unsigned long prec_1;
  # line 39 "../../../../Macaulay2/d/boostmath.dd"
  prec_1 = gmp_min_3(gmp_precision(a), gmp_precision(z));
  # line 40 "../../../../Macaulay2/d/boostmath.dd"
  BOOST_MATH_CALL(gamma_q, prec_1, RR_TO_BOOST(a), RR_TO_BOOST(z));
  # line 40 "../../../../Macaulay2/d/boostmath.dd"
  }
# line 43 "../../../../Macaulay2/d/boostmath.dd"
static parse_Expr regularizedGamma_1(parse_Expr e){
  # line 43 "../../../../Macaulay2/d/boostmath.dd"
  parse_Sequence s;
  # line 43 "../../../../Macaulay2/d/boostmath.dd"
  gmp_RRcell a_1;
  # line 43 "../../../../Macaulay2/d/boostmath.dd"
  gmp_RRcell z_1;
  # line 43 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__2;
  # line 43 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__3;
  # line 43 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__4;
  # line 43 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__5;
  # line 43 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__6;
  # line 43 "../../../../Macaulay2/d/boostmath.dd"
  switch (e->type_) {;
    # line 43 "../../../../Macaulay2/d/boostmath.dd"
    case 7:;
    # line 43 "../../../../Macaulay2/d/boostmath.dd"
    s = ((parse_Sequence)e);
    # line 44 "../../../../Macaulay2/d/boostmath.dd"
    tmp__2 = s->array[0];
    # line 44 "../../../../Macaulay2/d/boostmath.dd"
    switch (tmp__2->type_) {;
      # line 44 "../../../../Macaulay2/d/boostmath.dd"
      case 51:;
      # line 44 "../../../../Macaulay2/d/boostmath.dd"
      a_1 = ((gmp_RRcell)tmp__2);
      # line 45 "../../../../Macaulay2/d/boostmath.dd"
      tmp__3 = s->array[1];
      # line 45 "../../../../Macaulay2/d/boostmath.dd"
      switch (tmp__3->type_) {;
	# line 45 "../../../../Macaulay2/d/boostmath.dd"
	case 51:;
	# line 45 "../../../../Macaulay2/d/boostmath.dd"
	z_1 = ((gmp_RRcell)tmp__3);
	# line 45 "../../../../Macaulay2/d/boostmath.dd"
	tmp__4 = handleBoostError(regularizedGamma(a_1->v, z_1->v));
	# line 45 "../../../../Macaulay2/d/boostmath.dd"
	break;
	# line 45 "../../../../Macaulay2/d/boostmath.dd"
	default:;
	# line 46 "../../../../Macaulay2/d/boostmath.dd"
	tmp__4 = expr_WrongArgRR_1(2);
	# line 46 "../../../../Macaulay2/d/boostmath.dd"
	break;
	# line 46 "../../../../Macaulay2/d/boostmath.dd"
	};
      # line 46 "../../../../Macaulay2/d/boostmath.dd"
      tmp__5 = tmp__4;
      # line 46 "../../../../Macaulay2/d/boostmath.dd"
      break;
      # line 46 "../../../../Macaulay2/d/boostmath.dd"
      default:;
      # line 47 "../../../../Macaulay2/d/boostmath.dd"
      tmp__5 = expr_WrongArgRR_1(1);
      # line 47 "../../../../Macaulay2/d/boostmath.dd"
      break;
      # line 47 "../../../../Macaulay2/d/boostmath.dd"
      };
    # line 47 "../../../../Macaulay2/d/boostmath.dd"
    tmp__6 = tmp__5;
    # line 47 "../../../../Macaulay2/d/boostmath.dd"
    break;
    # line 47 "../../../../Macaulay2/d/boostmath.dd"
    default:;
    # line 48 "../../../../Macaulay2/d/boostmath.dd"
    tmp__6 = expr_WrongNumArgs_1(2);
    # line 48 "../../../../Macaulay2/d/boostmath.dd"
    break;
    # line 48 "../../../../Macaulay2/d/boostmath.dd"
    };
  # line 48 "../../../../Macaulay2/d/boostmath.dd"
  return tmp__6;
  # line 48 "../../../../Macaulay2/d/boostmath.dd"
  }
# line 48 "../../../../Macaulay2/d/boostmath.dd"
static M2_string str__2;
# line 53 "../../../../Macaulay2/d/boostmath.dd"
static gmp_RRorNull inverseRegularizedGamma(mpfr_srcptr a,mpfr_srcptr q){
  # line 53 "../../../../Macaulay2/d/boostmath.dd"
  unsigned long prec_2;
  # line 53 "../../../../Macaulay2/d/boostmath.dd"
  prec_2 = gmp_min_3(gmp_precision(a), gmp_precision(q));
  # line 54 "../../../../Macaulay2/d/boostmath.dd"
  BOOST_MATH_CALL(gamma_q_inv, prec_2, RR_TO_BOOST(a), RR_TO_BOOST(q));
  # line 54 "../../../../Macaulay2/d/boostmath.dd"
  }
# line 57 "../../../../Macaulay2/d/boostmath.dd"
static parse_Expr inverseRegularizedGamma_1(parse_Expr e){
  # line 57 "../../../../Macaulay2/d/boostmath.dd"
  parse_Sequence s_1;
  # line 57 "../../../../Macaulay2/d/boostmath.dd"
  gmp_RRcell a_2;
  # line 57 "../../../../Macaulay2/d/boostmath.dd"
  gmp_RRcell q_1;
  # line 57 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__7;
  # line 57 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__8;
  # line 57 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__9;
  # line 57 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__10;
  # line 57 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__11;
  # line 57 "../../../../Macaulay2/d/boostmath.dd"
  switch (e->type_) {;
    # line 57 "../../../../Macaulay2/d/boostmath.dd"
    case 7:;
    # line 57 "../../../../Macaulay2/d/boostmath.dd"
    s_1 = ((parse_Sequence)e);
    # line 58 "../../../../Macaulay2/d/boostmath.dd"
    tmp__7 = s_1->array[0];
    # line 58 "../../../../Macaulay2/d/boostmath.dd"
    switch (tmp__7->type_) {;
      # line 58 "../../../../Macaulay2/d/boostmath.dd"
      case 51:;
      # line 58 "../../../../Macaulay2/d/boostmath.dd"
      a_2 = ((gmp_RRcell)tmp__7);
      # line 59 "../../../../Macaulay2/d/boostmath.dd"
      tmp__8 = s_1->array[1];
      # line 59 "../../../../Macaulay2/d/boostmath.dd"
      switch (tmp__8->type_) {;
	# line 59 "../../../../Macaulay2/d/boostmath.dd"
	case 51:;
	# line 59 "../../../../Macaulay2/d/boostmath.dd"
	q_1 = ((gmp_RRcell)tmp__8);
	# line 60 "../../../../Macaulay2/d/boostmath.dd"
	tmp__9 = handleBoostError(inverseRegularizedGamma(a_2->v, q_1->v));
	# line 60 "../../../../Macaulay2/d/boostmath.dd"
	break;
	# line 60 "../../../../Macaulay2/d/boostmath.dd"
	default:;
	# line 61 "../../../../Macaulay2/d/boostmath.dd"
	tmp__9 = expr_WrongArgRR_1(2);
	# line 61 "../../../../Macaulay2/d/boostmath.dd"
	break;
	# line 61 "../../../../Macaulay2/d/boostmath.dd"
	};
      # line 61 "../../../../Macaulay2/d/boostmath.dd"
      tmp__10 = tmp__9;
      # line 61 "../../../../Macaulay2/d/boostmath.dd"
      break;
      # line 61 "../../../../Macaulay2/d/boostmath.dd"
      default:;
      # line 62 "../../../../Macaulay2/d/boostmath.dd"
      tmp__10 = expr_WrongArgRR_1(1);
      # line 62 "../../../../Macaulay2/d/boostmath.dd"
      break;
      # line 62 "../../../../Macaulay2/d/boostmath.dd"
      };
    # line 62 "../../../../Macaulay2/d/boostmath.dd"
    tmp__11 = tmp__10;
    # line 62 "../../../../Macaulay2/d/boostmath.dd"
    break;
    # line 62 "../../../../Macaulay2/d/boostmath.dd"
    default:;
    # line 63 "../../../../Macaulay2/d/boostmath.dd"
    tmp__11 = expr_WrongNumArgs_1(2);
    # line 63 "../../../../Macaulay2/d/boostmath.dd"
    break;
    # line 63 "../../../../Macaulay2/d/boostmath.dd"
    };
  # line 63 "../../../../Macaulay2/d/boostmath.dd"
  return tmp__11;
  # line 63 "../../../../Macaulay2/d/boostmath.dd"
  }
# line 63 "../../../../Macaulay2/d/boostmath.dd"
static M2_string str__3;
# line 68 "../../../../Macaulay2/d/boostmath.dd"
static gmp_RRorNull regularizedBeta(mpfr_srcptr x,mpfr_srcptr a,mpfr_srcptr b){
  # line 68 "../../../../Macaulay2/d/boostmath.dd"
  unsigned long prec_3;
  # line 68 "../../../../Macaulay2/d/boostmath.dd"
  prec_3 = gmp_min_3(gmp_precision(x), gmp_min_3(gmp_precision(a), gmp_precision(b)));
  # line 69 "../../../../Macaulay2/d/boostmath.dd"
  BOOST_MATH_CALL(ibeta, prec_3, RR_TO_BOOST(a), RR_TO_BOOST(b), RR_TO_BOOST(x));
  # line 69 "../../../../Macaulay2/d/boostmath.dd"
  }
# line 72 "../../../../Macaulay2/d/boostmath.dd"
static parse_Expr regularizedBeta_1(parse_Expr e){
  # line 72 "../../../../Macaulay2/d/boostmath.dd"
  parse_Sequence s_2;
  # line 72 "../../../../Macaulay2/d/boostmath.dd"
  gmp_RRcell x_1;
  # line 72 "../../../../Macaulay2/d/boostmath.dd"
  gmp_RRcell a_3;
  # line 72 "../../../../Macaulay2/d/boostmath.dd"
  gmp_RRcell b_1;
  # line 72 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__12;
  # line 72 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__13;
  # line 72 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__14;
  # line 72 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__15;
  # line 72 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__16;
  # line 72 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__17;
  # line 72 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__18;
  # line 72 "../../../../Macaulay2/d/boostmath.dd"
  switch (e->type_) {;
    # line 72 "../../../../Macaulay2/d/boostmath.dd"
    case 7:;
    # line 72 "../../../../Macaulay2/d/boostmath.dd"
    s_2 = ((parse_Sequence)e);
    # line 73 "../../../../Macaulay2/d/boostmath.dd"
    tmp__12 = s_2->array[0];
    # line 73 "../../../../Macaulay2/d/boostmath.dd"
    switch (tmp__12->type_) {;
      # line 73 "../../../../Macaulay2/d/boostmath.dd"
      case 51:;
      # line 73 "../../../../Macaulay2/d/boostmath.dd"
      x_1 = ((gmp_RRcell)tmp__12);
      # line 74 "../../../../Macaulay2/d/boostmath.dd"
      tmp__13 = s_2->array[1];
      # line 74 "../../../../Macaulay2/d/boostmath.dd"
      switch (tmp__13->type_) {;
	# line 74 "../../../../Macaulay2/d/boostmath.dd"
	case 51:;
	# line 74 "../../../../Macaulay2/d/boostmath.dd"
	a_3 = ((gmp_RRcell)tmp__13);
	# line 75 "../../../../Macaulay2/d/boostmath.dd"
	tmp__14 = s_2->array[2];
	# line 75 "../../../../Macaulay2/d/boostmath.dd"
	switch (tmp__14->type_) {;
	  # line 75 "../../../../Macaulay2/d/boostmath.dd"
	  case 51:;
	  # line 75 "../../../../Macaulay2/d/boostmath.dd"
	  b_1 = ((gmp_RRcell)tmp__14);
	  # line 76 "../../../../Macaulay2/d/boostmath.dd"
	  tmp__15 = handleBoostError(regularizedBeta(x_1->v, a_3->v, b_1->v));
	  # line 76 "../../../../Macaulay2/d/boostmath.dd"
	  break;
	  # line 76 "../../../../Macaulay2/d/boostmath.dd"
	  default:;
	  # line 77 "../../../../Macaulay2/d/boostmath.dd"
	  tmp__15 = expr_WrongArgRR_1(3);
	  # line 77 "../../../../Macaulay2/d/boostmath.dd"
	  break;
	  # line 77 "../../../../Macaulay2/d/boostmath.dd"
	  };
	# line 77 "../../../../Macaulay2/d/boostmath.dd"
	tmp__16 = tmp__15;
	# line 77 "../../../../Macaulay2/d/boostmath.dd"
	break;
	# line 77 "../../../../Macaulay2/d/boostmath.dd"
	default:;
	# line 78 "../../../../Macaulay2/d/boostmath.dd"
	tmp__16 = expr_WrongArgRR_1(2);
	# line 78 "../../../../Macaulay2/d/boostmath.dd"
	break;
	# line 78 "../../../../Macaulay2/d/boostmath.dd"
	};
      # line 78 "../../../../Macaulay2/d/boostmath.dd"
      tmp__17 = tmp__16;
      # line 78 "../../../../Macaulay2/d/boostmath.dd"
      break;
      # line 78 "../../../../Macaulay2/d/boostmath.dd"
      default:;
      # line 79 "../../../../Macaulay2/d/boostmath.dd"
      tmp__17 = expr_WrongArgRR_1(1);
      # line 79 "../../../../Macaulay2/d/boostmath.dd"
      break;
      # line 79 "../../../../Macaulay2/d/boostmath.dd"
      };
    # line 79 "../../../../Macaulay2/d/boostmath.dd"
    tmp__18 = tmp__17;
    # line 79 "../../../../Macaulay2/d/boostmath.dd"
    break;
    # line 79 "../../../../Macaulay2/d/boostmath.dd"
    default:;
    # line 80 "../../../../Macaulay2/d/boostmath.dd"
    tmp__18 = expr_WrongNumArgs_1(3);
    # line 80 "../../../../Macaulay2/d/boostmath.dd"
    break;
    # line 80 "../../../../Macaulay2/d/boostmath.dd"
    };
  # line 80 "../../../../Macaulay2/d/boostmath.dd"
  return tmp__18;
  # line 80 "../../../../Macaulay2/d/boostmath.dd"
  }
# line 80 "../../../../Macaulay2/d/boostmath.dd"
static M2_string str__4;
# line 85 "../../../../Macaulay2/d/boostmath.dd"
static gmp_RRorNull inverseRegularizedBeta(mpfr_srcptr p,mpfr_srcptr a,mpfr_srcptr b){
  # line 85 "../../../../Macaulay2/d/boostmath.dd"
  unsigned long prec_4;
  # line 85 "../../../../Macaulay2/d/boostmath.dd"
  prec_4 = gmp_min_3(gmp_precision(p), gmp_min_3(gmp_precision(a), gmp_precision(b)));
  # line 86 "../../../../Macaulay2/d/boostmath.dd"
  BOOST_MATH_CALL(ibeta_inv, prec_4, RR_TO_BOOST(a), RR_TO_BOOST(b), RR_TO_BOOST(p));
  # line 86 "../../../../Macaulay2/d/boostmath.dd"
  }
# line 89 "../../../../Macaulay2/d/boostmath.dd"
static parse_Expr inverseRegularizedBeta_1(parse_Expr e){
  # line 89 "../../../../Macaulay2/d/boostmath.dd"
  parse_Sequence s_3;
  # line 89 "../../../../Macaulay2/d/boostmath.dd"
  gmp_RRcell p_2;
  # line 89 "../../../../Macaulay2/d/boostmath.dd"
  gmp_RRcell a_4;
  # line 89 "../../../../Macaulay2/d/boostmath.dd"
  gmp_RRcell b_2;
  # line 89 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__19;
  # line 89 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__20;
  # line 89 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__21;
  # line 89 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__22;
  # line 89 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__23;
  # line 89 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__24;
  # line 89 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__25;
  # line 89 "../../../../Macaulay2/d/boostmath.dd"
  switch (e->type_) {;
    # line 89 "../../../../Macaulay2/d/boostmath.dd"
    case 7:;
    # line 89 "../../../../Macaulay2/d/boostmath.dd"
    s_3 = ((parse_Sequence)e);
    # line 90 "../../../../Macaulay2/d/boostmath.dd"
    tmp__19 = s_3->array[0];
    # line 90 "../../../../Macaulay2/d/boostmath.dd"
    switch (tmp__19->type_) {;
      # line 90 "../../../../Macaulay2/d/boostmath.dd"
      case 51:;
      # line 90 "../../../../Macaulay2/d/boostmath.dd"
      p_2 = ((gmp_RRcell)tmp__19);
      # line 91 "../../../../Macaulay2/d/boostmath.dd"
      tmp__20 = s_3->array[1];
      # line 91 "../../../../Macaulay2/d/boostmath.dd"
      switch (tmp__20->type_) {;
	# line 91 "../../../../Macaulay2/d/boostmath.dd"
	case 51:;
	# line 91 "../../../../Macaulay2/d/boostmath.dd"
	a_4 = ((gmp_RRcell)tmp__20);
	# line 92 "../../../../Macaulay2/d/boostmath.dd"
	tmp__21 = s_3->array[2];
	# line 92 "../../../../Macaulay2/d/boostmath.dd"
	switch (tmp__21->type_) {;
	  # line 92 "../../../../Macaulay2/d/boostmath.dd"
	  case 51:;
	  # line 92 "../../../../Macaulay2/d/boostmath.dd"
	  b_2 = ((gmp_RRcell)tmp__21);
	  # line 93 "../../../../Macaulay2/d/boostmath.dd"
	  tmp__22 = handleBoostError(inverseRegularizedBeta(p_2->v, a_4->v, b_2->v));
	  # line 93 "../../../../Macaulay2/d/boostmath.dd"
	  break;
	  # line 93 "../../../../Macaulay2/d/boostmath.dd"
	  default:;
	  # line 94 "../../../../Macaulay2/d/boostmath.dd"
	  tmp__22 = expr_WrongArgRR_1(3);
	  # line 94 "../../../../Macaulay2/d/boostmath.dd"
	  break;
	  # line 94 "../../../../Macaulay2/d/boostmath.dd"
	  };
	# line 94 "../../../../Macaulay2/d/boostmath.dd"
	tmp__23 = tmp__22;
	# line 94 "../../../../Macaulay2/d/boostmath.dd"
	break;
	# line 94 "../../../../Macaulay2/d/boostmath.dd"
	default:;
	# line 95 "../../../../Macaulay2/d/boostmath.dd"
	tmp__23 = expr_WrongArgRR_1(2);
	# line 95 "../../../../Macaulay2/d/boostmath.dd"
	break;
	# line 95 "../../../../Macaulay2/d/boostmath.dd"
	};
      # line 95 "../../../../Macaulay2/d/boostmath.dd"
      tmp__24 = tmp__23;
      # line 95 "../../../../Macaulay2/d/boostmath.dd"
      break;
      # line 95 "../../../../Macaulay2/d/boostmath.dd"
      default:;
      # line 96 "../../../../Macaulay2/d/boostmath.dd"
      tmp__24 = expr_WrongArgRR_1(1);
      # line 96 "../../../../Macaulay2/d/boostmath.dd"
      break;
      # line 96 "../../../../Macaulay2/d/boostmath.dd"
      };
    # line 96 "../../../../Macaulay2/d/boostmath.dd"
    tmp__25 = tmp__24;
    # line 96 "../../../../Macaulay2/d/boostmath.dd"
    break;
    # line 96 "../../../../Macaulay2/d/boostmath.dd"
    default:;
    # line 97 "../../../../Macaulay2/d/boostmath.dd"
    tmp__25 = expr_WrongNumArgs_1(3);
    # line 97 "../../../../Macaulay2/d/boostmath.dd"
    break;
    # line 97 "../../../../Macaulay2/d/boostmath.dd"
    };
  # line 97 "../../../../Macaulay2/d/boostmath.dd"
  return tmp__25;
  # line 97 "../../../../Macaulay2/d/boostmath.dd"
  }
# line 97 "../../../../Macaulay2/d/boostmath.dd"
static M2_string str__5;
# line 97 "../../../../Macaulay2/d/boostmath.dd"
static void boostmath__thread_prepare();
# line 97 "../../../../Macaulay2/d/boostmath.dd"
static void boostmath__final();
# line 24 "../../../../Macaulay2/d/boostmath.dd"
void boostmath__prepare(){
  # line 24 "../../../../Macaulay2/d/boostmath.dd"
  static struct FUNCTION_CELL this_final, this_thread_prepare;
  # line 24 "../../../../Macaulay2/d/boostmath.dd"
  static int called_yet = 0;
  # line 24 "../../../../Macaulay2/d/boostmath.dd"
  if (called_yet) return; else called_yet = 1;
  # line 24 "../../../../Macaulay2/d/boostmath.dd"
  str_ = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (24)*sizeof(signed char)-sizeof(signed char));
  if (0 == str_) outofmem2((size_t)sizeof(struct M2_string_struct) + (24)*sizeof(signed char)-sizeof(signed char));
  # line 24 "../../../../Macaulay2/d/boostmath.dd"
  str_->len = 24;
  # line 24 "../../../../Macaulay2/d/boostmath.dd"
  memcpy(str_->array, "Boost Math Toolkit error", 24);
  # line 24 "../../../../Macaulay2/d/boostmath.dd"
  str__1 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (10)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__1) outofmem2((size_t)sizeof(struct M2_string_struct) + (10)*sizeof(signed char)-sizeof(signed char));
  # line 24 "../../../../Macaulay2/d/boostmath.dd"
  str__1->len = 10;
  # line 35 "../../../../Macaulay2/d/boostmath.dd"
  memcpy(str__1->array, "inverseErf", 10);
  # line 35 "../../../../Macaulay2/d/boostmath.dd"
  str__2 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (16)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__2) outofmem2((size_t)sizeof(struct M2_string_struct) + (16)*sizeof(signed char)-sizeof(signed char));
  # line 35 "../../../../Macaulay2/d/boostmath.dd"
  str__2->len = 16;
  # line 49 "../../../../Macaulay2/d/boostmath.dd"
  memcpy(str__2->array, "regularizedGamma", 16);
  # line 49 "../../../../Macaulay2/d/boostmath.dd"
  str__3 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (23)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__3) outofmem2((size_t)sizeof(struct M2_string_struct) + (23)*sizeof(signed char)-sizeof(signed char));
  # line 49 "../../../../Macaulay2/d/boostmath.dd"
  str__3->len = 23;
  # line 64 "../../../../Macaulay2/d/boostmath.dd"
  memcpy(str__3->array, "inverseRegularizedGamma", 23);
  # line 64 "../../../../Macaulay2/d/boostmath.dd"
  str__4 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__4) outofmem2((size_t)sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  # line 64 "../../../../Macaulay2/d/boostmath.dd"
  str__4->len = 15;
  # line 81 "../../../../Macaulay2/d/boostmath.dd"
  memcpy(str__4->array, "regularizedBeta", 15);
  # line 81 "../../../../Macaulay2/d/boostmath.dd"
  str__5 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (22)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__5) outofmem2((size_t)sizeof(struct M2_string_struct) + (22)*sizeof(signed char)-sizeof(signed char));
  # line 81 "../../../../Macaulay2/d/boostmath.dd"
  str__5->len = 22;
  # line 98 "../../../../Macaulay2/d/boostmath.dd"
  memcpy(str__5->array, "inverseRegularizedBeta", 22);
  # line 98 "../../../../Macaulay2/d/boostmath.dd"
  util__prepare();
  # line 98 "../../../../Macaulay2/d/boostmath.dd"
  common__prepare();
  # line 35 "../../../../Macaulay2/d/boostmath.dd"
  common_setupfun_1(str__1, inverseErf_1)->Protected = 0;
  # line 49 "../../../../Macaulay2/d/boostmath.dd"
  common_setupfun_1(str__2, regularizedGamma_1)->Protected = 0;
  # line 64 "../../../../Macaulay2/d/boostmath.dd"
  common_setupfun_1(str__3, inverseRegularizedGamma_1)->Protected = 0;
  # line 81 "../../../../Macaulay2/d/boostmath.dd"
  common_setupfun_1(str__4, regularizedBeta_1)->Protected = 0;
  # line 98 "../../../../Macaulay2/d/boostmath.dd"
  common_setupfun_1(str__5, inverseRegularizedBeta_1)->Protected = 0;
  # line 98 "../../../../Macaulay2/d/boostmath.dd"
  this_thread_prepare.func = boostmath__thread_prepare;
  # line 98 "../../../../Macaulay2/d/boostmath.dd"
  this_thread_prepare.next = thread_prepare_list;
  # line 98 "../../../../Macaulay2/d/boostmath.dd"
  thread_prepare_list = &this_thread_prepare;
  # line 98 "../../../../Macaulay2/d/boostmath.dd"
  this_final.func = boostmath__final;
  # line 98 "../../../../Macaulay2/d/boostmath.dd"
  this_final.next = final_list;
  # line 98 "../../../../Macaulay2/d/boostmath.dd"
  final_list = &this_final;
  # line 98 "../../../../Macaulay2/d/boostmath.dd"
  }
# line 98 "../../../../Macaulay2/d/boostmath.dd"
static void boostmath__thread_prepare(){
  # line 98 "../../../../Macaulay2/d/boostmath.dd"
  }
# line 98 "../../../../Macaulay2/d/boostmath.dd"
static void boostmath__final(){
  # line 98 "../../../../Macaulay2/d/boostmath.dd"
  }
