#ifndef interrupts_included
#define interrupts_included

  #include <atomic_ops.h>
  #ifndef atomic_field_decl
  #define atomic_field_decl
  /* if you change this, change the copy in ../system/supervisor.hpp, too; better yet, remove it. */
  struct atomic_field {
       AO_t field;
       };

  #define load_Field(x) AO_load(&(x).field)
  #define test_Field(x) (load_Field(x) != 0)
  #define store_Field(x,val) AO_store(&(x).field,val)
  #endif
  

#define interrupted() test_Field(THREADLOCAL(interrupts_interruptedFlag,struct atomic_field))

/* included from ../../../../Macaulay2/c/scc1.c*/

#ifdef __cplusplus
  #define BASECLASS : public our_new_delete
  #include "newdelete.hpp"
#else
  #define BASECLASS
#endif

#if defined(__cplusplus)
  extern "C" {
#endif

#ifndef SAFEC_EXPORTS
#define SAFEC_EXPORTS
#endif
#ifndef SAFEC_basic_typedefs_defined
#define SAFEC_basic_typedefs_defined
typedef char M2_bool;
struct tagged_union { unsigned short type_; };
#undef M2_basic_typedefs_defined
#endif

/* typedefs */
typedef AO_TS_VAL_t atomic_LockValue;
typedef AO_TS_t atomic_LockField;
typedef struct atomic_field atomic_atomicField;
typedef struct atomic_field * atomic_atomicFieldPointer;
typedef struct atomic_field * atomic_atomicFieldPointerOrNull;
/* array types */
/* struct types */
/* basic types */
/* functions */
extern void interrupts__prepare() __attribute__ ((constructor));
extern void interrupts_clearSteppingFlag();
extern int interrupts_microStepCount;
extern int interrupts_stepCount;
extern void interrupts_clearAlarmedFlag();
extern void interrupts_clearInterruptFlag();
extern void interrupts_setSteppingFlag();
extern void interrupts_setAlarmedFlag();
extern void interrupts_setInterruptFlag();
extern void interrupts_clearAllFlags();
extern void interrupts_clearAlarm();
extern void interrupts_determineExceptionFlag();
extern int interrupts_exceptionFlag_id;
;
extern int interrupts_interruptedFlag_id;
;
extern int interrupts_steppingFlag_id;
;
extern int interrupts_alarmedFlag_id;
;
extern int interrupts_interruptPending_id;
;
extern int interrupts_interruptShield_id;
;
extern void atomic__prepare() __attribute__ ((constructor));
extern void arithmetic__prepare() __attribute__ ((constructor));

#if defined(__cplusplus)
  }
#endif

#endif
