#include "system-exports.h"
#include "scc-core.h"
#include "../system/supervisorinterface.h"
# line 4 "../../../../Macaulay2/d/system.d"

#ifdef HAVE_SYS_TYPES_H
 #include <sys/types.h>
#endif
#ifdef HAVE_SYS_STAT_H
 #include <sys/stat.h>
#endif
#ifdef HAVE_TIME_H
 #include <time.h>
#endif
#ifdef HAVE_ASSERT_H
 #include <assert.h>
#endif
#ifdef HAVE_PTHREAD_H
 #include <pthread.h>
#endif
#ifdef HAVE_SYS_WAIT_H
 #include <sys/wait.h>
#endif

# line 52 "../../../../Macaulay2/d/system.d"
int system_sleep(int t){
  # line 52 "../../../../Macaulay2/d/system.d"
  return sleep(t);
  # line 52 "../../../../Macaulay2/d/system.d"
  }
# line 53 "../../../../Macaulay2/d/system.d"
int system_nanosleep(long t){
  # line 53 "../../../../Macaulay2/d/system.d"
  struct timespec ts_sleep; ts_sleep.tv_sec = t/1000000000; ts_sleep.tv_nsec=t%1000000000; return nanosleep(&ts_sleep, NULL);;
  # line 53 "../../../../Macaulay2/d/system.d"
  }
# line 54 "../../../../Macaulay2/d/system.d"
int system_getpid(){
  # line 54 "../../../../Macaulay2/d/system.d"
  return getpid();
  # line 54 "../../../../Macaulay2/d/system.d"
  }
# line 55 "../../../../Macaulay2/d/system.d"
int system_getpgrp(){
  # line 55 "../../../../Macaulay2/d/system.d"
  return 
     #ifdef HAVE_GETPGRP
      getpgrp()
     #else
      -1
     #endif
     ;
  # line 55 "../../../../Macaulay2/d/system.d"
  }
# line 62 "../../../../Macaulay2/d/system.d"
int system_setpgid(int pid,int pgid){
  # line 62 "../../../../Macaulay2/d/system.d"
  return 
     #ifdef HAVE_SETPGID
      setpgid(pid,pgid)
     #else
      -1
     #endif
     ;
  # line 62 "../../../../Macaulay2/d/system.d"
  }
# line 69 "../../../../Macaulay2/d/system.d"
void system_exit(int x){
  # line 69 "../../../../Macaulay2/d/system.d"
  
     extern void clean_up();
     clean_up();
     exit(x);
     ;
  # line 69 "../../../../Macaulay2/d/system.d"
  }
# line 74 "../../../../Macaulay2/d/system.d"
int system_write(int fd,M2_string buffer,int buffersize){
  # line 74 "../../../../Macaulay2/d/system.d"
  
     if ((int)buffer->len < buffersize) fatalarrayindex(buffersize-1,buffer->len,__FILE__,__LINE__,-1);
     return write(fd,buffer->array,buffersize);
     ;
  # line 74 "../../../../Macaulay2/d/system.d"
  }
# line 78 "../../../../Macaulay2/d/system.d"
int system_write_1(int fd,M2_string buffer){
  # line 78 "../../../../Macaulay2/d/system.d"
  return system_write(fd, buffer, buffer->len);
  # line 78 "../../../../Macaulay2/d/system.d"
  }
# line 79 "../../../../Macaulay2/d/system.d"
int system_write_2(int fd,M2_string buffer,int buffersize,int offset){
  # line 79 "../../../../Macaulay2/d/system.d"
  
     if (offset < 0) fatalarrayindex(offset,buffer->len,__FILE__,__LINE__,-1);
     if ((int)buffer->len < buffersize+offset) fatalarrayindex(buffersize+offset-1,buffer->len,__FILE__,__LINE__,-1);
     return write(fd,buffer->array+offset,buffersize);
     ;
  # line 79 "../../../../Macaulay2/d/system.d"
  }
# line 84 "../../../../Macaulay2/d/system.d"
int system_read(int fd,M2_string buffer,int buffersize){
  # line 84 "../../../../Macaulay2/d/system.d"
  
     if ((int)buffer->len < buffersize) fatalarrayindex(buffersize,buffer->len,__FILE__,__LINE__,-1);
     if (buffersize == 0) return 0;
     return read(fd,buffer->array,buffersize);
     ;
  # line 84 "../../../../Macaulay2/d/system.d"
  }
# line 89 "../../../../Macaulay2/d/system.d"
int system_read_1(int fd,M2_string buffer,int buffersize,int offset){
  # line 89 "../../../../Macaulay2/d/system.d"
  
     if (offset < 0) fatalarrayindex(offset,buffer->len,__FILE__,__LINE__,-1);
     if ((int)buffer->len < buffersize+offset) fatalarrayindex(buffersize+offset,buffer->len,__FILE__,__LINE__,-1);
     if (buffersize == 0) return 0;
     return read(fd,buffer->array+offset,buffersize);
     ;
  # line 89 "../../../../Macaulay2/d/system.d"
  }
# line 97 "../../../../Macaulay2/d/system.d"
int system_fchmod(int fd,int mode){
  # line 97 "../../../../Macaulay2/d/system.d"
  return 
     #ifdef HAVE_FCHMOD
      fchmod(fd,mode)
     #else
      -1
     #endif
     ;
  # line 97 "../../../../Macaulay2/d/system.d"
  }
# line 115 "../../../../Macaulay2/d/system.d"
M2_string system_strerror_1(int errnum){
  # line 115 "../../../../Macaulay2/d/system.d"
  return M2_tostring_3(strerror(errnum));
  # line 115 "../../../../Macaulay2/d/system.d"
  }
# line 118 "../../../../Macaulay2/d/system.d"
int system_pipe(M2_arrayint fildes){
  # line 118 "../../../../Macaulay2/d/system.d"
  
     #ifdef HAVE_PIPE
      assert(fildes->len == 2);
      return pipe(fildes->array);
     #else
      return -1;
     #endif
     ;
  # line 118 "../../../../Macaulay2/d/system.d"
  }
# line 133 "../../../../Macaulay2/d/system.d"
int system_wait(int pid){
  # line 133 "../../../../Macaulay2/d/system.d"
  
     #ifdef HAVE_WAITPID
      int status;
      if (waitpid(pid,&status,0) == -1) return -1;
      return status;
     #else
      return -1;
     #endif
     ;
  # line 133 "../../../../Macaulay2/d/system.d"
  }
# line 133 "../../../../Macaulay2/d/system.d"
int system_loadDepth_id;
;
# line 168 "../../../../Macaulay2/d/system.d"
int system_currentTime(){
  # line 168 "../../../../Macaulay2/d/system.d"
  return time(NULL);
  # line 168 "../../../../Macaulay2/d/system.d"
  }
# line 184 "../../../../Macaulay2/d/system.d"
void system_segmentationFault(){
  # line 184 "../../../../Macaulay2/d/system.d"
  *((int*)1)=0;
  # line 184 "../../../../Macaulay2/d/system.d"
  }
# line 184 "../../../../Macaulay2/d/system.d"
static void dummyfun(){
  # line 184 "../../../../Macaulay2/d/system.d"
  }
# line 184 "../../../../Macaulay2/d/system.d"
static everytimeCell everytimeList;
# line 191 "../../../../Macaulay2/d/system.d"
void system_everytime(void (*f)()){
  # line 191 "../../../../Macaulay2/d/system.d"
  everytimeCell tmp__2;
  # line 191 "../../../../Macaulay2/d/system.d"
  tmp__2 = (everytimeCell) GC_MALLOC(sizeof(struct everytimeCell_struct));
  if (0 == tmp__2) outofmem2((size_t)sizeof(struct everytimeCell_struct));
  # line 191 "../../../../Macaulay2/d/system.d"
  tmp__2->f = f;
  # line 191 "../../../../Macaulay2/d/system.d"
  tmp__2->next = everytimeList;
  # line 191 "../../../../Macaulay2/d/system.d"
  everytimeList = tmp__2;
  # line 191 "../../../../Macaulay2/d/system.d"
  }
# line 193 "../../../../Macaulay2/d/system.d"
void system_everytimeRun(){
  # line 193 "../../../../Macaulay2/d/system.d"
  everytimeCell x_1;
  # line 193 "../../../../Macaulay2/d/system.d"
  everytimeCell tmp__3;
  # line 193 "../../../../Macaulay2/d/system.d"
  x_1 = everytimeList;
  # line 193 "../../../../Macaulay2/d/system.d"
  L0_:;
  # line 194 "../../../../Macaulay2/d/system.d"
  if ((! (x_1->next != x_1))) goto L1_;
  # line 194 "../../../../Macaulay2/d/system.d"
  x_1->f();
  # line 194 "../../../../Macaulay2/d/system.d"
  tmp__3 = x_1->next;
  # line 194 "../../../../Macaulay2/d/system.d"
  x_1 = tmp__3;
  # line 194 "../../../../Macaulay2/d/system.d"
  goto L0_;
  # line 194 "../../../../Macaulay2/d/system.d"
  L1_:;
  # line 194 "../../../../Macaulay2/d/system.d"
  }
# line 196 "../../../../Macaulay2/d/system.d"
int system_limitFiles(int n){
  # line 196 "../../../../Macaulay2/d/system.d"
  
     #ifdef HAVE_SETRLIMIT
      struct rlimit lim;
      lim.rlim_cur = lim.rlim_max = n;
      return setrlimit(RLIMIT_NOFILE,&lim);
     #else
      return -1;
     #endif
     ;
  # line 196 "../../../../Macaulay2/d/system.d"
  }
# line 205 "../../../../Macaulay2/d/system.d"
int system_limitProcesses(int n){
  # line 205 "../../../../Macaulay2/d/system.d"
  
     #ifdef RLIMIT_NPROC
       struct rlimit lim;
       lim.rlim_cur = lim.rlim_max = n;
       return setrlimit(RLIMIT_NPROC,&lim);
     #else
       return -1;
     #endif
     ;
  # line 205 "../../../../Macaulay2/d/system.d"
  }
# line 147 "../../../../Macaulay2/d/system.d"
static void tmp_(){
  # line 147 "../../../../Macaulay2/d/system.d"
  TS_Add_ThreadLocal(&system_loadDepth_id,"system_loadDepth");
  # line 147 "../../../../Macaulay2/d/system.d"
  (*((unsigned short*)TS_Get_Local(system_loadDepth_id))) = ((unsigned short)0);
  # line 147 "../../../../Macaulay2/d/system.d"
  }
# line 147 "../../../../Macaulay2/d/system.d"
static void system__thread_prepare();
# line 147 "../../../../Macaulay2/d/system.d"
static void system__final();
# line 190 "../../../../Macaulay2/d/system.d"
void system__prepare(){
  # line 190 "../../../../Macaulay2/d/system.d"
  everytimeCell tmp__1;
  # line 190 "../../../../Macaulay2/d/system.d"
  static struct FUNCTION_CELL this_final, this_thread_prepare;
  # line 190 "../../../../Macaulay2/d/system.d"
  static int called_yet = 0;
  # line 190 "../../../../Macaulay2/d/system.d"
  if (called_yet) return; else called_yet = 1;
  # line 190 "../../../../Macaulay2/d/system.d"
  M2__prepare();
  # line 190 "../../../../Macaulay2/d/system.d"
  tmp_();
  # line 190 "../../../../Macaulay2/d/system.d"
  tmp__1 = (everytimeCell) GC_MALLOC(sizeof(struct everytimeCell_struct));
  if (0 == tmp__1) outofmem2((size_t)sizeof(struct everytimeCell_struct));
  # line 190 "../../../../Macaulay2/d/system.d"
  tmp__1->f = dummyfun;
  # line 190 "../../../../Macaulay2/d/system.d"
  tmp__1->next = tmp__1;
  # line 190 "../../../../Macaulay2/d/system.d"
  everytimeList = tmp__1;
  # line 190 "../../../../Macaulay2/d/system.d"
  this_thread_prepare.func = system__thread_prepare;
  # line 190 "../../../../Macaulay2/d/system.d"
  this_thread_prepare.next = thread_prepare_list;
  # line 190 "../../../../Macaulay2/d/system.d"
  thread_prepare_list = &this_thread_prepare;
  # line 190 "../../../../Macaulay2/d/system.d"
  this_final.func = system__final;
  # line 190 "../../../../Macaulay2/d/system.d"
  this_final.next = final_list;
  # line 190 "../../../../Macaulay2/d/system.d"
  final_list = &this_final;
  # line 190 "../../../../Macaulay2/d/system.d"
  }
# line 190 "../../../../Macaulay2/d/system.d"
static void system__thread_prepare(){
  # line 190 "../../../../Macaulay2/d/system.d"
  tmp_();
  # line 190 "../../../../Macaulay2/d/system.d"
  }
# line 190 "../../../../Macaulay2/d/system.d"
static void system__final(){
  # line 190 "../../../../Macaulay2/d/system.d"
  }
