#include "version-exports.h"
#include "scc-core.h"
#include "../system/supervisorinterface.h"
# line 15 "../../../../Macaulay2/d/version.dd"

   #include <M2/config.h>
   #include <M2/gc-include.h>
   #include <M2/math-include.h>
   #include "distributed-packages.h"

   #define stringize0(a) #a
   #define stringize(a) stringize0(a)

   const char * M2_version () { return PACKAGE_VERSION; }

   extern char timestamp[];
   static int32_t endianness_string[2] = {0x61626364,0};

   #include <boost/version.hpp>

//   #include <mpfr.h>
//   #include <mpfi.h>

   #include <memtailor.h>
   #include <mathic.h>
   #include <mathicgb.h>

   #include <frobby.h>
   #ifdef HAVE_FROBBY_VERSION
     extern const char* const frobby_version;
   #else
     namespace constants { extern const char* const version; }
     const char* const frobby_version = constants::version;
   #endif

   #include <mps/version.h>
   #ifndef MPS_MAJOR_VERSION
     #error "MPS_MAJOR_VERSION undefined"
   #endif

   #undef ASSERT
   #ifdef HAVE_SCSCP
     #include <scscp.h>
     void scscp_dummy() { SCSCP_sc_init(NULL,NULL); /* just to force linking with the library */ }
   #endif

   #include <NTL/version.h>

   #undef ASSERT

   #ifdef WITH_TBB
   #include <tbb/tbb.h>
   #endif

   #include <Eigen/Core>
   
# line 68 "../../../../Macaulay2/d/version.dd"

#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wconversion"
#include <flint/flint.h>
#pragma GCC diagnostic pop
# line 83 "../../../../Macaulay2/d/version.dd"
#include <atomic_ops.h>
# line 94 "../../../../Macaulay2/d/version.dd"
#include <fflas-ffpack/config.h>
# line 97 "../../../../Macaulay2/d/version.dd"

#pragma push_macro("PACKAGE_VERSION")
#undef PACKAGE_VERSION
#include <factory/factoryconf.h>
const char * factory_version () { return PACKAGE_VERSION; }
extern const char factoryVersion[]; /* extracted from factory's factory.h */
#pragma pop_macro("PACKAGE_VERSION")
# line 111 "../../../../Macaulay2/d/version.dd"
#include <readline/readline.h>
# line 117 "../../../../Macaulay2/d/version.dd"
#include <gdbm.h>
# line 120 "../../../../Macaulay2/d/version.dd"
extern "C" void ilaver_(int *major, int *minor, int *patch);
# line 73 "../../../../Macaulay2/d/version.dd"
static const char * gcversion(){
  # line 73 "../../../../Macaulay2/d/version.dd"
  
     static char buf[40];
     unsigned x = GC_get_version();
     unsigned major = x >> 16;
     unsigned minor = (x >> 8) & 0xff;
     unsigned micro = x & 0xff;
     if (micro == 0xff) snprintf(buf,40,"%d.%d", major, minor);
     else snprintf(buf,40,"%d.%d.%d", major, minor, micro);
     return buf;
  # line 73 "../../../../Macaulay2/d/version.dd"
  }
# line 84 "../../../../Macaulay2/d/version.dd"
static const char * atomicopsversion(){
  # line 84 "../../../../Macaulay2/d/version.dd"
  
#ifdef AO_VERSION_MICRO
     static char buf[40];
     snprintf(buf,40,"%d.%d.%d",AO_VERSION_MAJOR, AO_VERSION_MINOR, AO_VERSION_MICRO);
     return buf
#else
     return "version number not available"
#endif
;
  # line 84 "../../../../Macaulay2/d/version.dd"
  }
# line 95 "../../../../Macaulay2/d/version.dd"
static const char * ffpackVersion(){
  # line 95 "../../../../Macaulay2/d/version.dd"
  return __FFLASFFPACK_PACKAGE_VERSION;
  # line 95 "../../../../Macaulay2/d/version.dd"
  }
# line 104 "../../../../Macaulay2/d/version.dd"
static const char * factoryversion(){
  # line 104 "../../../../Macaulay2/d/version.dd"
  
     return factory_version();
     // the following way used to work, but now it gives 4.0.1 instead of 4.1.0:
     //   char const * p = strrchr(factoryVersion,' ');
     //   return p ? p+1 : factoryVersion;
     ;
  # line 104 "../../../../Macaulay2/d/version.dd"
  }
# line 112 "../../../../Macaulay2/d/version.dd"
static const char * readlineversion(){
  # line 112 "../../../../Macaulay2/d/version.dd"
  
     static char buf[8];
     snprintf(buf, 8, "%d.%d", (rl_readline_version>>8)&0xff, rl_readline_version&0xff );
     return buf;
  # line 112 "../../../../Macaulay2/d/version.dd"
  }
# line 118 "../../../../Macaulay2/d/version.dd"
static const char * gdbmversion(){
  # line 118 "../../../../Macaulay2/d/version.dd"
  return gdbm_version;
  # line 118 "../../../../Macaulay2/d/version.dd"
  }
# line 121 "../../../../Macaulay2/d/version.dd"
static const char * lapackversion(){
  # line 121 "../../../../Macaulay2/d/version.dd"
  
    int major, minor, patch;
    static char buf[40];
    ilaver_(&major, &minor, &patch);
    snprintf(buf, 40, "%d.%d.%d", major, minor, patch);
    return buf;
  # line 121 "../../../../Macaulay2/d/version.dd"
  }
# line 121 "../../../../Macaulay2/d/version.dd"
static int ic;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str_;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__1;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__2;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string compiler;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__3;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__4;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__5;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__6;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__7;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__8;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__9;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__10;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__11;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__12;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__13;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__14;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__15;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__16;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__17;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__18;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__19;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__20;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__21;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__22;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__23;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__24;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__25;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__26;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__27;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__28;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__29;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__30;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__31;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__32;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__33;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__34;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__35;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__36;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__37;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__38;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__39;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__40;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__41;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__42;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__43;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__44;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__45;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__46;
# line 121 "../../../../Macaulay2/d/version.dd"
static M2_string str__47;
# line 121 "../../../../Macaulay2/d/version.dd"
static void version__thread_prepare();
# line 121 "../../../../Macaulay2/d/version.dd"
static void version__final();
# line 137 "../../../../Macaulay2/d/version.dd"
void version__prepare(){
  # line 137 "../../../../Macaulay2/d/version.dd"
  M2_string tmp_;
  # line 137 "../../../../Macaulay2/d/version.dd"
  M2_string tmp__1;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__2;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__3;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__4;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__5;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__6;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__7;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__8;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__9;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__10;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__11;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__12;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__13;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__14;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__15;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__16;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__17;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__18;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__19;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__20;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__21;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__22;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__23;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__24;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__25;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__26;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__27;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__28;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__29;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__30;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__31;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__32;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__33;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__34;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__35;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__36;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__37;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__38;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__39;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__40;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__41;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__42;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__43;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__44;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__45;
  # line 137 "../../../../Macaulay2/d/version.dd"
  parse_Sequence tmp__46;
  # line 137 "../../../../Macaulay2/d/version.dd"
  static struct FUNCTION_CELL this_final, this_thread_prepare;
  # line 137 "../../../../Macaulay2/d/version.dd"
  static int called_yet = 0;
  # line 137 "../../../../Macaulay2/d/version.dd"
  if (called_yet) return; else called_yet = 1;
  # line 137 "../../../../Macaulay2/d/version.dd"
  str_ = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (4)*sizeof(signed char)-sizeof(signed char));
  if (0 == str_) outofmem2((size_t)sizeof(struct M2_string_struct) + (4)*sizeof(signed char)-sizeof(signed char));
  # line 137 "../../../../Macaulay2/d/version.dd"
  str_->len = 4;
  # line 137 "../../../../Macaulay2/d/version.dd"
  memcpy(str_->array, "icc ", 4);
  # line 137 "../../../../Macaulay2/d/version.dd"
  str__1 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (1)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__1) outofmem2((size_t)sizeof(struct M2_string_struct) + (1)*sizeof(signed char)-sizeof(signed char));
  # line 137 "../../../../Macaulay2/d/version.dd"
  str__1->len = 1;
  # line 140 "../../../../Macaulay2/d/version.dd"
  memcpy(str__1->array, ".", 1);
  # line 140 "../../../../Macaulay2/d/version.dd"
  str__2 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (1)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__2) outofmem2((size_t)sizeof(struct M2_string_struct) + (1)*sizeof(signed char)-sizeof(signed char));
  # line 140 "../../../../Macaulay2/d/version.dd"
  str__2->len = 1;
  # line 139 "../../../../Macaulay2/d/version.dd"
  memcpy(str__2->array, ".", 1);
  # line 139 "../../../../Macaulay2/d/version.dd"
  str__3 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (7)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__3) outofmem2((size_t)sizeof(struct M2_string_struct) + (7)*sizeof(signed char)-sizeof(signed char));
  # line 139 "../../../../Macaulay2/d/version.dd"
  str__3->len = 7;
  # line 158 "../../../../Macaulay2/d/version.dd"
  memcpy(str__3->array, "version", 7);
  # line 158 "../../../../Macaulay2/d/version.dd"
  str__4 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (7)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__4) outofmem2((size_t)sizeof(struct M2_string_struct) + (7)*sizeof(signed char)-sizeof(signed char));
  # line 158 "../../../../Macaulay2/d/version.dd"
  str__4->len = 7;
  # line 159 "../../../../Macaulay2/d/version.dd"
  memcpy(str__4->array, "VERSION", 7);
  # line 159 "../../../../Macaulay2/d/version.dd"
  str__5 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (12)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__5) outofmem2((size_t)sizeof(struct M2_string_struct) + (12)*sizeof(signed char)-sizeof(signed char));
  # line 159 "../../../../Macaulay2/d/version.dd"
  str__5->len = 12;
  # line 160 "../../../../Macaulay2/d/version.dd"
  memcpy(str__5->array, "architecture", 12);
  # line 160 "../../../../Macaulay2/d/version.dd"
  str__6 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (5)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__6) outofmem2((size_t)sizeof(struct M2_string_struct) + (5)*sizeof(signed char)-sizeof(signed char));
  # line 160 "../../../../Macaulay2/d/version.dd"
  str__6->len = 5;
  # line 161 "../../../../Macaulay2/d/version.dd"
  memcpy(str__6->array, "issue", 5);
  # line 161 "../../../../Macaulay2/d/version.dd"
  str__7 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (7)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__7) outofmem2((size_t)sizeof(struct M2_string_struct) + (7)*sizeof(signed char)-sizeof(signed char));
  # line 161 "../../../../Macaulay2/d/version.dd"
  str__7->len = 7;
  # line 162 "../../../../Macaulay2/d/version.dd"
  memcpy(str__7->array, "machine", 7);
  # line 162 "../../../../Macaulay2/d/version.dd"
  str__8 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (16)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__8) outofmem2((size_t)sizeof(struct M2_string_struct) + (16)*sizeof(signed char)-sizeof(signed char));
  # line 162 "../../../../Macaulay2/d/version.dd"
  str__8->len = 16;
  # line 163 "../../../../Macaulay2/d/version.dd"
  memcpy(str__8->array, "operating system", 16);
  # line 163 "../../../../Macaulay2/d/version.dd"
  str__9 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (24)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__9) outofmem2((size_t)sizeof(struct M2_string_struct) + (24)*sizeof(signed char)-sizeof(signed char));
  # line 163 "../../../../Macaulay2/d/version.dd"
  str__9->len = 24;
  # line 164 "../../../../Macaulay2/d/version.dd"
  memcpy(str__9->array, "operating system release", 24);
  # line 164 "../../../../Macaulay2/d/version.dd"
  str__10 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (8)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__10) outofmem2((size_t)sizeof(struct M2_string_struct) + (8)*sizeof(signed char)-sizeof(signed char));
  # line 164 "../../../../Macaulay2/d/version.dd"
  str__10->len = 8;
  # line 165 "../../../../Macaulay2/d/version.dd"
  memcpy(str__10->array, "compiler", 8);
  # line 165 "../../../../Macaulay2/d/version.dd"
  str__11 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (19)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__11) outofmem2((size_t)sizeof(struct M2_string_struct) + (19)*sizeof(signed char)-sizeof(signed char));
  # line 165 "../../../../Macaulay2/d/version.dd"
  str__11->len = 19;
  # line 166 "../../../../Macaulay2/d/version.dd"
  memcpy(str__11->array, "configure arguments", 19);
  # line 166 "../../../../Macaulay2/d/version.dd"
  str__12 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (12)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__12) outofmem2((size_t)sizeof(struct M2_string_struct) + (12)*sizeof(signed char)-sizeof(signed char));
  # line 166 "../../../../Macaulay2/d/version.dd"
  str__12->len = 12;
  # line 167 "../../../../Macaulay2/d/version.dd"
  memcpy(str__12->array, "compile time", 12);
  # line 167 "../../../../Macaulay2/d/version.dd"
  str__13 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (17)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__13) outofmem2((size_t)sizeof(struct M2_string_struct) + (17)*sizeof(signed char)-sizeof(signed char));
  # line 167 "../../../../Macaulay2/d/version.dd"
  str__13->len = 17;
  # line 168 "../../../../Macaulay2/d/version.dd"
  memcpy(str__13->array, "compile node name", 17);
  # line 168 "../../../../Macaulay2/d/version.dd"
  str__14 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (18)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__14) outofmem2((size_t)sizeof(struct M2_string_struct) + (18)*sizeof(signed char)-sizeof(signed char));
  # line 168 "../../../../Macaulay2/d/version.dd"
  str__14->len = 18;
  # line 169 "../../../../Macaulay2/d/version.dd"
  memcpy(str__14->array, "atomic_ops version", 18);
  # line 169 "../../../../Macaulay2/d/version.dd"
  str__15 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (10)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__15) outofmem2((size_t)sizeof(struct M2_string_struct) + (10)*sizeof(signed char)-sizeof(signed char));
  # line 169 "../../../../Macaulay2/d/version.dd"
  str__15->len = 10;
  # line 170 "../../../../Macaulay2/d/version.dd"
  memcpy(str__15->array, "gc version", 10);
  # line 170 "../../../../Macaulay2/d/version.dd"
  str__16 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (13)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__16) outofmem2((size_t)sizeof(struct M2_string_struct) + (13)*sizeof(signed char)-sizeof(signed char));
  # line 170 "../../../../Macaulay2/d/version.dd"
  str__16->len = 13;
  # line 171 "../../../../Macaulay2/d/version.dd"
  memcpy(str__16->array, "mysql version", 13);
  # line 171 "../../../../Macaulay2/d/version.dd"
  str__17 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (20)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__17) outofmem2((size_t)sizeof(struct M2_string_struct) + (20)*sizeof(signed char)-sizeof(signed char));
  # line 171 "../../../../Macaulay2/d/version.dd"
  str__17->len = 20;
  # line 178 "../../../../Macaulay2/d/version.dd"
  memcpy(str__17->array, "fflas_ffpack version", 20);
  # line 178 "../../../../Macaulay2/d/version.dd"
  str__18 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__18) outofmem2((size_t)sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  # line 178 "../../../../Macaulay2/d/version.dd"
  str__18->len = 15;
  # line 179 "../../../../Macaulay2/d/version.dd"
  memcpy(str__18->array, "mpsolve version", 15);
  # line 179 "../../../../Macaulay2/d/version.dd"
  str__19 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__19) outofmem2((size_t)sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  # line 179 "../../../../Macaulay2/d/version.dd"
  str__19->len = 14;
  # line 180 "../../../../Macaulay2/d/version.dd"
  memcpy(str__19->array, "python version", 14);
  # line 180 "../../../../Macaulay2/d/version.dd"
  str__20 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (12)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__20) outofmem2((size_t)sizeof(struct M2_string_struct) + (12)*sizeof(signed char)-sizeof(signed char));
  # line 180 "../../../../Macaulay2/d/version.dd"
  str__20->len = 12;
  # line 187 "../../../../Macaulay2/d/version.dd"
  memcpy(str__20->array, "gdbm version", 12);
  # line 187 "../../../../Macaulay2/d/version.dd"
  str__21 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (11)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__21) outofmem2((size_t)sizeof(struct M2_string_struct) + (11)*sizeof(signed char)-sizeof(signed char));
  # line 187 "../../../../Macaulay2/d/version.dd"
  str__21->len = 11;
  # line 188 "../../../../Macaulay2/d/version.dd"
  memcpy(str__21->array, "gmp version", 11);
  # line 188 "../../../../Macaulay2/d/version.dd"
  str__22 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (12)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__22) outofmem2((size_t)sizeof(struct M2_string_struct) + (12)*sizeof(signed char)-sizeof(signed char));
  # line 188 "../../../../Macaulay2/d/version.dd"
  str__22->len = 12;
  # line 195 "../../../../Macaulay2/d/version.dd"
  memcpy(str__22->array, "mpir version", 12);
  # line 195 "../../../../Macaulay2/d/version.dd"
  str__23 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (11)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__23) outofmem2((size_t)sizeof(struct M2_string_struct) + (11)*sizeof(signed char)-sizeof(signed char));
  # line 195 "../../../../Macaulay2/d/version.dd"
  str__23->len = 11;
  # line 202 "../../../../Macaulay2/d/version.dd"
  memcpy(str__23->array, "ntl version", 11);
  # line 202 "../../../../Macaulay2/d/version.dd"
  str__24 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__24) outofmem2((size_t)sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  # line 202 "../../../../Macaulay2/d/version.dd"
  str__24->len = 14;
  # line 203 "../../../../Macaulay2/d/version.dd"
  memcpy(str__24->array, "frobby version", 14);
  # line 203 "../../../../Macaulay2/d/version.dd"
  str__25 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (13)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__25) outofmem2((size_t)sizeof(struct M2_string_struct) + (13)*sizeof(signed char)-sizeof(signed char));
  # line 203 "../../../../Macaulay2/d/version.dd"
  str__25->len = 13;
  # line 204 "../../../../Macaulay2/d/version.dd"
  memcpy(str__25->array, "flint version", 13);
  # line 204 "../../../../Macaulay2/d/version.dd"
  str__26 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (13)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__26) outofmem2((size_t)sizeof(struct M2_string_struct) + (13)*sizeof(signed char)-sizeof(signed char));
  # line 204 "../../../../Macaulay2/d/version.dd"
  str__26->len = 13;
  # line 205 "../../../../Macaulay2/d/version.dd"
  memcpy(str__26->array, "scscp version", 13);
  # line 205 "../../../../Macaulay2/d/version.dd"
  str__27 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (13)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__27) outofmem2((size_t)sizeof(struct M2_string_struct) + (13)*sizeof(signed char)-sizeof(signed char));
  # line 205 "../../../../Macaulay2/d/version.dd"
  str__27->len = 13;
  # line 212 "../../../../Macaulay2/d/version.dd"
  memcpy(str__27->array, "boost version", 13);
  # line 212 "../../../../Macaulay2/d/version.dd"
  str__28 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (17)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__28) outofmem2((size_t)sizeof(struct M2_string_struct) + (17)*sizeof(signed char)-sizeof(signed char));
  # line 212 "../../../../Macaulay2/d/version.dd"
  str__28->len = 17;
  # line 213 "../../../../Macaulay2/d/version.dd"
  memcpy(str__28->array, "memtailor version", 17);
  # line 213 "../../../../Macaulay2/d/version.dd"
  str__29 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__29) outofmem2((size_t)sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  # line 213 "../../../../Macaulay2/d/version.dd"
  str__29->len = 14;
  # line 214 "../../../../Macaulay2/d/version.dd"
  memcpy(str__29->array, "mathic version", 14);
  # line 214 "../../../../Macaulay2/d/version.dd"
  str__30 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (16)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__30) outofmem2((size_t)sizeof(struct M2_string_struct) + (16)*sizeof(signed char)-sizeof(signed char));
  # line 214 "../../../../Macaulay2/d/version.dd"
  str__30->len = 16;
  # line 215 "../../../../Macaulay2/d/version.dd"
  memcpy(str__30->array, "mathicgb version", 16);
  # line 215 "../../../../Macaulay2/d/version.dd"
  str__31 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__31) outofmem2((size_t)sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  # line 215 "../../../../Macaulay2/d/version.dd"
  str__31->len = 15;
  # line 216 "../../../../Macaulay2/d/version.dd"
  memcpy(str__31->array, "factory version", 15);
  # line 216 "../../../../Macaulay2/d/version.dd"
  str__32 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (16)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__32) outofmem2((size_t)sizeof(struct M2_string_struct) + (16)*sizeof(signed char)-sizeof(signed char));
  # line 216 "../../../../Macaulay2/d/version.dd"
  str__32->len = 16;
  # line 217 "../../../../Macaulay2/d/version.dd"
  memcpy(str__32->array, "readline version", 16);
  # line 217 "../../../../Macaulay2/d/version.dd"
  str__33 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (12)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__33) outofmem2((size_t)sizeof(struct M2_string_struct) + (12)*sizeof(signed char)-sizeof(signed char));
  # line 217 "../../../../Macaulay2/d/version.dd"
  str__33->len = 12;
  # line 218 "../../../../Macaulay2/d/version.dd"
  memcpy(str__33->array, "mpfr version", 12);
  # line 218 "../../../../Macaulay2/d/version.dd"
  str__34 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (12)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__34) outofmem2((size_t)sizeof(struct M2_string_struct) + (12)*sizeof(signed char)-sizeof(signed char));
  # line 218 "../../../../Macaulay2/d/version.dd"
  str__34->len = 12;
  # line 219 "../../../../Macaulay2/d/version.dd"
  memcpy(str__34->array, "mpfi version", 12);
  # line 219 "../../../../Macaulay2/d/version.dd"
  str__35 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (11)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__35) outofmem2((size_t)sizeof(struct M2_string_struct) + (11)*sizeof(signed char)-sizeof(signed char));
  # line 219 "../../../../Macaulay2/d/version.dd"
  str__35->len = 11;
  # line 220 "../../../../Macaulay2/d/version.dd"
  memcpy(str__35->array, "tbb version", 11);
  # line 220 "../../../../Macaulay2/d/version.dd"
  str__36 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__36) outofmem2((size_t)sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  # line 220 "../../../../Macaulay2/d/version.dd"
  str__36->len = 14;
  # line 227 "../../../../Macaulay2/d/version.dd"
  memcpy(str__36->array, "lapack version", 14);
  # line 227 "../../../../Macaulay2/d/version.dd"
  str__37 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (13)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__37) outofmem2((size_t)sizeof(struct M2_string_struct) + (13)*sizeof(signed char)-sizeof(signed char));
  # line 227 "../../../../Macaulay2/d/version.dd"
  str__37->len = 13;
  # line 228 "../../../../Macaulay2/d/version.dd"
  memcpy(str__37->array, "eigen version", 13);
  # line 228 "../../../../Macaulay2/d/version.dd"
  str__38 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__38) outofmem2((size_t)sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  # line 228 "../../../../Macaulay2/d/version.dd"
  str__38->len = 14;
  # line 232 "../../../../Macaulay2/d/version.dd"
  memcpy(str__38->array, "libffi version", 14);
  # line 232 "../../../../Macaulay2/d/version.dd"
  str__39 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (9)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__39) outofmem2((size_t)sizeof(struct M2_string_struct) + (9)*sizeof(signed char)-sizeof(signed char));
  # line 232 "../../../../Macaulay2/d/version.dd"
  str__39->len = 9;
  # line 233 "../../../../Macaulay2/d/version.dd"
  memcpy(str__39->array, "M2 suffix", 9);
  # line 233 "../../../../Macaulay2/d/version.dd"
  str__40 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (20)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__40) outofmem2((size_t)sizeof(struct M2_string_struct) + (20)*sizeof(signed char)-sizeof(signed char));
  # line 233 "../../../../Macaulay2/d/version.dd"
  str__40->len = 20;
  # line 234 "../../../../Macaulay2/d/version.dd"
  memcpy(str__40->array, "executable extension", 20);
  # line 234 "../../../../Macaulay2/d/version.dd"
  str__41 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (7)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__41) outofmem2((size_t)sizeof(struct M2_string_struct) + (7)*sizeof(signed char)-sizeof(signed char));
  # line 234 "../../../../Macaulay2/d/version.dd"
  str__41->len = 7;
  # line 235 "../../../../Macaulay2/d/version.dd"
  memcpy(str__41->array, "M2 name", 7);
  # line 235 "../../../../Macaulay2/d/version.dd"
  str__42 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (10)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__42) outofmem2((size_t)sizeof(struct M2_string_struct) + (10)*sizeof(signed char)-sizeof(signed char));
  # line 235 "../../../../Macaulay2/d/version.dd"
  str__42->len = 10;
  # line 236 "../../../../Macaulay2/d/version.dd"
  memcpy(str__42->array, "endianness", 10);
  # line 236 "../../../../Macaulay2/d/version.dd"
  str__43 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (12)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__43) outofmem2((size_t)sizeof(struct M2_string_struct) + (12)*sizeof(signed char)-sizeof(signed char));
  # line 236 "../../../../Macaulay2/d/version.dd"
  str__43->len = 12;
  # line 237 "../../../../Macaulay2/d/version.dd"
  memcpy(str__43->array, "pointer size", 12);
  # line 237 "../../../../Macaulay2/d/version.dd"
  str__44 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (8)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__44) outofmem2((size_t)sizeof(struct M2_string_struct) + (8)*sizeof(signed char)-sizeof(signed char));
  # line 237 "../../../../Macaulay2/d/version.dd"
  str__44->len = 8;
  # line 238 "../../../../Macaulay2/d/version.dd"
  memcpy(str__44->array, "packages", 8);
  # line 238 "../../../../Macaulay2/d/version.dd"
  str__45 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (5)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__45) outofmem2((size_t)sizeof(struct M2_string_struct) + (5)*sizeof(signed char)-sizeof(signed char));
  # line 238 "../../../../Macaulay2/d/version.dd"
  str__45->len = 5;
  # line 239 "../../../../Macaulay2/d/version.dd"
  memcpy(str__45->array, "build", 5);
  # line 239 "../../../../Macaulay2/d/version.dd"
  str__46 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (4)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__46) outofmem2((size_t)sizeof(struct M2_string_struct) + (4)*sizeof(signed char)-sizeof(signed char));
  # line 239 "../../../../Macaulay2/d/version.dd"
  str__46->len = 4;
  # line 240 "../../../../Macaulay2/d/version.dd"
  memcpy(str__46->array, "host", 4);
  # line 240 "../../../../Macaulay2/d/version.dd"
  str__47 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__47) outofmem2((size_t)sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  # line 240 "../../../../Macaulay2/d/version.dd"
  str__47->len = 15;
  # line 241 "../../../../Macaulay2/d/version.dd"
  memcpy(str__47->array, "git description", 15);
  # line 241 "../../../../Macaulay2/d/version.dd"
  M2__prepare();
  # line 241 "../../../../Macaulay2/d/version.dd"
  hashtables__prepare();
  # line 128 "../../../../Macaulay2/d/version.dd"
  ic = 
     #if defined(__INTEL_COMPILER)
     	  __INTEL_COMPILER
     #else
     	  0
     #endif
     ;
  # line 136 "../../../../Macaulay2/d/version.dd"
  if ((ic != 0)) goto L0_;
  # line 142 "../../../../Macaulay2/d/version.dd"
  tmp_ = M2_tostring_3(
	    #ifdef __clang__
	        "clang " __clang_version__
	    #else
	    #if defined(__GNUC__)
	    #ifdef __GNUC_PATCHLEVEL__
		 "gcc " stringize(__GNUC__) "." stringize(__GNUC_MINOR__) "." stringize(__GNUC_PATCHLEVEL__)
	    #else
		 "gcc " stringize(__GNUC__) "." stringize(__GNUC_MINOR__)
	    #endif
	    #else
	    "unknown"
	    #endif
	    #endif
	    );
  # line 142 "../../../../Macaulay2/d/version.dd"
  goto L1_;
  # line 142 "../../../../Macaulay2/d/version.dd"
  L0_:;
  # line 138 "../../../../Macaulay2/d/version.dd"
  if (((ic % 10) == 0)) goto L2_;
  # line 140 "../../../../Macaulay2/d/version.dd"
  tmp__1 = strings_plus_(strings_plus_(strings1_tostring_2((ic / 100)), str__1), strings1_tostring_2((ic % 100)));
  # line 140 "../../../../Macaulay2/d/version.dd"
  goto L3_;
  # line 140 "../../../../Macaulay2/d/version.dd"
  L2_:;
  # line 139 "../../../../Macaulay2/d/version.dd"
  tmp__1 = strings_plus_(strings_plus_(strings1_tostring_2((ic / 100)), str__2), strings1_tostring_2(((ic / 10) % 10)));
  # line 139 "../../../../Macaulay2/d/version.dd"
  L3_:;
  # line 137 "../../../../Macaulay2/d/version.dd"
  tmp_ = strings_plus_(str_, tmp__1);
  # line 137 "../../../../Macaulay2/d/version.dd"
  L1_:;
  # line 137 "../../../../Macaulay2/d/version.dd"
  compiler = tmp_;
  # line 137 "../../../../Macaulay2/d/version.dd"
  tmp__2 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__2) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 137 "../../../../Macaulay2/d/version.dd"
  tmp__2->type_ = 7;
  # line 137 "../../../../Macaulay2/d/version.dd"
  tmp__2->len = 2;
  # line 59 "hashtables.sig"
  tmp__2->array[0] = util_toExpr_12(str__4);
  # line 62 "hashtables.sig"
  tmp__2->array[1] = util_toExpr_12(M2_tostring_3(M2_version()));
  # line 63 "hashtables.sig"
  tmp__3 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__3) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__3->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__3->len = 2;
  # line 59 "hashtables.sig"
  tmp__3->array[0] = util_toExpr_12(str__5);
  # line 62 "hashtables.sig"
  tmp__3->array[1] = util_toExpr_12(M2_tostring_3(ARCH));
  # line 63 "hashtables.sig"
  tmp__4 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__4) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__4->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__4->len = 2;
  # line 59 "hashtables.sig"
  tmp__4->array[0] = util_toExpr_12(str__6);
  # line 62 "hashtables.sig"
  tmp__4->array[1] = util_toExpr_12(M2_tostring_3(ISSUE));
  # line 63 "hashtables.sig"
  tmp__5 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__5) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__5->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__5->len = 2;
  # line 59 "hashtables.sig"
  tmp__5->array[0] = util_toExpr_12(str__7);
  # line 62 "hashtables.sig"
  tmp__5->array[1] = util_toExpr_12(M2_tostring_3(MACHINE));
  # line 63 "hashtables.sig"
  tmp__6 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__6) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__6->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__6->len = 2;
  # line 59 "hashtables.sig"
  tmp__6->array[0] = util_toExpr_12(str__8);
  # line 62 "hashtables.sig"
  tmp__6->array[1] = util_toExpr_12(M2_tostring_3(OS));
  # line 63 "hashtables.sig"
  tmp__7 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__7) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__7->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__7->len = 2;
  # line 59 "hashtables.sig"
  tmp__7->array[0] = util_toExpr_12(str__9);
  # line 62 "hashtables.sig"
  tmp__7->array[1] = util_toExpr_12(M2_tostring_3(REL));
  # line 63 "hashtables.sig"
  tmp__8 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__8) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__8->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__8->len = 2;
  # line 59 "hashtables.sig"
  tmp__8->array[0] = util_toExpr_12(str__10);
  # line 62 "hashtables.sig"
  tmp__8->array[1] = util_toExpr_12(compiler);
  # line 62 "hashtables.sig"
  tmp__9 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__9) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 62 "hashtables.sig"
  tmp__9->type_ = 7;
  # line 62 "hashtables.sig"
  tmp__9->len = 2;
  # line 59 "hashtables.sig"
  tmp__9->array[0] = util_toExpr_12(str__11);
  # line 62 "hashtables.sig"
  tmp__9->array[1] = util_toExpr_12(M2_tostring_3(CONFIG_ARGS));
  # line 63 "hashtables.sig"
  tmp__10 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__10) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__10->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__10->len = 2;
  # line 59 "hashtables.sig"
  tmp__10->array[0] = util_toExpr_12(str__12);
  # line 62 "hashtables.sig"
  tmp__10->array[1] = util_toExpr_12(M2_tostring_3(timestamp));
  # line 63 "hashtables.sig"
  tmp__11 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__11) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__11->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__11->len = 2;
  # line 59 "hashtables.sig"
  tmp__11->array[0] = util_toExpr_12(str__13);
  # line 62 "hashtables.sig"
  tmp__11->array[1] = util_toExpr_12(M2_tostring_3(NODENAME));
  # line 63 "hashtables.sig"
  tmp__12 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__12) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__12->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__12->len = 2;
  # line 59 "hashtables.sig"
  tmp__12->array[0] = util_toExpr_12(str__14);
  # line 62 "hashtables.sig"
  tmp__12->array[1] = util_toExpr_12(M2_tostring_3(atomicopsversion()));
  # line 169 "../../../../Macaulay2/d/version.dd"
  tmp__13 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__13) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 169 "../../../../Macaulay2/d/version.dd"
  tmp__13->type_ = 7;
  # line 169 "../../../../Macaulay2/d/version.dd"
  tmp__13->len = 2;
  # line 59 "hashtables.sig"
  tmp__13->array[0] = util_toExpr_12(str__15);
  # line 62 "hashtables.sig"
  tmp__13->array[1] = util_toExpr_12(M2_tostring_3(gcversion()));
  # line 170 "../../../../Macaulay2/d/version.dd"
  tmp__14 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__14) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 170 "../../../../Macaulay2/d/version.dd"
  tmp__14->type_ = 7;
  # line 170 "../../../../Macaulay2/d/version.dd"
  tmp__14->len = 2;
  # line 59 "hashtables.sig"
  tmp__14->array[0] = util_toExpr_12(str__16);
  # line 62 "hashtables.sig"
  tmp__14->array[1] = util_toExpr_12(M2_tostring_3(
	  #if WITH_MYSQL
		   mysql_get_client_info()
	  #else
		   "not present"
	  #endif
	  ));
  # line 63 "hashtables.sig"
  tmp__15 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__15) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__15->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__15->len = 2;
  # line 59 "hashtables.sig"
  tmp__15->array[0] = util_toExpr_12(str__17);
  # line 62 "hashtables.sig"
  tmp__15->array[1] = util_toExpr_12(M2_tostring_3(ffpackVersion()));
  # line 178 "../../../../Macaulay2/d/version.dd"
  tmp__16 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__16) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 178 "../../../../Macaulay2/d/version.dd"
  tmp__16->type_ = 7;
  # line 178 "../../../../Macaulay2/d/version.dd"
  tmp__16->len = 2;
  # line 59 "hashtables.sig"
  tmp__16->array[0] = util_toExpr_12(str__18);
  # line 62 "hashtables.sig"
  tmp__16->array[1] = util_toExpr_12(M2_tostring_3(stringize(MPS_MAJOR_VERSION) "." stringize(MPS_MINOR_VERSION) "." stringize(MPS_PATCH_VERSION)));
  # line 63 "hashtables.sig"
  tmp__17 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__17) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__17->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__17->len = 2;
  # line 59 "hashtables.sig"
  tmp__17->array[0] = util_toExpr_12(str__19);
  # line 62 "hashtables.sig"
  tmp__17->array[1] = util_toExpr_12(M2_tostring_3(
	#ifdef WITH_PYTHON
		 PY_VERSION
	#else
		 "not present"
	#endif
	));
  # line 63 "hashtables.sig"
  tmp__18 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__18) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__18->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__18->len = 2;
  # line 59 "hashtables.sig"
  tmp__18->array[0] = util_toExpr_12(str__20);
  # line 62 "hashtables.sig"
  tmp__18->array[1] = util_toExpr_12(M2_tostring_3(gdbmversion()));
  # line 187 "../../../../Macaulay2/d/version.dd"
  tmp__19 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__19) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 187 "../../../../Macaulay2/d/version.dd"
  tmp__19->type_ = 7;
  # line 187 "../../../../Macaulay2/d/version.dd"
  tmp__19->len = 2;
  # line 59 "hashtables.sig"
  tmp__19->array[0] = util_toExpr_12(str__21);
  # line 62 "hashtables.sig"
  tmp__19->array[1] = util_toExpr_12(M2_tostring_3(
	  #if USING_MPIR
	       "not present"
	  #else
	       __gmp_version
	  #endif
	  ));
  # line 63 "hashtables.sig"
  tmp__20 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__20) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__20->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__20->len = 2;
  # line 59 "hashtables.sig"
  tmp__20->array[0] = util_toExpr_12(str__22);
  # line 62 "hashtables.sig"
  tmp__20->array[1] = util_toExpr_12(M2_tostring_3(
	#if USING_MPIR
	     __mpir_version
	#else
	     "not present"
	#endif
	));
  # line 63 "hashtables.sig"
  tmp__21 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__21) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__21->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__21->len = 2;
  # line 59 "hashtables.sig"
  tmp__21->array[0] = util_toExpr_12(str__23);
  # line 62 "hashtables.sig"
  tmp__21->array[1] = util_toExpr_12(M2_tostring_3(NTL_VERSION));
  # line 63 "hashtables.sig"
  tmp__22 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__22) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__22->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__22->len = 2;
  # line 59 "hashtables.sig"
  tmp__22->array[0] = util_toExpr_12(str__24);
  # line 62 "hashtables.sig"
  tmp__22->array[1] = util_toExpr_12(M2_tostring_3(frobby_version));
  # line 63 "hashtables.sig"
  tmp__23 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__23) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__23->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__23->len = 2;
  # line 59 "hashtables.sig"
  tmp__23->array[0] = util_toExpr_12(str__25);
  # line 62 "hashtables.sig"
  tmp__23->array[1] = util_toExpr_12(M2_tostring_3(flint_version));
  # line 63 "hashtables.sig"
  tmp__24 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__24) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__24->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__24->len = 2;
  # line 59 "hashtables.sig"
  tmp__24->array[0] = util_toExpr_12(str__26);
  # line 62 "hashtables.sig"
  tmp__24->array[1] = util_toExpr_12(M2_tostring_3(
	 #ifdef HAVE_SCSCP
	   stringize(SCSCP_VERSION_MAJOR) "." stringize(SCSCP_VERSION_MINOR) "." stringize(SCSCP_VERSION_PATCH)
	 #else
	   "not present"
	 #endif
	 ));
  # line 63 "hashtables.sig"
  tmp__25 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__25) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__25->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__25->len = 2;
  # line 59 "hashtables.sig"
  tmp__25->array[0] = util_toExpr_12(str__27);
  # line 62 "hashtables.sig"
  tmp__25->array[1] = util_toExpr_12(M2_tostring_3(BOOST_LIB_VERSION));
  # line 63 "hashtables.sig"
  tmp__26 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__26) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__26->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__26->len = 2;
  # line 59 "hashtables.sig"
  tmp__26->array[0] = util_toExpr_12(str__28);
  # line 62 "hashtables.sig"
  tmp__26->array[1] = util_toExpr_12(M2_tostring_3(MEMTAILOR_VERSION_STRING));
  # line 63 "hashtables.sig"
  tmp__27 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__27) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__27->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__27->len = 2;
  # line 59 "hashtables.sig"
  tmp__27->array[0] = util_toExpr_12(str__29);
  # line 62 "hashtables.sig"
  tmp__27->array[1] = util_toExpr_12(M2_tostring_3(MATHIC_VERSION_STRING));
  # line 63 "hashtables.sig"
  tmp__28 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__28) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__28->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__28->len = 2;
  # line 59 "hashtables.sig"
  tmp__28->array[0] = util_toExpr_12(str__30);
  # line 62 "hashtables.sig"
  tmp__28->array[1] = util_toExpr_12(M2_tostring_3(MATHICGB_VERSION_STRING));
  # line 63 "hashtables.sig"
  tmp__29 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__29) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__29->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__29->len = 2;
  # line 59 "hashtables.sig"
  tmp__29->array[0] = util_toExpr_12(str__31);
  # line 62 "hashtables.sig"
  tmp__29->array[1] = util_toExpr_12(M2_tostring_3(factoryversion()));
  # line 216 "../../../../Macaulay2/d/version.dd"
  tmp__30 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__30) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 216 "../../../../Macaulay2/d/version.dd"
  tmp__30->type_ = 7;
  # line 216 "../../../../Macaulay2/d/version.dd"
  tmp__30->len = 2;
  # line 59 "hashtables.sig"
  tmp__30->array[0] = util_toExpr_12(str__32);
  # line 62 "hashtables.sig"
  tmp__30->array[1] = util_toExpr_12(M2_tostring_3(readlineversion()));
  # line 217 "../../../../Macaulay2/d/version.dd"
  tmp__31 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__31) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 217 "../../../../Macaulay2/d/version.dd"
  tmp__31->type_ = 7;
  # line 217 "../../../../Macaulay2/d/version.dd"
  tmp__31->len = 2;
  # line 59 "hashtables.sig"
  tmp__31->array[0] = util_toExpr_12(str__33);
  # line 62 "hashtables.sig"
  tmp__31->array[1] = util_toExpr_12(M2_tostring_3(MPFR_VERSION_STRING));
  # line 63 "hashtables.sig"
  tmp__32 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__32) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__32->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__32->len = 2;
  # line 59 "hashtables.sig"
  tmp__32->array[0] = util_toExpr_12(str__34);
  # line 62 "hashtables.sig"
  tmp__32->array[1] = util_toExpr_12(M2_tostring_3(MPFI_VERSION_STRING));
  # line 63 "hashtables.sig"
  tmp__33 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__33) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__33->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__33->len = 2;
  # line 59 "hashtables.sig"
  tmp__33->array[0] = util_toExpr_12(str__35);
  # line 62 "hashtables.sig"
  tmp__33->array[1] = util_toExpr_12(M2_tostring_3(
	 #ifdef WITH_TBB
	   stringize(TBB_VERSION_MAJOR) "." stringize(TBB_VERSION_MINOR)
	 #else
	   "not present"
	 #endif
	 ));
  # line 63 "hashtables.sig"
  tmp__34 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__34) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__34->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__34->len = 2;
  # line 59 "hashtables.sig"
  tmp__34->array[0] = util_toExpr_12(str__36);
  # line 62 "hashtables.sig"
  tmp__34->array[1] = util_toExpr_12(M2_tostring_3(lapackversion()));
  # line 227 "../../../../Macaulay2/d/version.dd"
  tmp__35 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__35) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 227 "../../../../Macaulay2/d/version.dd"
  tmp__35->type_ = 7;
  # line 227 "../../../../Macaulay2/d/version.dd"
  tmp__35->len = 2;
  # line 59 "hashtables.sig"
  tmp__35->array[0] = util_toExpr_12(str__37);
  # line 62 "hashtables.sig"
  tmp__35->array[1] = util_toExpr_12(M2_tostring_3(
       stringize(EIGEN_WORLD_VERSION) "."
       stringize(EIGEN_MAJOR_VERSION) "."
       stringize(EIGEN_MINOR_VERSION)));
  # line 63 "hashtables.sig"
  tmp__36 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__36) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__36->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__36->len = 2;
  # line 59 "hashtables.sig"
  tmp__36->array[0] = util_toExpr_12(str__38);
  # line 62 "hashtables.sig"
  tmp__36->array[1] = util_toExpr_12(M2_tostring_3(LIBFFI_VERSION));
  # line 63 "hashtables.sig"
  tmp__37 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__37) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__37->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__37->len = 2;
  # line 59 "hashtables.sig"
  tmp__37->array[0] = util_toExpr_12(str__39);
  # line 62 "hashtables.sig"
  tmp__37->array[1] = util_toExpr_12(M2_tostring_3(M2SUFFIX));
  # line 63 "hashtables.sig"
  tmp__38 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__38) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__38->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__38->len = 2;
  # line 59 "hashtables.sig"
  tmp__38->array[0] = util_toExpr_12(str__40);
  # line 62 "hashtables.sig"
  tmp__38->array[1] = util_toExpr_12(M2_tostring_3(EXEEXT));
  # line 63 "hashtables.sig"
  tmp__39 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__39) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__39->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__39->len = 2;
  # line 59 "hashtables.sig"
  tmp__39->array[0] = util_toExpr_12(str__41);
  # line 62 "hashtables.sig"
  tmp__39->array[1] = util_toExpr_12(M2_tostring_3( "M2" M2SUFFIX EXEEXT ));
  # line 63 "hashtables.sig"
  tmp__40 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__40) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__40->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__40->len = 2;
  # line 59 "hashtables.sig"
  tmp__40->array[0] = util_toExpr_12(str__42);
  # line 62 "hashtables.sig"
  tmp__40->array[1] = util_toExpr_12(M2_tostring_3((char *)endianness_string));
  # line 63 "hashtables.sig"
  tmp__41 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__41) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__41->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__41->len = 2;
  # line 59 "hashtables.sig"
  tmp__41->array[0] = util_toExpr_12(str__43);
  # line 60 "hashtables.sig"
  tmp__41->array[1] = util_toExpr(sizeof(void *));
  # line 60 "hashtables.sig"
  tmp__42 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__42) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 60 "hashtables.sig"
  tmp__42->type_ = 7;
  # line 60 "hashtables.sig"
  tmp__42->len = 2;
  # line 59 "hashtables.sig"
  tmp__42->array[0] = util_toExpr_12(str__44);
  # line 62 "hashtables.sig"
  tmp__42->array[1] = util_toExpr_12(M2_tostring_3(DISTRIBUTED_PACKAGES));
  # line 63 "hashtables.sig"
  tmp__43 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__43) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__43->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__43->len = 2;
  # line 59 "hashtables.sig"
  tmp__43->array[0] = util_toExpr_12(str__45);
  # line 62 "hashtables.sig"
  tmp__43->array[1] = util_toExpr_12(M2_tostring_3(buildsystemtype));
  # line 63 "hashtables.sig"
  tmp__44 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__44) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__44->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__44->len = 2;
  # line 59 "hashtables.sig"
  tmp__44->array[0] = util_toExpr_12(str__46);
  # line 62 "hashtables.sig"
  tmp__44->array[1] = util_toExpr_12(M2_tostring_3(hostsystemtype));
  # line 63 "hashtables.sig"
  tmp__45 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__45) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (2)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__45->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__45->len = 2;
  # line 59 "hashtables.sig"
  tmp__45->array[0] = util_toExpr_12(str__47);
  # line 62 "hashtables.sig"
  tmp__45->array[1] = util_toExpr_12(M2_tostring_3(GIT_DESCRIPTION));
  # line 63 "hashtables.sig"
  tmp__46 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (44)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__46) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (44)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 63 "hashtables.sig"
  tmp__46->type_ = 7;
  # line 63 "hashtables.sig"
  tmp__46->len = 44;
  # line 159 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[0] = ((parse_Expr)tmp__2);
  # line 160 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[1] = ((parse_Expr)tmp__3);
  # line 161 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[2] = ((parse_Expr)tmp__4);
  # line 162 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[3] = ((parse_Expr)tmp__5);
  # line 163 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[4] = ((parse_Expr)tmp__6);
  # line 164 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[5] = ((parse_Expr)tmp__7);
  # line 165 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[6] = ((parse_Expr)tmp__8);
  # line 166 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[7] = ((parse_Expr)tmp__9);
  # line 167 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[8] = ((parse_Expr)tmp__10);
  # line 168 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[9] = ((parse_Expr)tmp__11);
  # line 169 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[10] = ((parse_Expr)tmp__12);
  # line 170 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[11] = ((parse_Expr)tmp__13);
  # line 171 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[12] = ((parse_Expr)tmp__14);
  # line 178 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[13] = ((parse_Expr)tmp__15);
  # line 179 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[14] = ((parse_Expr)tmp__16);
  # line 180 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[15] = ((parse_Expr)tmp__17);
  # line 187 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[16] = ((parse_Expr)tmp__18);
  # line 188 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[17] = ((parse_Expr)tmp__19);
  # line 195 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[18] = ((parse_Expr)tmp__20);
  # line 202 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[19] = ((parse_Expr)tmp__21);
  # line 203 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[20] = ((parse_Expr)tmp__22);
  # line 204 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[21] = ((parse_Expr)tmp__23);
  # line 205 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[22] = ((parse_Expr)tmp__24);
  # line 212 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[23] = ((parse_Expr)tmp__25);
  # line 213 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[24] = ((parse_Expr)tmp__26);
  # line 214 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[25] = ((parse_Expr)tmp__27);
  # line 215 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[26] = ((parse_Expr)tmp__28);
  # line 216 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[27] = ((parse_Expr)tmp__29);
  # line 217 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[28] = ((parse_Expr)tmp__30);
  # line 218 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[29] = ((parse_Expr)tmp__31);
  # line 219 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[30] = ((parse_Expr)tmp__32);
  # line 220 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[31] = ((parse_Expr)tmp__33);
  # line 227 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[32] = ((parse_Expr)tmp__34);
  # line 228 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[33] = ((parse_Expr)tmp__35);
  # line 232 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[34] = ((parse_Expr)tmp__36);
  # line 233 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[35] = ((parse_Expr)tmp__37);
  # line 234 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[36] = ((parse_Expr)tmp__38);
  # line 235 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[37] = ((parse_Expr)tmp__39);
  # line 236 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[38] = ((parse_Expr)tmp__40);
  # line 237 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[39] = ((parse_Expr)tmp__41);
  # line 238 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[40] = ((parse_Expr)tmp__42);
  # line 239 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[41] = ((parse_Expr)tmp__43);
  # line 240 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[42] = ((parse_Expr)tmp__44);
  # line 241 "../../../../Macaulay2/d/version.dd"
  tmp__46->array[43] = ((parse_Expr)tmp__45);
  # line 158 "../../../../Macaulay2/d/version.dd"
  common_setupconst(str__3, hashtables_toHashTable(tmp__46));
  # line 158 "../../../../Macaulay2/d/version.dd"
  this_thread_prepare.func = version__thread_prepare;
  # line 158 "../../../../Macaulay2/d/version.dd"
  this_thread_prepare.next = thread_prepare_list;
  # line 158 "../../../../Macaulay2/d/version.dd"
  thread_prepare_list = &this_thread_prepare;
  # line 158 "../../../../Macaulay2/d/version.dd"
  this_final.func = version__final;
  # line 158 "../../../../Macaulay2/d/version.dd"
  this_final.next = final_list;
  # line 158 "../../../../Macaulay2/d/version.dd"
  final_list = &this_final;
  # line 158 "../../../../Macaulay2/d/version.dd"
  }
# line 158 "../../../../Macaulay2/d/version.dd"
static void version__thread_prepare(){
  # line 158 "../../../../Macaulay2/d/version.dd"
  }
# line 158 "../../../../Macaulay2/d/version.dd"
static void version__final(){
  # line 158 "../../../../Macaulay2/d/version.dd"
  }
