#include "ffi-exports.h"
#include "scc-core.h"
#include "../system/supervisorinterface.h"
# line 6 "../../../../Macaulay2/d/ffi.d"
#include <dlfcn.h>
	#include <ffi.h>
	/* FFI_BAD_ARGTYPE not introduced until libffi 3.4 in 2021 */
	#ifndef FFI_BAD_ARGTYPE
	  #define FFI_BAD_ARGTYPE 3
	#endif
	#include <M2mem.h>
# line 16 "../../../../Macaulay2/d/ffi.d"

#ifndef HAVE_FFI_GET_STRUCT_OFFSETS
#define FFI_ALIGN(v, a)  (((((size_t) (v))-1) | ((a)-1))+1)

ffi_status
ffi_get_struct_offsets(ffi_abi abi, ffi_type *struct_type, size_t *offsets)
{
  ffi_cif cif;
  ffi_status status;
  ffi_type **ptr;
  size_t size;

  status = ffi_prep_cif(&cif, abi, 0, struct_type, NULL);
  if (status != FFI_OK)
    return status;

  ptr = &(struct_type->elements[0]);
  size = 0;

  while ((*ptr) != NULL) {
      size = FFI_ALIGN(size, (*ptr)->alignment);
      *offsets++ = size;
      size += (*ptr)->size;
      ptr++;
  }

  return FFI_OK;
}
#endif

# line 48 "../../../../Macaulay2/d/ffi.d"
static parse_Expr toExpr_3(void * x){
  # line 48 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell tmp_;
  # line 48 "../../../../Macaulay2/d/ffi.d"
  tmp_ = (parse_pointerCell) GC_MALLOC(sizeof(struct parse_pointerCell_struct));
  if (0 == tmp_) outofmem2((size_t)sizeof(struct parse_pointerCell_struct));
  # line 48 "../../../../Macaulay2/d/ffi.d"
  tmp_->type_ = 81;
  # line 48 "../../../../Macaulay2/d/ffi.d"
  tmp_->v = x;
  # line 48 "../../../../Macaulay2/d/ffi.d"
  return ((parse_Expr)tmp_);
  # line 48 "../../../../Macaulay2/d/ffi.d"
  }
# line 48 "../../../../Macaulay2/d/ffi.d"
static M2_string str_;
# line 49 "../../../../Macaulay2/d/ffi.d"
static parse_Expr WrongArgPointer(){
  # line 49 "../../../../Macaulay2/d/ffi.d"
  return expr_WrongArg(str_);
  # line 49 "../../../../Macaulay2/d/ffi.d"
  }
# line 49 "../../../../Macaulay2/d/ffi.d"
static M2_string str__1;
# line 50 "../../../../Macaulay2/d/ffi.d"
static parse_Expr WrongArgPointer_1(int n){
  # line 50 "../../../../Macaulay2/d/ffi.d"
  return expr_WrongArg_1(n, str__1);
  # line 50 "../../../../Macaulay2/d/ffi.d"
  }
# line 50 "../../../../Macaulay2/d/ffi.d"
static M2_string str__2;
# line 53 "../../../../Macaulay2/d/ffi.d"
static void * getMem(int n){
  # line 53 "../../../../Macaulay2/d/ffi.d"
  return getmem(n);
  # line 53 "../../../../Macaulay2/d/ffi.d"
  }
# line 54 "../../../../Macaulay2/d/ffi.d"
static void * getMemAtomic(int n){
  # line 54 "../../../../Macaulay2/d/ffi.d"
  return getmem_atomic(n);
  # line 54 "../../../../Macaulay2/d/ffi.d"
  }
# line 56 "../../../../Macaulay2/d/ffi.d"
static parse_Expr dlerror0(){
  # line 56 "../../../../Macaulay2/d/ffi.d"
  return expr_buildErrorPacket(M2_tostring_2(dlerror()));
  # line 56 "../../../../Macaulay2/d/ffi.d"
  }
# line 59 "../../../../Macaulay2/d/ffi.d"
static parse_Expr dlopen0(parse_Expr e){
  # line 59 "../../../../Macaulay2/d/ffi.d"
  M2_stringCell s;
  # line 59 "../../../../Macaulay2/d/ffi.d"
  voidPointerOrNull r;
  # line 59 "../../../../Macaulay2/d/ffi.d"
  void * handle;
  # line 59 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__1;
  # line 59 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__2;
  # line 59 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 59 "../../../../Macaulay2/d/ffi.d"
    case 18:;
    # line 59 "../../../../Macaulay2/d/ffi.d"
    s = ((M2_stringCell)e);
    # line 61 "../../../../Macaulay2/d/ffi.d"
    r = dlopen(M2_tocharstar(s->v), RTLD_LAZY);
    # line 63 "../../../../Macaulay2/d/ffi.d"
    if (0 == r) goto L1_;
    # line 63 "../../../../Macaulay2/d/ffi.d"
    goto L0_;
    # line 63 "../../../../Macaulay2/d/ffi.d"
    L1_:;
    # line 64 "../../../../Macaulay2/d/ffi.d"
    tmp__1 = dlerror0();
    # line 64 "../../../../Macaulay2/d/ffi.d"
    goto L2_;
    # line 64 "../../../../Macaulay2/d/ffi.d"
    L0_:;
    # line 63 "../../../../Macaulay2/d/ffi.d"
    handle = ((void *)r);
    # line 65 "../../../../Macaulay2/d/ffi.d"
    tmp__1 = toExpr_3(handle);
    # line 65 "../../../../Macaulay2/d/ffi.d"
    goto L2_;
    # line 65 "../../../../Macaulay2/d/ffi.d"
    L2_:;
    # line 65 "../../../../Macaulay2/d/ffi.d"
    tmp__2 = tmp__1;
    # line 65 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 65 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 66 "../../../../Macaulay2/d/ffi.d"
    tmp__2 = expr_WrongArgString();
    # line 66 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 66 "../../../../Macaulay2/d/ffi.d"
    };
  # line 66 "../../../../Macaulay2/d/ffi.d"
  return tmp__2;
  # line 66 "../../../../Macaulay2/d/ffi.d"
  }
# line 66 "../../../../Macaulay2/d/ffi.d"
static M2_string str__3;
# line 66 "../../../../Macaulay2/d/ffi.d"
static M2_string str__4;
# line 70 "../../../../Macaulay2/d/ffi.d"
static parse_Expr dlsym0(parse_Expr e){
  # line 70 "../../../../Macaulay2/d/ffi.d"
  M2_stringCell y;
  # line 70 "../../../../Macaulay2/d/ffi.d"
  voidPointerOrNull r_1;
  # line 70 "../../../../Macaulay2/d/ffi.d"
  void * addr;
  # line 70 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a;
  # line 70 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_1;
  # line 70 "../../../../Macaulay2/d/ffi.d"
  M2_stringCell y_1;
  # line 70 "../../../../Macaulay2/d/ffi.d"
  voidPointerOrNull r_2;
  # line 70 "../../../../Macaulay2/d/ffi.d"
  void * addr_1;
  # line 70 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__3;
  # line 70 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__4;
  # line 70 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__5;
  # line 70 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__6;
  # line 70 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__7;
  # line 70 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__8;
  # line 70 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__9;
  # line 70 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__10;
  # line 70 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 70 "../../../../Macaulay2/d/ffi.d"
    case 18:;
    # line 70 "../../../../Macaulay2/d/ffi.d"
    y = ((M2_stringCell)e);
    # line 72 "../../../../Macaulay2/d/ffi.d"
    r_1 = dlsym(RTLD_DEFAULT, M2_tocharstar(y->v));
    # line 74 "../../../../Macaulay2/d/ffi.d"
    if (0 == r_1) goto L4_;
    # line 74 "../../../../Macaulay2/d/ffi.d"
    goto L3_;
    # line 74 "../../../../Macaulay2/d/ffi.d"
    L4_:;
    # line 75 "../../../../Macaulay2/d/ffi.d"
    tmp__3 = dlerror0();
    # line 75 "../../../../Macaulay2/d/ffi.d"
    goto L5_;
    # line 75 "../../../../Macaulay2/d/ffi.d"
    L3_:;
    # line 74 "../../../../Macaulay2/d/ffi.d"
    addr = ((void *)r_1);
    # line 76 "../../../../Macaulay2/d/ffi.d"
    tmp__3 = toExpr_3(addr);
    # line 76 "../../../../Macaulay2/d/ffi.d"
    goto L5_;
    # line 76 "../../../../Macaulay2/d/ffi.d"
    L5_:;
    # line 76 "../../../../Macaulay2/d/ffi.d"
    tmp__4 = tmp__3;
    # line 76 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 76 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 70 "../../../../Macaulay2/d/ffi.d"
    a = ((parse_Sequence)e);
    # line 78 "../../../../Macaulay2/d/ffi.d"
    if ((a->len != 2)) goto L6_;
    # line 79 "../../../../Macaulay2/d/ffi.d"
    tmp__5 = a->array[0];
    # line 79 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__5->type_) {;
      # line 79 "../../../../Macaulay2/d/ffi.d"
      case 81:;
      # line 79 "../../../../Macaulay2/d/ffi.d"
      x_1 = ((parse_pointerCell)tmp__5);
      # line 80 "../../../../Macaulay2/d/ffi.d"
      tmp__6 = a->array[1];
      # line 80 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__6->type_) {;
	# line 80 "../../../../Macaulay2/d/ffi.d"
	case 18:;
	# line 80 "../../../../Macaulay2/d/ffi.d"
	y_1 = ((M2_stringCell)tmp__6);
	# line 82 "../../../../Macaulay2/d/ffi.d"
	r_2 = dlsym(x_1->v, M2_tocharstar(y_1->v));
	# line 84 "../../../../Macaulay2/d/ffi.d"
	if (0 == r_2) goto L8_;
	# line 84 "../../../../Macaulay2/d/ffi.d"
	goto L7_;
	# line 84 "../../../../Macaulay2/d/ffi.d"
	L8_:;
	# line 85 "../../../../Macaulay2/d/ffi.d"
	tmp__7 = dlerror0();
	# line 85 "../../../../Macaulay2/d/ffi.d"
	goto L9_;
	# line 85 "../../../../Macaulay2/d/ffi.d"
	L7_:;
	# line 84 "../../../../Macaulay2/d/ffi.d"
	addr_1 = ((void *)r_2);
	# line 86 "../../../../Macaulay2/d/ffi.d"
	tmp__7 = toExpr_3(addr_1);
	# line 86 "../../../../Macaulay2/d/ffi.d"
	goto L9_;
	# line 86 "../../../../Macaulay2/d/ffi.d"
	L9_:;
	# line 86 "../../../../Macaulay2/d/ffi.d"
	tmp__8 = tmp__7;
	# line 86 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 86 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 87 "../../../../Macaulay2/d/ffi.d"
	tmp__8 = expr_WrongArgString_1(2);
	# line 87 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 87 "../../../../Macaulay2/d/ffi.d"
	};
      # line 87 "../../../../Macaulay2/d/ffi.d"
      tmp__9 = tmp__8;
      # line 87 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 87 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 88 "../../../../Macaulay2/d/ffi.d"
      tmp__9 = WrongArgPointer_1(1);
      # line 88 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 88 "../../../../Macaulay2/d/ffi.d"
      };
    # line 88 "../../../../Macaulay2/d/ffi.d"
    tmp__10 = tmp__9;
    # line 88 "../../../../Macaulay2/d/ffi.d"
    goto L10_;
    # line 88 "../../../../Macaulay2/d/ffi.d"
    L6_:;
    # line 78 "../../../../Macaulay2/d/ffi.d"
    tmp__10 = expr_WrongNumArgs_3(1, 2);
    # line 78 "../../../../Macaulay2/d/ffi.d"
    L10_:;
    # line 78 "../../../../Macaulay2/d/ffi.d"
    tmp__4 = tmp__10;
    # line 78 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 78 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 89 "../../../../Macaulay2/d/ffi.d"
    tmp__4 = expr_WrongArg(str__4);
    # line 89 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 89 "../../../../Macaulay2/d/ffi.d"
    };
  # line 89 "../../../../Macaulay2/d/ffi.d"
  return tmp__4;
  # line 89 "../../../../Macaulay2/d/ffi.d"
  }
# line 89 "../../../../Macaulay2/d/ffi.d"
static M2_string str__5;
# line 89 "../../../../Macaulay2/d/ffi.d"
static void * ffiTypeVoid;
# line 89 "../../../../Macaulay2/d/ffi.d"
static int ffiOk;
# line 96 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiTypeSize(parse_Expr e){
  # line 96 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_2;
  # line 96 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__11;
  # line 96 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 96 "../../../../Macaulay2/d/ffi.d"
    case 81:;
    # line 96 "../../../../Macaulay2/d/ffi.d"
    x_2 = ((parse_pointerCell)e);
    # line 97 "../../../../Macaulay2/d/ffi.d"
    tmp__11 = util_toExpr(((ffi_type *)x_2->v)->size);
    # line 97 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 97 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 98 "../../../../Macaulay2/d/ffi.d"
    tmp__11 = WrongArgPointer();
    # line 98 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 98 "../../../../Macaulay2/d/ffi.d"
    };
  # line 98 "../../../../Macaulay2/d/ffi.d"
  return tmp__11;
  # line 98 "../../../../Macaulay2/d/ffi.d"
  }
# line 98 "../../../../Macaulay2/d/ffi.d"
static M2_string str__6;
# line 98 "../../../../Macaulay2/d/ffi.d"
static M2_string str__7;
# line 98 "../../../../Macaulay2/d/ffi.d"
static M2_string str__8;
# line 98 "../../../../Macaulay2/d/ffi.d"
static M2_string str__9;
# line 98 "../../../../Macaulay2/d/ffi.d"
static M2_string str__10;
# line 102 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiError(int r){
  # line 102 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__12;
  # line 102 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__13;
  # line 102 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__14;
  # line 102 "../../../../Macaulay2/d/ffi.d"
  if ((r == FFI_BAD_TYPEDEF)) goto L11_;
  # line 104 "../../../../Macaulay2/d/ffi.d"
  if ((r == FFI_BAD_ABI)) goto L12_;
  # line 106 "../../../../Macaulay2/d/ffi.d"
  if ((r == FFI_BAD_ARGTYPE)) goto L13_;
  # line 108 "../../../../Macaulay2/d/ffi.d"
  tmp__12 = expr_buildErrorPacket(str__7);
  # line 108 "../../../../Macaulay2/d/ffi.d"
  goto L14_;
  # line 108 "../../../../Macaulay2/d/ffi.d"
  L13_:;
  # line 107 "../../../../Macaulay2/d/ffi.d"
  tmp__12 = expr_buildErrorPacket(str__8);
  # line 107 "../../../../Macaulay2/d/ffi.d"
  L14_:;
  # line 107 "../../../../Macaulay2/d/ffi.d"
  tmp__13 = tmp__12;
  # line 107 "../../../../Macaulay2/d/ffi.d"
  goto L15_;
  # line 107 "../../../../Macaulay2/d/ffi.d"
  L12_:;
  # line 105 "../../../../Macaulay2/d/ffi.d"
  tmp__13 = expr_buildErrorPacket(str__9);
  # line 105 "../../../../Macaulay2/d/ffi.d"
  L15_:;
  # line 105 "../../../../Macaulay2/d/ffi.d"
  tmp__14 = tmp__13;
  # line 105 "../../../../Macaulay2/d/ffi.d"
  goto L16_;
  # line 105 "../../../../Macaulay2/d/ffi.d"
  L11_:;
  # line 103 "../../../../Macaulay2/d/ffi.d"
  tmp__14 = expr_buildErrorPacket(str__10);
  # line 103 "../../../../Macaulay2/d/ffi.d"
  L16_:;
  # line 103 "../../../../Macaulay2/d/ffi.d"
  return tmp__14;
  # line 103 "../../../../Macaulay2/d/ffi.d"
  }
# line 103 "../../../../Macaulay2/d/ffi.d"
static M2_string str__11;
# line 111 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiPrepCif(parse_Expr e){
  # line 111 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_1;
  # line 111 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_3;
  # line 111 "../../../../Macaulay2/d/ffi.d"
  parse_List y_2;
  # line 111 "../../../../Macaulay2/d/ffi.d"
  int i;
  # line 111 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell z;
  # line 111 "../../../../Macaulay2/d/ffi.d"
  struct M2_1129 * argtypes;
  # line 111 "../../../../Macaulay2/d/ffi.d"
  void * cif;
  # line 111 "../../../../Macaulay2/d/ffi.d"
  int r_3;
  # line 111 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__15;
  # line 111 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__16;
  # line 111 "../../../../Macaulay2/d/ffi.d"
  struct M2_1129 * tmp__17;
  # line 111 "../../../../Macaulay2/d/ffi.d"
  int tmp__18;
  # line 111 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__19;
  # line 111 "../../../../Macaulay2/d/ffi.d"
  void * tmp__20;
  # line 111 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__21;
  # line 111 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__22;
  # line 111 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__23;
  # line 111 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__24;
  # line 111 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__25;
  # line 111 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 111 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 111 "../../../../Macaulay2/d/ffi.d"
    a_1 = ((parse_Sequence)e);
    # line 113 "../../../../Macaulay2/d/ffi.d"
    if ((a_1->len != 2)) goto L17_;
    # line 114 "../../../../Macaulay2/d/ffi.d"
    tmp__15 = a_1->array[0];
    # line 114 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__15->type_) {;
      # line 114 "../../../../Macaulay2/d/ffi.d"
      case 81:;
      # line 114 "../../../../Macaulay2/d/ffi.d"
      x_3 = ((parse_pointerCell)tmp__15);
      # line 115 "../../../../Macaulay2/d/ffi.d"
      tmp__16 = a_1->array[1];
      # line 115 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__16->type_) {;
	# line 115 "../../../../Macaulay2/d/ffi.d"
	case 45:;
	# line 115 "../../../../Macaulay2/d/ffi.d"
	y_2 = ((parse_List)tmp__16);
	# line 115 "../../../../Macaulay2/d/ffi.d"
	i = 0;
	# line 117 "../../../../Macaulay2/d/ffi.d"
	tmp__18 = y_2->v->len;
	# line 117 "../../../../Macaulay2/d/ffi.d"
	;
	# line 117 "../../../../Macaulay2/d/ffi.d"
	tmp__17 = (struct M2_1129 *) GC_MALLOC(sizeof(struct M2_1129) + (tmp__18)*sizeof(void *)-sizeof(void *));
	if (0 == tmp__17) outofmem2((size_t)sizeof(struct M2_1129) + (tmp__18)*sizeof(void *)-sizeof(void *));
	# line 117 "../../../../Macaulay2/d/ffi.d"
	tmp__17->len = tmp__18;
	# line 117 "../../../../Macaulay2/d/ffi.d"
	if ((tmp__18 == 0)) goto L19_;
	# line 117 "../../../../Macaulay2/d/ffi.d"
	L18_:;
	# line 118 "../../../../Macaulay2/d/ffi.d"
	tmp__19 = y_2->v->array[i];
	# line 118 "../../../../Macaulay2/d/ffi.d"
	switch (tmp__19->type_) {;
	  # line 118 "../../../../Macaulay2/d/ffi.d"
	  case 81:;
	  # line 118 "../../../../Macaulay2/d/ffi.d"
	  z = ((parse_pointerCell)tmp__19);
	  # line 118 "../../../../Macaulay2/d/ffi.d"
	  tmp__20 = z->v;
	  # line 118 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 118 "../../../../Macaulay2/d/ffi.d"
	  default:;
	  # line 119 "../../../../Macaulay2/d/ffi.d"
	  tmp__20 = ffiTypeVoid;
	  # line 119 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 119 "../../../../Macaulay2/d/ffi.d"
	  };
	# line 119 "../../../../Macaulay2/d/ffi.d"
	tmp__17->array[i] = tmp__20;
	# line 117 "../../../../Macaulay2/d/ffi.d"
	if (((++ i) < tmp__18)) goto L20_;
	# line 117 "../../../../Macaulay2/d/ffi.d"
	goto L19_;
	# line 117 "../../../../Macaulay2/d/ffi.d"
	L20_:;
	# line 117 "../../../../Macaulay2/d/ffi.d"
	goto L18_;
	# line 117 "../../../../Macaulay2/d/ffi.d"
	L19_:;
	# line 117 "../../../../Macaulay2/d/ffi.d"
	argtypes = tmp__17;
	# line 120 "../../../../Macaulay2/d/ffi.d"
	cif = getmem(sizeof(ffi_cif));
	# line 121 "../../../../Macaulay2/d/ffi.d"
	r_3 = ffi_prep_cif((ffi_cif *)cif, FFI_DEFAULT_ABI, argtypes->len, (ffi_type *) x_3->v, (ffi_type **) argtypes->array);
	# line 126 "../../../../Macaulay2/d/ffi.d"
	if ((r_3 != ffiOk)) goto L21_;
	# line 127 "../../../../Macaulay2/d/ffi.d"
	tmp__21 = toExpr_3(cif);
	# line 127 "../../../../Macaulay2/d/ffi.d"
	goto L22_;
	# line 127 "../../../../Macaulay2/d/ffi.d"
	L21_:;
	# line 126 "../../../../Macaulay2/d/ffi.d"
	tmp__21 = ffiError(r_3);
	# line 126 "../../../../Macaulay2/d/ffi.d"
	L22_:;
	# line 126 "../../../../Macaulay2/d/ffi.d"
	tmp__22 = tmp__21;
	# line 126 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 126 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 128 "../../../../Macaulay2/d/ffi.d"
	tmp__22 = expr_WrongArg_1(2, str__11);
	# line 128 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 128 "../../../../Macaulay2/d/ffi.d"
	};
      # line 128 "../../../../Macaulay2/d/ffi.d"
      tmp__23 = tmp__22;
      # line 128 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 128 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 129 "../../../../Macaulay2/d/ffi.d"
      tmp__23 = WrongArgPointer_1(1);
      # line 129 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 129 "../../../../Macaulay2/d/ffi.d"
      };
    # line 129 "../../../../Macaulay2/d/ffi.d"
    tmp__24 = tmp__23;
    # line 129 "../../../../Macaulay2/d/ffi.d"
    goto L23_;
    # line 129 "../../../../Macaulay2/d/ffi.d"
    L17_:;
    # line 113 "../../../../Macaulay2/d/ffi.d"
    tmp__24 = expr_WrongNumArgs_1(2);
    # line 113 "../../../../Macaulay2/d/ffi.d"
    L23_:;
    # line 113 "../../../../Macaulay2/d/ffi.d"
    tmp__25 = tmp__24;
    # line 113 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 113 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 130 "../../../../Macaulay2/d/ffi.d"
    tmp__25 = expr_WrongNumArgs_1(2);
    # line 130 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 130 "../../../../Macaulay2/d/ffi.d"
    };
  # line 130 "../../../../Macaulay2/d/ffi.d"
  return tmp__25;
  # line 130 "../../../../Macaulay2/d/ffi.d"
  }
# line 130 "../../../../Macaulay2/d/ffi.d"
static M2_string str__12;
# line 130 "../../../../Macaulay2/d/ffi.d"
static M2_string str__13;
# line 134 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiPrepCifVar(parse_Expr e){
  # line 134 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_2;
  # line 134 "../../../../Macaulay2/d/ffi.d"
  gmp_ZZcell n_1;
  # line 134 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_4;
  # line 134 "../../../../Macaulay2/d/ffi.d"
  parse_List y_3;
  # line 134 "../../../../Macaulay2/d/ffi.d"
  int i_1;
  # line 134 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell z_1;
  # line 134 "../../../../Macaulay2/d/ffi.d"
  struct M2_1129 * argtypes_1;
  # line 134 "../../../../Macaulay2/d/ffi.d"
  void * cif_1;
  # line 134 "../../../../Macaulay2/d/ffi.d"
  int r_4;
  # line 134 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__26;
  # line 134 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__27;
  # line 134 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__28;
  # line 134 "../../../../Macaulay2/d/ffi.d"
  struct M2_1129 * tmp__29;
  # line 134 "../../../../Macaulay2/d/ffi.d"
  int tmp__30;
  # line 134 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__31;
  # line 134 "../../../../Macaulay2/d/ffi.d"
  void * tmp__32;
  # line 134 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__33;
  # line 134 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__34;
  # line 134 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__35;
  # line 134 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__36;
  # line 134 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__37;
  # line 134 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__38;
  # line 134 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 134 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 134 "../../../../Macaulay2/d/ffi.d"
    a_2 = ((parse_Sequence)e);
    # line 136 "../../../../Macaulay2/d/ffi.d"
    if ((a_2->len != 3)) goto L24_;
    # line 137 "../../../../Macaulay2/d/ffi.d"
    tmp__26 = a_2->array[0];
    # line 137 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__26->type_) {;
      # line 137 "../../../../Macaulay2/d/ffi.d"
      case 3:;
      # line 137 "../../../../Macaulay2/d/ffi.d"
      n_1 = ((gmp_ZZcell)tmp__26);
      # line 138 "../../../../Macaulay2/d/ffi.d"
      tmp__27 = a_2->array[1];
      # line 138 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__27->type_) {;
	# line 138 "../../../../Macaulay2/d/ffi.d"
	case 81:;
	# line 138 "../../../../Macaulay2/d/ffi.d"
	x_4 = ((parse_pointerCell)tmp__27);
	# line 139 "../../../../Macaulay2/d/ffi.d"
	tmp__28 = a_2->array[2];
	# line 139 "../../../../Macaulay2/d/ffi.d"
	switch (tmp__28->type_) {;
	  # line 139 "../../../../Macaulay2/d/ffi.d"
	  case 45:;
	  # line 139 "../../../../Macaulay2/d/ffi.d"
	  y_3 = ((parse_List)tmp__28);
	  # line 139 "../../../../Macaulay2/d/ffi.d"
	  i_1 = 0;
	  # line 141 "../../../../Macaulay2/d/ffi.d"
	  tmp__30 = y_3->v->len;
	  # line 141 "../../../../Macaulay2/d/ffi.d"
	  ;
	  # line 141 "../../../../Macaulay2/d/ffi.d"
	  tmp__29 = (struct M2_1129 *) GC_MALLOC(sizeof(struct M2_1129) + (tmp__30)*sizeof(void *)-sizeof(void *));
	  if (0 == tmp__29) outofmem2((size_t)sizeof(struct M2_1129) + (tmp__30)*sizeof(void *)-sizeof(void *));
	  # line 141 "../../../../Macaulay2/d/ffi.d"
	  tmp__29->len = tmp__30;
	  # line 141 "../../../../Macaulay2/d/ffi.d"
	  if ((tmp__30 == 0)) goto L26_;
	  # line 141 "../../../../Macaulay2/d/ffi.d"
	  L25_:;
	  # line 142 "../../../../Macaulay2/d/ffi.d"
	  tmp__31 = y_3->v->array[i_1];
	  # line 142 "../../../../Macaulay2/d/ffi.d"
	  switch (tmp__31->type_) {;
	    # line 142 "../../../../Macaulay2/d/ffi.d"
	    case 81:;
	    # line 142 "../../../../Macaulay2/d/ffi.d"
	    z_1 = ((parse_pointerCell)tmp__31);
	    # line 142 "../../../../Macaulay2/d/ffi.d"
	    tmp__32 = z_1->v;
	    # line 142 "../../../../Macaulay2/d/ffi.d"
	    break;
	    # line 142 "../../../../Macaulay2/d/ffi.d"
	    default:;
	    # line 143 "../../../../Macaulay2/d/ffi.d"
	    tmp__32 = ffiTypeVoid;
	    # line 143 "../../../../Macaulay2/d/ffi.d"
	    break;
	    # line 143 "../../../../Macaulay2/d/ffi.d"
	    };
	  # line 143 "../../../../Macaulay2/d/ffi.d"
	  tmp__29->array[i_1] = tmp__32;
	  # line 141 "../../../../Macaulay2/d/ffi.d"
	  if (((++ i_1) < tmp__30)) goto L27_;
	  # line 141 "../../../../Macaulay2/d/ffi.d"
	  goto L26_;
	  # line 141 "../../../../Macaulay2/d/ffi.d"
	  L27_:;
	  # line 141 "../../../../Macaulay2/d/ffi.d"
	  goto L25_;
	  # line 141 "../../../../Macaulay2/d/ffi.d"
	  L26_:;
	  # line 141 "../../../../Macaulay2/d/ffi.d"
	  argtypes_1 = tmp__29;
	  # line 144 "../../../../Macaulay2/d/ffi.d"
	  cif_1 = getmem(sizeof(ffi_cif));
	  # line 145 "../../../../Macaulay2/d/ffi.d"
	  r_4 = ffi_prep_cif_var((ffi_cif *)cif_1, FFI_DEFAULT_ABI, gmp_toInt_1(n_1), argtypes_1->len, (ffi_type *) x_4->v, (ffi_type **) argtypes_1->array);
	  # line 151 "../../../../Macaulay2/d/ffi.d"
	  if ((r_4 != ffiOk)) goto L28_;
	  # line 152 "../../../../Macaulay2/d/ffi.d"
	  tmp__33 = toExpr_3(cif_1);
	  # line 152 "../../../../Macaulay2/d/ffi.d"
	  goto L29_;
	  # line 152 "../../../../Macaulay2/d/ffi.d"
	  L28_:;
	  # line 151 "../../../../Macaulay2/d/ffi.d"
	  tmp__33 = ffiError(r_4);
	  # line 151 "../../../../Macaulay2/d/ffi.d"
	  L29_:;
	  # line 151 "../../../../Macaulay2/d/ffi.d"
	  tmp__34 = tmp__33;
	  # line 151 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 151 "../../../../Macaulay2/d/ffi.d"
	  default:;
	  # line 153 "../../../../Macaulay2/d/ffi.d"
	  tmp__34 = expr_WrongArg_1(3, str__13);
	  # line 153 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 153 "../../../../Macaulay2/d/ffi.d"
	  };
	# line 153 "../../../../Macaulay2/d/ffi.d"
	tmp__35 = tmp__34;
	# line 153 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 153 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 154 "../../../../Macaulay2/d/ffi.d"
	tmp__35 = WrongArgPointer_1(2);
	# line 154 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 154 "../../../../Macaulay2/d/ffi.d"
	};
      # line 154 "../../../../Macaulay2/d/ffi.d"
      tmp__36 = tmp__35;
      # line 154 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 154 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 155 "../../../../Macaulay2/d/ffi.d"
      tmp__36 = expr_WrongArgZZ_1(1);
      # line 155 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 155 "../../../../Macaulay2/d/ffi.d"
      };
    # line 155 "../../../../Macaulay2/d/ffi.d"
    tmp__37 = tmp__36;
    # line 155 "../../../../Macaulay2/d/ffi.d"
    goto L30_;
    # line 155 "../../../../Macaulay2/d/ffi.d"
    L24_:;
    # line 136 "../../../../Macaulay2/d/ffi.d"
    tmp__37 = expr_WrongNumArgs_1(3);
    # line 136 "../../../../Macaulay2/d/ffi.d"
    L30_:;
    # line 136 "../../../../Macaulay2/d/ffi.d"
    tmp__38 = tmp__37;
    # line 136 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 136 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 156 "../../../../Macaulay2/d/ffi.d"
    tmp__38 = expr_WrongNumArgs_1(3);
    # line 156 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 156 "../../../../Macaulay2/d/ffi.d"
    };
  # line 156 "../../../../Macaulay2/d/ffi.d"
  return tmp__38;
  # line 156 "../../../../Macaulay2/d/ffi.d"
  }
# line 156 "../../../../Macaulay2/d/ffi.d"
static M2_string str__14;
# line 162 "../../../../Macaulay2/d/ffi.d"
static void * endianAdjust(void * ptr,void * rtype){
  # line 162 "../../../../Macaulay2/d/ffi.d"
  int offset;
  # line 162 "../../../../Macaulay2/d/ffi.d"
  char tmp__39;
  # line 162 "../../../../Macaulay2/d/ffi.d"
  void * tmp__40;
  # line 162 "../../../../Macaulay2/d/ffi.d"
  void * tmp__41;
  # line 162 "../../../../Macaulay2/d/ffi.d"
  if ((__BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__)) goto L31_;
  # line 165 "../../../../Macaulay2/d/ffi.d"
  offset = sizeof(ffi_arg) - ((ffi_type *)rtype)->size;
  # line 167 "../../../../Macaulay2/d/ffi.d"
  tmp__39 = (((ffi_type *)rtype)->type == FFI_TYPE_FLOAT);
  # line 167 "../../../../Macaulay2/d/ffi.d"
  if (tmp__39) goto L33_;
  # line 168 "../../../../Macaulay2/d/ffi.d"
  tmp__39 = (offset <= 0);
  # line 168 "../../../../Macaulay2/d/ffi.d"
  L33_:;
  # line 168 "../../../../Macaulay2/d/ffi.d"
  if (tmp__39) goto L32_;
  # line 170 "../../../../Macaulay2/d/ffi.d"
  tmp__40 = ptr + offset;
  # line 170 "../../../../Macaulay2/d/ffi.d"
  goto L34_;
  # line 170 "../../../../Macaulay2/d/ffi.d"
  L32_:;
  # line 169 "../../../../Macaulay2/d/ffi.d"
  tmp__40 = ptr;
  # line 169 "../../../../Macaulay2/d/ffi.d"
  L34_:;
  # line 169 "../../../../Macaulay2/d/ffi.d"
  tmp__41 = tmp__40;
  # line 169 "../../../../Macaulay2/d/ffi.d"
  goto L35_;
  # line 169 "../../../../Macaulay2/d/ffi.d"
  L31_:;
  # line 163 "../../../../Macaulay2/d/ffi.d"
  tmp__41 = ptr;
  # line 163 "../../../../Macaulay2/d/ffi.d"
  L35_:;
  # line 163 "../../../../Macaulay2/d/ffi.d"
  return tmp__41;
  # line 163 "../../../../Macaulay2/d/ffi.d"
  }
# line 163 "../../../../Macaulay2/d/ffi.d"
static M2_string str__15;
# line 173 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiCall(parse_Expr e){
  # line 173 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_3;
  # line 173 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell cif_2;
  # line 173 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell fn;
  # line 173 "../../../../Macaulay2/d/ffi.d"
  gmp_ZZcell n_2;
  # line 173 "../../../../Macaulay2/d/ffi.d"
  parse_List z_2;
  # line 173 "../../../../Macaulay2/d/ffi.d"
  void * rvalue;
  # line 173 "../../../../Macaulay2/d/ffi.d"
  int i_2;
  # line 173 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell p;
  # line 173 "../../../../Macaulay2/d/ffi.d"
  struct M2_1129 * avalues;
  # line 173 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__42;
  # line 173 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__43;
  # line 173 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__44;
  # line 173 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__45;
  # line 173 "../../../../Macaulay2/d/ffi.d"
  struct M2_1129 * tmp__46;
  # line 173 "../../../../Macaulay2/d/ffi.d"
  int tmp__47;
  # line 173 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__48;
  # line 173 "../../../../Macaulay2/d/ffi.d"
  void * tmp__49;
  # line 173 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__50;
  # line 173 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__51;
  # line 173 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__52;
  # line 173 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__53;
  # line 173 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__54;
  # line 173 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__55;
  # line 173 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 173 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 173 "../../../../Macaulay2/d/ffi.d"
    a_3 = ((parse_Sequence)e);
    # line 175 "../../../../Macaulay2/d/ffi.d"
    if ((a_3->len != 4)) goto L36_;
    # line 176 "../../../../Macaulay2/d/ffi.d"
    tmp__42 = a_3->array[0];
    # line 176 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__42->type_) {;
      # line 176 "../../../../Macaulay2/d/ffi.d"
      case 81:;
      # line 176 "../../../../Macaulay2/d/ffi.d"
      cif_2 = ((parse_pointerCell)tmp__42);
      # line 177 "../../../../Macaulay2/d/ffi.d"
      tmp__43 = a_3->array[1];
      # line 177 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__43->type_) {;
	# line 177 "../../../../Macaulay2/d/ffi.d"
	case 81:;
	# line 177 "../../../../Macaulay2/d/ffi.d"
	fn = ((parse_pointerCell)tmp__43);
	# line 178 "../../../../Macaulay2/d/ffi.d"
	tmp__44 = a_3->array[2];
	# line 178 "../../../../Macaulay2/d/ffi.d"
	switch (tmp__44->type_) {;
	  # line 178 "../../../../Macaulay2/d/ffi.d"
	  case 3:;
	  # line 178 "../../../../Macaulay2/d/ffi.d"
	  n_2 = ((gmp_ZZcell)tmp__44);
	  # line 179 "../../../../Macaulay2/d/ffi.d"
	  tmp__45 = a_3->array[3];
	  # line 179 "../../../../Macaulay2/d/ffi.d"
	  switch (tmp__45->type_) {;
	    # line 179 "../../../../Macaulay2/d/ffi.d"
	    case 45:;
	    # line 179 "../../../../Macaulay2/d/ffi.d"
	    z_2 = ((parse_List)tmp__45);
	    # line 181 "../../../../Macaulay2/d/ffi.d"
	    rvalue = getMem(gmp_toInt_1(n_2));
	    # line 181 "../../../../Macaulay2/d/ffi.d"
	    i_2 = 0;
	    # line 183 "../../../../Macaulay2/d/ffi.d"
	    tmp__47 = z_2->v->len;
	    # line 183 "../../../../Macaulay2/d/ffi.d"
	    ;
	    # line 183 "../../../../Macaulay2/d/ffi.d"
	    tmp__46 = (struct M2_1129 *) GC_MALLOC(sizeof(struct M2_1129) + (tmp__47)*sizeof(void *)-sizeof(void *));
	    if (0 == tmp__46) outofmem2((size_t)sizeof(struct M2_1129) + (tmp__47)*sizeof(void *)-sizeof(void *));
	    # line 183 "../../../../Macaulay2/d/ffi.d"
	    tmp__46->len = tmp__47;
	    # line 183 "../../../../Macaulay2/d/ffi.d"
	    if ((tmp__47 == 0)) goto L38_;
	    # line 183 "../../../../Macaulay2/d/ffi.d"
	    L37_:;
	    # line 184 "../../../../Macaulay2/d/ffi.d"
	    tmp__48 = z_2->v->array[i_2];
	    # line 184 "../../../../Macaulay2/d/ffi.d"
	    switch (tmp__48->type_) {;
	      # line 184 "../../../../Macaulay2/d/ffi.d"
	      case 81:;
	      # line 184 "../../../../Macaulay2/d/ffi.d"
	      p = ((parse_pointerCell)tmp__48);
	      # line 185 "../../../../Macaulay2/d/ffi.d"
	      tmp__49 = p->v;
	      # line 185 "../../../../Macaulay2/d/ffi.d"
	      break;
	      # line 185 "../../../../Macaulay2/d/ffi.d"
	      default:;
	      # line 186 "../../../../Macaulay2/d/ffi.d"
	      tmp__49 = ((void *)0);
	      # line 186 "../../../../Macaulay2/d/ffi.d"
	      break;
	      # line 186 "../../../../Macaulay2/d/ffi.d"
	      };
	    # line 186 "../../../../Macaulay2/d/ffi.d"
	    tmp__46->array[i_2] = tmp__49;
	    # line 183 "../../../../Macaulay2/d/ffi.d"
	    if (((++ i_2) < tmp__47)) goto L39_;
	    # line 183 "../../../../Macaulay2/d/ffi.d"
	    goto L38_;
	    # line 183 "../../../../Macaulay2/d/ffi.d"
	    L39_:;
	    # line 183 "../../../../Macaulay2/d/ffi.d"
	    goto L37_;
	    # line 183 "../../../../Macaulay2/d/ffi.d"
	    L38_:;
	    # line 183 "../../../../Macaulay2/d/ffi.d"
	    avalues = tmp__46;
	    # line 187 "../../../../Macaulay2/d/ffi.d"
	    ffi_call((ffi_cif *)cif_2->v, fn->v, rvalue, avalues->array);
	    # line 191 "../../../../Macaulay2/d/ffi.d"
	    tmp__50 = toExpr_3(endianAdjust(rvalue, ((ffi_cif *)cif_2->v)->rtype));
	    # line 192 "../../../../Macaulay2/d/ffi.d"
	    break;
	    # line 192 "../../../../Macaulay2/d/ffi.d"
	    default:;
	    # line 193 "../../../../Macaulay2/d/ffi.d"
	    tmp__50 = expr_WrongArg_1(4, str__15);
	    # line 193 "../../../../Macaulay2/d/ffi.d"
	    break;
	    # line 193 "../../../../Macaulay2/d/ffi.d"
	    };
	  # line 193 "../../../../Macaulay2/d/ffi.d"
	  tmp__51 = tmp__50;
	  # line 193 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 193 "../../../../Macaulay2/d/ffi.d"
	  default:;
	  # line 194 "../../../../Macaulay2/d/ffi.d"
	  tmp__51 = expr_WrongArgZZ_1(3);
	  # line 194 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 194 "../../../../Macaulay2/d/ffi.d"
	  };
	# line 194 "../../../../Macaulay2/d/ffi.d"
	tmp__52 = tmp__51;
	# line 194 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 194 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 195 "../../../../Macaulay2/d/ffi.d"
	tmp__52 = WrongArgPointer_1(2);
	# line 195 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 195 "../../../../Macaulay2/d/ffi.d"
	};
      # line 195 "../../../../Macaulay2/d/ffi.d"
      tmp__53 = tmp__52;
      # line 195 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 195 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 196 "../../../../Macaulay2/d/ffi.d"
      tmp__53 = WrongArgPointer_1(1);
      # line 196 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 196 "../../../../Macaulay2/d/ffi.d"
      };
    # line 196 "../../../../Macaulay2/d/ffi.d"
    tmp__54 = tmp__53;
    # line 196 "../../../../Macaulay2/d/ffi.d"
    goto L40_;
    # line 196 "../../../../Macaulay2/d/ffi.d"
    L36_:;
    # line 175 "../../../../Macaulay2/d/ffi.d"
    tmp__54 = expr_WrongNumArgs_1(4);
    # line 175 "../../../../Macaulay2/d/ffi.d"
    L40_:;
    # line 175 "../../../../Macaulay2/d/ffi.d"
    tmp__55 = tmp__54;
    # line 175 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 175 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 197 "../../../../Macaulay2/d/ffi.d"
    tmp__55 = expr_WrongNumArgs_1(4);
    # line 197 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 197 "../../../../Macaulay2/d/ffi.d"
    };
  # line 197 "../../../../Macaulay2/d/ffi.d"
  return tmp__55;
  # line 197 "../../../../Macaulay2/d/ffi.d"
  }
# line 197 "../../../../Macaulay2/d/ffi.d"
static M2_string str__16;
# line 197 "../../../../Macaulay2/d/ffi.d"
static M2_string str__17;
# line 197 "../../../../Macaulay2/d/ffi.d"
static M2_string str__18;
# line 197 "../../../../Macaulay2/d/ffi.d"
static M2_string str__19;
# line 210 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiIntegerType(parse_Expr e){
  # line 210 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_4;
  # line 210 "../../../../Macaulay2/d/ffi.d"
  gmp_ZZcell n_3;
  # line 210 "../../../../Macaulay2/d/ffi.d"
  parse_Boolean signed_1;
  # line 210 "../../../../Macaulay2/d/ffi.d"
  int bits;
  # line 210 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__56;
  # line 210 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__57;
  # line 210 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__58;
  # line 210 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__59;
  # line 210 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__60;
  # line 210 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__61;
  # line 210 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__62;
  # line 210 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__63;
  # line 210 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__64;
  # line 210 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__65;
  # line 210 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__66;
  # line 210 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__67;
  # line 210 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__68;
  # line 210 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__69;
  # line 210 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__70;
  # line 210 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 210 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 210 "../../../../Macaulay2/d/ffi.d"
    a_4 = ((parse_Sequence)e);
    # line 212 "../../../../Macaulay2/d/ffi.d"
    if ((a_4->len == 2)) goto L41_;
    # line 241 "../../../../Macaulay2/d/ffi.d"
    tmp__56 = expr_WrongNumArgs_1(2);
    # line 241 "../../../../Macaulay2/d/ffi.d"
    goto L42_;
    # line 241 "../../../../Macaulay2/d/ffi.d"
    L41_:;
    # line 213 "../../../../Macaulay2/d/ffi.d"
    tmp__57 = a_4->array[0];
    # line 213 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__57->type_) {;
      # line 213 "../../../../Macaulay2/d/ffi.d"
      case 3:;
      # line 213 "../../../../Macaulay2/d/ffi.d"
      n_3 = ((gmp_ZZcell)tmp__57);
      # line 215 "../../../../Macaulay2/d/ffi.d"
      tmp__58 = a_4->array[1];
      # line 215 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__58->type_) {;
	# line 215 "../../../../Macaulay2/d/ffi.d"
	case 5:;
	# line 215 "../../../../Macaulay2/d/ffi.d"
	signed_1 = ((parse_Boolean)tmp__58);
	# line 217 "../../../../Macaulay2/d/ffi.d"
	bits = gmp_toInt_1(n_3);
	# line 218 "../../../../Macaulay2/d/ffi.d"
	if (signed_1->v) goto L43_;
	# line 229 "../../../../Macaulay2/d/ffi.d"
	if ((bits == 8)) goto L44_;
	# line 231 "../../../../Macaulay2/d/ffi.d"
	if ((bits == 16)) goto L45_;
	# line 233 "../../../../Macaulay2/d/ffi.d"
	if ((bits == 32)) goto L46_;
	# line 235 "../../../../Macaulay2/d/ffi.d"
	if ((bits == 64)) goto L47_;
	# line 237 "../../../../Macaulay2/d/ffi.d"
	tmp__59 = expr_buildErrorPacket(str__18);
	# line 237 "../../../../Macaulay2/d/ffi.d"
	goto L48_;
	# line 237 "../../../../Macaulay2/d/ffi.d"
	L47_:;
	# line 236 "../../../../Macaulay2/d/ffi.d"
	tmp__59 = toExpr_3(&ffi_type_uint64);
	# line 236 "../../../../Macaulay2/d/ffi.d"
	L48_:;
	# line 236 "../../../../Macaulay2/d/ffi.d"
	tmp__60 = tmp__59;
	# line 236 "../../../../Macaulay2/d/ffi.d"
	goto L49_;
	# line 236 "../../../../Macaulay2/d/ffi.d"
	L46_:;
	# line 234 "../../../../Macaulay2/d/ffi.d"
	tmp__60 = toExpr_3(&ffi_type_uint32);
	# line 234 "../../../../Macaulay2/d/ffi.d"
	L49_:;
	# line 234 "../../../../Macaulay2/d/ffi.d"
	tmp__61 = tmp__60;
	# line 234 "../../../../Macaulay2/d/ffi.d"
	goto L50_;
	# line 234 "../../../../Macaulay2/d/ffi.d"
	L45_:;
	# line 232 "../../../../Macaulay2/d/ffi.d"
	tmp__61 = toExpr_3(&ffi_type_uint16);
	# line 232 "../../../../Macaulay2/d/ffi.d"
	L50_:;
	# line 232 "../../../../Macaulay2/d/ffi.d"
	tmp__62 = tmp__61;
	# line 232 "../../../../Macaulay2/d/ffi.d"
	goto L51_;
	# line 232 "../../../../Macaulay2/d/ffi.d"
	L44_:;
	# line 230 "../../../../Macaulay2/d/ffi.d"
	tmp__62 = toExpr_3(&ffi_type_uint8);
	# line 230 "../../../../Macaulay2/d/ffi.d"
	L51_:;
	# line 230 "../../../../Macaulay2/d/ffi.d"
	tmp__63 = tmp__62;
	# line 230 "../../../../Macaulay2/d/ffi.d"
	goto L52_;
	# line 230 "../../../../Macaulay2/d/ffi.d"
	L43_:;
	# line 219 "../../../../Macaulay2/d/ffi.d"
	if ((bits == 8)) goto L53_;
	# line 221 "../../../../Macaulay2/d/ffi.d"
	if ((bits == 16)) goto L54_;
	# line 223 "../../../../Macaulay2/d/ffi.d"
	if ((bits == 32)) goto L55_;
	# line 225 "../../../../Macaulay2/d/ffi.d"
	if ((bits == 64)) goto L56_;
	# line 227 "../../../../Macaulay2/d/ffi.d"
	tmp__64 = expr_buildErrorPacket(str__19);
	# line 227 "../../../../Macaulay2/d/ffi.d"
	goto L57_;
	# line 227 "../../../../Macaulay2/d/ffi.d"
	L56_:;
	# line 226 "../../../../Macaulay2/d/ffi.d"
	tmp__64 = toExpr_3(&ffi_type_sint64);
	# line 226 "../../../../Macaulay2/d/ffi.d"
	L57_:;
	# line 226 "../../../../Macaulay2/d/ffi.d"
	tmp__65 = tmp__64;
	# line 226 "../../../../Macaulay2/d/ffi.d"
	goto L58_;
	# line 226 "../../../../Macaulay2/d/ffi.d"
	L55_:;
	# line 224 "../../../../Macaulay2/d/ffi.d"
	tmp__65 = toExpr_3(&ffi_type_sint32);
	# line 224 "../../../../Macaulay2/d/ffi.d"
	L58_:;
	# line 224 "../../../../Macaulay2/d/ffi.d"
	tmp__66 = tmp__65;
	# line 224 "../../../../Macaulay2/d/ffi.d"
	goto L59_;
	# line 224 "../../../../Macaulay2/d/ffi.d"
	L54_:;
	# line 222 "../../../../Macaulay2/d/ffi.d"
	tmp__66 = toExpr_3(&ffi_type_sint16);
	# line 222 "../../../../Macaulay2/d/ffi.d"
	L59_:;
	# line 222 "../../../../Macaulay2/d/ffi.d"
	tmp__67 = tmp__66;
	# line 222 "../../../../Macaulay2/d/ffi.d"
	goto L60_;
	# line 222 "../../../../Macaulay2/d/ffi.d"
	L53_:;
	# line 220 "../../../../Macaulay2/d/ffi.d"
	tmp__67 = toExpr_3(&ffi_type_sint8);
	# line 220 "../../../../Macaulay2/d/ffi.d"
	L60_:;
	# line 220 "../../../../Macaulay2/d/ffi.d"
	tmp__63 = tmp__67;
	# line 220 "../../../../Macaulay2/d/ffi.d"
	L52_:;
	# line 220 "../../../../Macaulay2/d/ffi.d"
	tmp__68 = tmp__63;
	# line 220 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 220 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 239 "../../../../Macaulay2/d/ffi.d"
	tmp__68 = expr_WrongArgBoolean_1(2);
	# line 239 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 239 "../../../../Macaulay2/d/ffi.d"
	};
      # line 239 "../../../../Macaulay2/d/ffi.d"
      tmp__69 = tmp__68;
      # line 239 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 239 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 240 "../../../../Macaulay2/d/ffi.d"
      tmp__69 = expr_WrongArgZZ_1(1);
      # line 240 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 240 "../../../../Macaulay2/d/ffi.d"
      };
    # line 240 "../../../../Macaulay2/d/ffi.d"
    tmp__56 = tmp__69;
    # line 240 "../../../../Macaulay2/d/ffi.d"
    L42_:;
    # line 240 "../../../../Macaulay2/d/ffi.d"
    tmp__70 = tmp__56;
    # line 240 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 240 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 242 "../../../../Macaulay2/d/ffi.d"
    tmp__70 = expr_WrongNumArgs_1(2);
    # line 242 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 242 "../../../../Macaulay2/d/ffi.d"
    };
  # line 242 "../../../../Macaulay2/d/ffi.d"
  return tmp__70;
  # line 242 "../../../../Macaulay2/d/ffi.d"
  }
# line 242 "../../../../Macaulay2/d/ffi.d"
static M2_string str__20;
# line 242 "../../../../Macaulay2/d/ffi.d"
static M2_string str__21;
# line 242 "../../../../Macaulay2/d/ffi.d"
static M2_string str__22;
# line 246 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiIntegerAddress(parse_Expr e){
  # line 246 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_5;
  # line 246 "../../../../Macaulay2/d/ffi.d"
  gmp_ZZcell x_5;
  # line 246 "../../../../Macaulay2/d/ffi.d"
  gmp_ZZcell y_4;
  # line 246 "../../../../Macaulay2/d/ffi.d"
  parse_Boolean signed_2;
  # line 246 "../../../../Macaulay2/d/ffi.d"
  int bits_1;
  # line 246 "../../../../Macaulay2/d/ffi.d"
  void * ptr_1;
  # line 246 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__71;
  # line 246 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__72;
  # line 246 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__73;
  # line 246 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__74;
  # line 246 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__75;
  # line 246 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__76;
  # line 246 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__77;
  # line 246 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__78;
  # line 246 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__79;
  # line 246 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__80;
  # line 246 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__81;
  # line 246 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 246 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 246 "../../../../Macaulay2/d/ffi.d"
    a_5 = ((parse_Sequence)e);
    # line 248 "../../../../Macaulay2/d/ffi.d"
    if ((a_5->len == 3)) goto L61_;
    # line 292 "../../../../Macaulay2/d/ffi.d"
    tmp__71 = expr_WrongNumArgs_1(3);
    # line 292 "../../../../Macaulay2/d/ffi.d"
    goto L62_;
    # line 292 "../../../../Macaulay2/d/ffi.d"
    L61_:;
    # line 249 "../../../../Macaulay2/d/ffi.d"
    tmp__72 = a_5->array[0];
    # line 249 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__72->type_) {;
      # line 249 "../../../../Macaulay2/d/ffi.d"
      case 3:;
      # line 249 "../../../../Macaulay2/d/ffi.d"
      x_5 = ((gmp_ZZcell)tmp__72);
      # line 251 "../../../../Macaulay2/d/ffi.d"
      tmp__73 = a_5->array[1];
      # line 251 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__73->type_) {;
	# line 251 "../../../../Macaulay2/d/ffi.d"
	case 3:;
	# line 251 "../../../../Macaulay2/d/ffi.d"
	y_4 = ((gmp_ZZcell)tmp__73);
	# line 253 "../../../../Macaulay2/d/ffi.d"
	tmp__74 = a_5->array[2];
	# line 253 "../../../../Macaulay2/d/ffi.d"
	switch (tmp__74->type_) {;
	  # line 253 "../../../../Macaulay2/d/ffi.d"
	  case 5:;
	  # line 253 "../../../../Macaulay2/d/ffi.d"
	  signed_2 = ((parse_Boolean)tmp__74);
	  # line 255 "../../../../Macaulay2/d/ffi.d"
	  bits_1 = gmp_toInt_1(y_4);
	  # line 256 "../../../../Macaulay2/d/ffi.d"
	  ptr_1 = getMemAtomic((bits_1 / 8));
	  # line 257 "../../../../Macaulay2/d/ffi.d"
	  if (signed_2->v) goto L63_;
	  # line 274 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_1 == 8)) goto L64_;
	  # line 277 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_1 == 16)) goto L65_;
	  # line 280 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_1 == 32)) goto L66_;
	  # line 283 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_1 == 64)) goto L67_;
	  # line 286 "../../../../Macaulay2/d/ffi.d"
	  tmp__75 = expr_buildErrorPacket(str__21);
	  # line 286 "../../../../Macaulay2/d/ffi.d"
	  return tmp__75;
	  # line 286 "../../../../Macaulay2/d/ffi.d"
	  L67_:;
	  # line 284 "../../../../Macaulay2/d/ffi.d"
	  *(uint64_t *)ptr_1 = gmp_toUInt64_1(x_5);
	  # line 285 "../../../../Macaulay2/d/ffi.d"
	  goto L68_;
	  # line 285 "../../../../Macaulay2/d/ffi.d"
	  L66_:;
	  # line 281 "../../../../Macaulay2/d/ffi.d"
	  *(uint32_t *)ptr_1 = gmp_toULong_1(x_5);
	  # line 282 "../../../../Macaulay2/d/ffi.d"
	  L68_:;
	  # line 282 "../../../../Macaulay2/d/ffi.d"
	  goto L69_;
	  # line 282 "../../../../Macaulay2/d/ffi.d"
	  L65_:;
	  # line 278 "../../../../Macaulay2/d/ffi.d"
	  *(uint16_t *)ptr_1 = gmp_toUInt_1(x_5);
	  # line 279 "../../../../Macaulay2/d/ffi.d"
	  L69_:;
	  # line 279 "../../../../Macaulay2/d/ffi.d"
	  goto L70_;
	  # line 279 "../../../../Macaulay2/d/ffi.d"
	  L64_:;
	  # line 275 "../../../../Macaulay2/d/ffi.d"
	  *(uint8_t *)ptr_1 = gmp_toUInt_1(x_5);
	  # line 276 "../../../../Macaulay2/d/ffi.d"
	  L70_:;
	  # line 288 "../../../../Macaulay2/d/ffi.d"
	  tmp__76 = toExpr_3(ptr_1);
	  # line 288 "../../../../Macaulay2/d/ffi.d"
	  goto L71_;
	  # line 288 "../../../../Macaulay2/d/ffi.d"
	  L63_:;
	  # line 258 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_1 == 8)) goto L72_;
	  # line 261 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_1 == 16)) goto L73_;
	  # line 264 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_1 == 32)) goto L74_;
	  # line 267 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_1 == 64)) goto L75_;
	  # line 270 "../../../../Macaulay2/d/ffi.d"
	  tmp__77 = expr_buildErrorPacket(str__22);
	  # line 270 "../../../../Macaulay2/d/ffi.d"
	  return tmp__77;
	  # line 270 "../../../../Macaulay2/d/ffi.d"
	  L75_:;
	  # line 268 "../../../../Macaulay2/d/ffi.d"
	  *(int64_t *)ptr_1 = gmp_toInt64_1(x_5);
	  # line 269 "../../../../Macaulay2/d/ffi.d"
	  goto L76_;
	  # line 269 "../../../../Macaulay2/d/ffi.d"
	  L74_:;
	  # line 265 "../../../../Macaulay2/d/ffi.d"
	  *(int32_t *)ptr_1 = gmp_toLong_1(x_5);
	  # line 266 "../../../../Macaulay2/d/ffi.d"
	  L76_:;
	  # line 266 "../../../../Macaulay2/d/ffi.d"
	  goto L77_;
	  # line 266 "../../../../Macaulay2/d/ffi.d"
	  L73_:;
	  # line 262 "../../../../Macaulay2/d/ffi.d"
	  *(int16_t *)ptr_1 = gmp_toInt_1(x_5);
	  # line 263 "../../../../Macaulay2/d/ffi.d"
	  L77_:;
	  # line 263 "../../../../Macaulay2/d/ffi.d"
	  goto L78_;
	  # line 263 "../../../../Macaulay2/d/ffi.d"
	  L72_:;
	  # line 259 "../../../../Macaulay2/d/ffi.d"
	  *(int8_t *)ptr_1 = gmp_toInt_1(x_5);
	  # line 260 "../../../../Macaulay2/d/ffi.d"
	  L78_:;
	  # line 272 "../../../../Macaulay2/d/ffi.d"
	  tmp__76 = toExpr_3(ptr_1);
	  # line 272 "../../../../Macaulay2/d/ffi.d"
	  L71_:;
	  # line 272 "../../../../Macaulay2/d/ffi.d"
	  tmp__78 = tmp__76;
	  # line 272 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 272 "../../../../Macaulay2/d/ffi.d"
	  default:;
	  # line 289 "../../../../Macaulay2/d/ffi.d"
	  tmp__78 = expr_WrongArgBoolean_1(3);
	  # line 289 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 289 "../../../../Macaulay2/d/ffi.d"
	  };
	# line 289 "../../../../Macaulay2/d/ffi.d"
	tmp__79 = tmp__78;
	# line 289 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 289 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 290 "../../../../Macaulay2/d/ffi.d"
	tmp__79 = expr_WrongArgZZ_1(2);
	# line 290 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 290 "../../../../Macaulay2/d/ffi.d"
	};
      # line 290 "../../../../Macaulay2/d/ffi.d"
      tmp__80 = tmp__79;
      # line 290 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 290 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 291 "../../../../Macaulay2/d/ffi.d"
      tmp__80 = expr_WrongArgZZ_1(1);
      # line 291 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 291 "../../../../Macaulay2/d/ffi.d"
      };
    # line 291 "../../../../Macaulay2/d/ffi.d"
    tmp__71 = tmp__80;
    # line 291 "../../../../Macaulay2/d/ffi.d"
    L62_:;
    # line 291 "../../../../Macaulay2/d/ffi.d"
    tmp__81 = tmp__71;
    # line 291 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 291 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 293 "../../../../Macaulay2/d/ffi.d"
    tmp__81 = expr_WrongNumArgs_1(3);
    # line 293 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 293 "../../../../Macaulay2/d/ffi.d"
    };
  # line 293 "../../../../Macaulay2/d/ffi.d"
  return tmp__81;
  # line 293 "../../../../Macaulay2/d/ffi.d"
  }
# line 293 "../../../../Macaulay2/d/ffi.d"
static M2_string str__23;
# line 293 "../../../../Macaulay2/d/ffi.d"
static M2_string str__24;
# line 293 "../../../../Macaulay2/d/ffi.d"
static M2_string str__25;
# line 297 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiIntegerValue(parse_Expr e){
  # line 297 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_6;
  # line 297 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_6;
  # line 297 "../../../../Macaulay2/d/ffi.d"
  gmp_ZZcell y_5;
  # line 297 "../../../../Macaulay2/d/ffi.d"
  parse_Boolean signed_3;
  # line 297 "../../../../Macaulay2/d/ffi.d"
  int bits_2;
  # line 297 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__82;
  # line 297 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__83;
  # line 297 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__84;
  # line 297 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__85;
  # line 297 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__86;
  # line 297 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__87;
  # line 297 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__88;
  # line 297 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__89;
  # line 297 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__90;
  # line 297 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__91;
  # line 297 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__92;
  # line 297 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__93;
  # line 297 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__94;
  # line 297 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__95;
  # line 297 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__96;
  # line 297 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__97;
  # line 297 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__98;
  # line 297 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 297 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 297 "../../../../Macaulay2/d/ffi.d"
    a_6 = ((parse_Sequence)e);
    # line 299 "../../../../Macaulay2/d/ffi.d"
    if ((a_6->len == 3)) goto L79_;
    # line 332 "../../../../Macaulay2/d/ffi.d"
    tmp__82 = expr_WrongNumArgs_1(3);
    # line 332 "../../../../Macaulay2/d/ffi.d"
    goto L80_;
    # line 332 "../../../../Macaulay2/d/ffi.d"
    L79_:;
    # line 300 "../../../../Macaulay2/d/ffi.d"
    tmp__83 = a_6->array[0];
    # line 300 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__83->type_) {;
      # line 300 "../../../../Macaulay2/d/ffi.d"
      case 81:;
      # line 300 "../../../../Macaulay2/d/ffi.d"
      x_6 = ((parse_pointerCell)tmp__83);
      # line 302 "../../../../Macaulay2/d/ffi.d"
      tmp__84 = a_6->array[1];
      # line 302 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__84->type_) {;
	# line 302 "../../../../Macaulay2/d/ffi.d"
	case 3:;
	# line 302 "../../../../Macaulay2/d/ffi.d"
	y_5 = ((gmp_ZZcell)tmp__84);
	# line 304 "../../../../Macaulay2/d/ffi.d"
	tmp__85 = a_6->array[2];
	# line 304 "../../../../Macaulay2/d/ffi.d"
	switch (tmp__85->type_) {;
	  # line 304 "../../../../Macaulay2/d/ffi.d"
	  case 5:;
	  # line 304 "../../../../Macaulay2/d/ffi.d"
	  signed_3 = ((parse_Boolean)tmp__85);
	  # line 306 "../../../../Macaulay2/d/ffi.d"
	  bits_2 = gmp_toInt_1(y_5);
	  # line 307 "../../../../Macaulay2/d/ffi.d"
	  if (signed_3->v) goto L81_;
	  # line 319 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_2 == 8)) goto L82_;
	  # line 321 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_2 == 16)) goto L83_;
	  # line 323 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_2 == 32)) goto L84_;
	  # line 325 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_2 == 64)) goto L85_;
	  # line 327 "../../../../Macaulay2/d/ffi.d"
	  tmp__86 = expr_buildErrorPacket(str__24);
	  # line 327 "../../../../Macaulay2/d/ffi.d"
	  goto L86_;
	  # line 327 "../../../../Macaulay2/d/ffi.d"
	  L85_:;
	  # line 326 "../../../../Macaulay2/d/ffi.d"
	  tmp__86 = util_toExpr_11(*(uint64_t *)x_6->v);
	  # line 326 "../../../../Macaulay2/d/ffi.d"
	  L86_:;
	  # line 326 "../../../../Macaulay2/d/ffi.d"
	  tmp__87 = tmp__86;
	  # line 326 "../../../../Macaulay2/d/ffi.d"
	  goto L87_;
	  # line 326 "../../../../Macaulay2/d/ffi.d"
	  L84_:;
	  # line 324 "../../../../Macaulay2/d/ffi.d"
	  tmp__87 = util_toExpr_9(*(uint32_t *)x_6->v);
	  # line 324 "../../../../Macaulay2/d/ffi.d"
	  L87_:;
	  # line 324 "../../../../Macaulay2/d/ffi.d"
	  tmp__88 = tmp__87;
	  # line 324 "../../../../Macaulay2/d/ffi.d"
	  goto L88_;
	  # line 324 "../../../../Macaulay2/d/ffi.d"
	  L83_:;
	  # line 322 "../../../../Macaulay2/d/ffi.d"
	  tmp__88 = util_toExpr_7(*(uint16_t *)x_6->v);
	  # line 322 "../../../../Macaulay2/d/ffi.d"
	  L88_:;
	  # line 322 "../../../../Macaulay2/d/ffi.d"
	  tmp__89 = tmp__88;
	  # line 322 "../../../../Macaulay2/d/ffi.d"
	  goto L89_;
	  # line 322 "../../../../Macaulay2/d/ffi.d"
	  L82_:;
	  # line 320 "../../../../Macaulay2/d/ffi.d"
	  tmp__89 = util_toExpr_5(*(uint8_t *)x_6->v);
	  # line 320 "../../../../Macaulay2/d/ffi.d"
	  L89_:;
	  # line 320 "../../../../Macaulay2/d/ffi.d"
	  tmp__90 = tmp__89;
	  # line 320 "../../../../Macaulay2/d/ffi.d"
	  goto L90_;
	  # line 320 "../../../../Macaulay2/d/ffi.d"
	  L81_:;
	  # line 308 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_2 == 8)) goto L91_;
	  # line 310 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_2 == 16)) goto L92_;
	  # line 312 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_2 == 32)) goto L93_;
	  # line 314 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_2 == 64)) goto L94_;
	  # line 316 "../../../../Macaulay2/d/ffi.d"
	  tmp__91 = expr_buildErrorPacket(str__25);
	  # line 316 "../../../../Macaulay2/d/ffi.d"
	  goto L95_;
	  # line 316 "../../../../Macaulay2/d/ffi.d"
	  L94_:;
	  # line 315 "../../../../Macaulay2/d/ffi.d"
	  tmp__91 = util_toExpr_10(*(int64_t *)x_6->v);
	  # line 315 "../../../../Macaulay2/d/ffi.d"
	  L95_:;
	  # line 315 "../../../../Macaulay2/d/ffi.d"
	  tmp__92 = tmp__91;
	  # line 315 "../../../../Macaulay2/d/ffi.d"
	  goto L96_;
	  # line 315 "../../../../Macaulay2/d/ffi.d"
	  L93_:;
	  # line 313 "../../../../Macaulay2/d/ffi.d"
	  tmp__92 = util_toExpr_8(*(int32_t *)x_6->v);
	  # line 313 "../../../../Macaulay2/d/ffi.d"
	  L96_:;
	  # line 313 "../../../../Macaulay2/d/ffi.d"
	  tmp__93 = tmp__92;
	  # line 313 "../../../../Macaulay2/d/ffi.d"
	  goto L97_;
	  # line 313 "../../../../Macaulay2/d/ffi.d"
	  L92_:;
	  # line 311 "../../../../Macaulay2/d/ffi.d"
	  tmp__93 = util_toExpr_6(*(int16_t *)x_6->v);
	  # line 311 "../../../../Macaulay2/d/ffi.d"
	  L97_:;
	  # line 311 "../../../../Macaulay2/d/ffi.d"
	  tmp__94 = tmp__93;
	  # line 311 "../../../../Macaulay2/d/ffi.d"
	  goto L98_;
	  # line 311 "../../../../Macaulay2/d/ffi.d"
	  L91_:;
	  # line 309 "../../../../Macaulay2/d/ffi.d"
	  tmp__94 = util_toExpr_4(*(int8_t *)x_6->v);
	  # line 309 "../../../../Macaulay2/d/ffi.d"
	  L98_:;
	  # line 309 "../../../../Macaulay2/d/ffi.d"
	  tmp__90 = tmp__94;
	  # line 309 "../../../../Macaulay2/d/ffi.d"
	  L90_:;
	  # line 309 "../../../../Macaulay2/d/ffi.d"
	  tmp__95 = tmp__90;
	  # line 309 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 309 "../../../../Macaulay2/d/ffi.d"
	  default:;
	  # line 329 "../../../../Macaulay2/d/ffi.d"
	  tmp__95 = expr_WrongArgBoolean_1(3);
	  # line 329 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 329 "../../../../Macaulay2/d/ffi.d"
	  };
	# line 329 "../../../../Macaulay2/d/ffi.d"
	tmp__96 = tmp__95;
	# line 329 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 329 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 330 "../../../../Macaulay2/d/ffi.d"
	tmp__96 = expr_WrongArgZZ_1(2);
	# line 330 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 330 "../../../../Macaulay2/d/ffi.d"
	};
      # line 330 "../../../../Macaulay2/d/ffi.d"
      tmp__97 = tmp__96;
      # line 330 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 330 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 331 "../../../../Macaulay2/d/ffi.d"
      tmp__97 = WrongArgPointer_1(1);
      # line 331 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 331 "../../../../Macaulay2/d/ffi.d"
      };
    # line 331 "../../../../Macaulay2/d/ffi.d"
    tmp__82 = tmp__97;
    # line 331 "../../../../Macaulay2/d/ffi.d"
    L80_:;
    # line 331 "../../../../Macaulay2/d/ffi.d"
    tmp__98 = tmp__82;
    # line 331 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 331 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 333 "../../../../Macaulay2/d/ffi.d"
    tmp__98 = expr_WrongNumArgs_1(3);
    # line 333 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 333 "../../../../Macaulay2/d/ffi.d"
    };
  # line 333 "../../../../Macaulay2/d/ffi.d"
  return tmp__98;
  # line 333 "../../../../Macaulay2/d/ffi.d"
  }
# line 333 "../../../../Macaulay2/d/ffi.d"
static M2_string str__26;
# line 333 "../../../../Macaulay2/d/ffi.d"
static M2_string str__27;
# line 341 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiRealType(parse_Expr e){
  # line 341 "../../../../Macaulay2/d/ffi.d"
  gmp_ZZcell n_4;
  # line 341 "../../../../Macaulay2/d/ffi.d"
  int bits_3;
  # line 341 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__99;
  # line 341 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__100;
  # line 341 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__101;
  # line 341 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 341 "../../../../Macaulay2/d/ffi.d"
    case 3:;
    # line 341 "../../../../Macaulay2/d/ffi.d"
    n_4 = ((gmp_ZZcell)e);
    # line 343 "../../../../Macaulay2/d/ffi.d"
    bits_3 = gmp_toInt_1(n_4);
    # line 344 "../../../../Macaulay2/d/ffi.d"
    if ((bits_3 == 32)) goto L99_;
    # line 345 "../../../../Macaulay2/d/ffi.d"
    if ((bits_3 == 64)) goto L100_;
    # line 346 "../../../../Macaulay2/d/ffi.d"
    tmp__99 = expr_buildErrorPacket(str__27);
    # line 346 "../../../../Macaulay2/d/ffi.d"
    goto L101_;
    # line 346 "../../../../Macaulay2/d/ffi.d"
    L100_:;
    # line 345 "../../../../Macaulay2/d/ffi.d"
    tmp__99 = toExpr_3(&ffi_type_double);
    # line 345 "../../../../Macaulay2/d/ffi.d"
    L101_:;
    # line 345 "../../../../Macaulay2/d/ffi.d"
    tmp__100 = tmp__99;
    # line 345 "../../../../Macaulay2/d/ffi.d"
    goto L102_;
    # line 345 "../../../../Macaulay2/d/ffi.d"
    L99_:;
    # line 344 "../../../../Macaulay2/d/ffi.d"
    tmp__100 = toExpr_3(&ffi_type_float);
    # line 344 "../../../../Macaulay2/d/ffi.d"
    L102_:;
    # line 344 "../../../../Macaulay2/d/ffi.d"
    tmp__101 = tmp__100;
    # line 344 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 344 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 347 "../../../../Macaulay2/d/ffi.d"
    tmp__101 = expr_WrongArgZZ();
    # line 347 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 347 "../../../../Macaulay2/d/ffi.d"
    };
  # line 347 "../../../../Macaulay2/d/ffi.d"
  return tmp__101;
  # line 347 "../../../../Macaulay2/d/ffi.d"
  }
# line 347 "../../../../Macaulay2/d/ffi.d"
static M2_string str__28;
# line 347 "../../../../Macaulay2/d/ffi.d"
static M2_string str__29;
# line 351 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiRealAddress(parse_Expr e){
  # line 351 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_7;
  # line 351 "../../../../Macaulay2/d/ffi.d"
  gmp_RRcell x_7;
  # line 351 "../../../../Macaulay2/d/ffi.d"
  gmp_ZZcell y_6;
  # line 351 "../../../../Macaulay2/d/ffi.d"
  int bits_4;
  # line 351 "../../../../Macaulay2/d/ffi.d"
  void * ptr_2;
  # line 351 "../../../../Macaulay2/d/ffi.d"
  double z_3;
  # line 351 "../../../../Macaulay2/d/ffi.d"
  float z_4;
  # line 351 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__102;
  # line 351 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__103;
  # line 351 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__104;
  # line 351 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__105;
  # line 351 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__106;
  # line 351 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__107;
  # line 351 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__108;
  # line 351 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 351 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 351 "../../../../Macaulay2/d/ffi.d"
    a_7 = ((parse_Sequence)e);
    # line 353 "../../../../Macaulay2/d/ffi.d"
    if ((a_7->len == 2)) goto L103_;
    # line 372 "../../../../Macaulay2/d/ffi.d"
    tmp__102 = expr_WrongNumArgs_1(2);
    # line 372 "../../../../Macaulay2/d/ffi.d"
    goto L104_;
    # line 372 "../../../../Macaulay2/d/ffi.d"
    L103_:;
    # line 354 "../../../../Macaulay2/d/ffi.d"
    tmp__103 = a_7->array[0];
    # line 354 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__103->type_) {;
      # line 354 "../../../../Macaulay2/d/ffi.d"
      case 51:;
      # line 354 "../../../../Macaulay2/d/ffi.d"
      x_7 = ((gmp_RRcell)tmp__103);
      # line 356 "../../../../Macaulay2/d/ffi.d"
      tmp__104 = a_7->array[1];
      # line 356 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__104->type_) {;
	# line 356 "../../../../Macaulay2/d/ffi.d"
	case 3:;
	# line 356 "../../../../Macaulay2/d/ffi.d"
	y_6 = ((gmp_ZZcell)tmp__104);
	# line 358 "../../../../Macaulay2/d/ffi.d"
	bits_4 = gmp_toInt_1(y_6);
	# line 359 "../../../../Macaulay2/d/ffi.d"
	ptr_2 = getMemAtomic((bits_4 / 8));
	# line 360 "../../../../Macaulay2/d/ffi.d"
	if ((bits_4 == 32)) goto L105_;
	# line 364 "../../../../Macaulay2/d/ffi.d"
	if ((bits_4 == 64)) goto L106_;
	# line 368 "../../../../Macaulay2/d/ffi.d"
	tmp__105 = expr_buildErrorPacket(str__29);
	# line 368 "../../../../Macaulay2/d/ffi.d"
	return tmp__105;
	# line 368 "../../../../Macaulay2/d/ffi.d"
	L106_:;
	# line 366 "../../../../Macaulay2/d/ffi.d"
	z_3 = gmp_toDouble_5(x_7);
	# line 367 "../../../../Macaulay2/d/ffi.d"
	*(double *)ptr_2 = z_3;
	# line 367 "../../../../Macaulay2/d/ffi.d"
	goto L107_;
	# line 367 "../../../../Macaulay2/d/ffi.d"
	L105_:;
	# line 362 "../../../../Macaulay2/d/ffi.d"
	z_4 = gmp_toFloat_2(x_7);
	# line 363 "../../../../Macaulay2/d/ffi.d"
	*(float *)ptr_2 = z_4;
	# line 363 "../../../../Macaulay2/d/ffi.d"
	L107_:;
	# line 369 "../../../../Macaulay2/d/ffi.d"
	tmp__106 = toExpr_3(ptr_2);
	# line 369 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 369 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 370 "../../../../Macaulay2/d/ffi.d"
	tmp__106 = expr_WrongArgZZ_1(2);
	# line 370 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 370 "../../../../Macaulay2/d/ffi.d"
	};
      # line 370 "../../../../Macaulay2/d/ffi.d"
      tmp__107 = tmp__106;
      # line 370 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 370 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 371 "../../../../Macaulay2/d/ffi.d"
      tmp__107 = expr_WrongArgRR_1(1);
      # line 371 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 371 "../../../../Macaulay2/d/ffi.d"
      };
    # line 371 "../../../../Macaulay2/d/ffi.d"
    tmp__102 = tmp__107;
    # line 371 "../../../../Macaulay2/d/ffi.d"
    L104_:;
    # line 371 "../../../../Macaulay2/d/ffi.d"
    tmp__108 = tmp__102;
    # line 371 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 371 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 373 "../../../../Macaulay2/d/ffi.d"
    tmp__108 = expr_WrongNumArgs_1(2);
    # line 373 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 373 "../../../../Macaulay2/d/ffi.d"
    };
  # line 373 "../../../../Macaulay2/d/ffi.d"
  return tmp__108;
  # line 373 "../../../../Macaulay2/d/ffi.d"
  }
# line 373 "../../../../Macaulay2/d/ffi.d"
static M2_string str__30;
# line 373 "../../../../Macaulay2/d/ffi.d"
static M2_string str__31;
# line 377 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiRealValue(parse_Expr e){
  # line 377 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_8;
  # line 377 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_8;
  # line 377 "../../../../Macaulay2/d/ffi.d"
  gmp_ZZcell y_7;
  # line 377 "../../../../Macaulay2/d/ffi.d"
  int bits_5;
  # line 377 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__109;
  # line 377 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__110;
  # line 377 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__111;
  # line 377 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__112;
  # line 377 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__113;
  # line 377 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__114;
  # line 377 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__115;
  # line 377 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__116;
  # line 377 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 377 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 377 "../../../../Macaulay2/d/ffi.d"
    a_8 = ((parse_Sequence)e);
    # line 379 "../../../../Macaulay2/d/ffi.d"
    if ((a_8->len == 2)) goto L108_;
    # line 392 "../../../../Macaulay2/d/ffi.d"
    tmp__109 = expr_WrongNumArgs_1(2);
    # line 392 "../../../../Macaulay2/d/ffi.d"
    goto L109_;
    # line 392 "../../../../Macaulay2/d/ffi.d"
    L108_:;
    # line 380 "../../../../Macaulay2/d/ffi.d"
    tmp__110 = a_8->array[0];
    # line 380 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__110->type_) {;
      # line 380 "../../../../Macaulay2/d/ffi.d"
      case 81:;
      # line 380 "../../../../Macaulay2/d/ffi.d"
      x_8 = ((parse_pointerCell)tmp__110);
      # line 382 "../../../../Macaulay2/d/ffi.d"
      tmp__111 = a_8->array[1];
      # line 382 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__111->type_) {;
	# line 382 "../../../../Macaulay2/d/ffi.d"
	case 3:;
	# line 382 "../../../../Macaulay2/d/ffi.d"
	y_7 = ((gmp_ZZcell)tmp__111);
	# line 384 "../../../../Macaulay2/d/ffi.d"
	bits_5 = gmp_toInt_1(y_7);
	# line 385 "../../../../Macaulay2/d/ffi.d"
	if ((bits_5 == 32)) goto L110_;
	# line 387 "../../../../Macaulay2/d/ffi.d"
	if ((bits_5 == 64)) goto L111_;
	# line 389 "../../../../Macaulay2/d/ffi.d"
	tmp__112 = expr_buildErrorPacket(str__31);
	# line 389 "../../../../Macaulay2/d/ffi.d"
	goto L112_;
	# line 389 "../../../../Macaulay2/d/ffi.d"
	L111_:;
	# line 388 "../../../../Macaulay2/d/ffi.d"
	tmp__112 = util_toExpr_19(*(double *)x_8->v);
	# line 388 "../../../../Macaulay2/d/ffi.d"
	L112_:;
	# line 388 "../../../../Macaulay2/d/ffi.d"
	tmp__113 = tmp__112;
	# line 388 "../../../../Macaulay2/d/ffi.d"
	goto L113_;
	# line 388 "../../../../Macaulay2/d/ffi.d"
	L110_:;
	# line 386 "../../../../Macaulay2/d/ffi.d"
	tmp__113 = util_toExpr_18(*(float *)x_8->v);
	# line 386 "../../../../Macaulay2/d/ffi.d"
	L113_:;
	# line 386 "../../../../Macaulay2/d/ffi.d"
	tmp__114 = tmp__113;
	# line 386 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 386 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 390 "../../../../Macaulay2/d/ffi.d"
	tmp__114 = expr_WrongArgZZ_1(2);
	# line 390 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 390 "../../../../Macaulay2/d/ffi.d"
	};
      # line 390 "../../../../Macaulay2/d/ffi.d"
      tmp__115 = tmp__114;
      # line 390 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 390 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 391 "../../../../Macaulay2/d/ffi.d"
      tmp__115 = WrongArgPointer_1(1);
      # line 391 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 391 "../../../../Macaulay2/d/ffi.d"
      };
    # line 391 "../../../../Macaulay2/d/ffi.d"
    tmp__109 = tmp__115;
    # line 391 "../../../../Macaulay2/d/ffi.d"
    L109_:;
    # line 391 "../../../../Macaulay2/d/ffi.d"
    tmp__116 = tmp__109;
    # line 391 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 391 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 393 "../../../../Macaulay2/d/ffi.d"
    tmp__116 = expr_WrongNumArgs_1(2);
    # line 393 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 393 "../../../../Macaulay2/d/ffi.d"
    };
  # line 393 "../../../../Macaulay2/d/ffi.d"
  return tmp__116;
  # line 393 "../../../../Macaulay2/d/ffi.d"
  }
# line 393 "../../../../Macaulay2/d/ffi.d"
static M2_string str__32;
# line 393 "../../../../Macaulay2/d/ffi.d"
static int pointerSize;
# line 393 "../../../../Macaulay2/d/ffi.d"
static M2_string str__33;
# line 393 "../../../../Macaulay2/d/ffi.d"
static M2_string str__34;
# line 393 "../../../../Macaulay2/d/ffi.d"
static M2_string str__35;
# line 393 "../../../../Macaulay2/d/ffi.d"
static M2_string str__36;
# line 405 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiPointerAddress(parse_Expr e){
  # line 405 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_9;
  # line 405 "../../../../Macaulay2/d/ffi.d"
  void * y_8;
  # line 405 "../../../../Macaulay2/d/ffi.d"
  M2_stringCell x_10;
  # line 405 "../../../../Macaulay2/d/ffi.d"
  void * y_9;
  # line 405 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_9;
  # line 405 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_11;
  # line 405 "../../../../Macaulay2/d/ffi.d"
  parse_List y_10;
  # line 405 "../../../../Macaulay2/d/ffi.d"
  int n_5;
  # line 405 "../../../../Macaulay2/d/ffi.d"
  int bytes;
  # line 405 "../../../../Macaulay2/d/ffi.d"
  void * arr;
  # line 405 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell z_5;
  # line 405 "../../../../Macaulay2/d/ffi.d"
  void * ptr_3;
  # line 405 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__117;
  # line 405 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__118;
  # line 405 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__119;
  # line 405 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__120;
  # line 405 "../../../../Macaulay2/d/ffi.d"
  int i_3;
  # line 405 "../../../../Macaulay2/d/ffi.d"
  int tmp__121;
  # line 405 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__122;
  # line 405 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__123;
  # line 405 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__124;
  # line 405 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__125;
  # line 405 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 405 "../../../../Macaulay2/d/ffi.d"
    case 81:;
    # line 405 "../../../../Macaulay2/d/ffi.d"
    x_9 = ((parse_pointerCell)e);
    # line 407 "../../../../Macaulay2/d/ffi.d"
    y_8 = getMem(pointerSize);
    # line 408 "../../../../Macaulay2/d/ffi.d"
    *(void **)y_8 = x_9->v;
    # line 409 "../../../../Macaulay2/d/ffi.d"
    tmp__117 = toExpr_3(y_8);
    # line 409 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 409 "../../../../Macaulay2/d/ffi.d"
    case 18:;
    # line 405 "../../../../Macaulay2/d/ffi.d"
    x_10 = ((M2_stringCell)e);
    # line 411 "../../../../Macaulay2/d/ffi.d"
    y_9 = getMem(pointerSize);
    # line 412 "../../../../Macaulay2/d/ffi.d"
    *(void **)y_9 = M2_tocharstar(x_10->v);
    # line 413 "../../../../Macaulay2/d/ffi.d"
    tmp__117 = toExpr_3(y_9);
    # line 413 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 413 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 405 "../../../../Macaulay2/d/ffi.d"
    a_9 = ((parse_Sequence)e);
    # line 415 "../../../../Macaulay2/d/ffi.d"
    if ((a_9->len == 2)) goto L114_;
    # line 435 "../../../../Macaulay2/d/ffi.d"
    tmp__118 = expr_WrongNumArgs_3(1, 2);
    # line 435 "../../../../Macaulay2/d/ffi.d"
    goto L115_;
    # line 435 "../../../../Macaulay2/d/ffi.d"
    L114_:;
    # line 416 "../../../../Macaulay2/d/ffi.d"
    tmp__119 = a_9->array[0];
    # line 416 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__119->type_) {;
      # line 416 "../../../../Macaulay2/d/ffi.d"
      case 81:;
      # line 416 "../../../../Macaulay2/d/ffi.d"
      x_11 = ((parse_pointerCell)tmp__119);
      # line 418 "../../../../Macaulay2/d/ffi.d"
      tmp__120 = a_9->array[1];
      # line 418 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__120->type_) {;
	# line 418 "../../../../Macaulay2/d/ffi.d"
	case 45:;
	# line 418 "../../../../Macaulay2/d/ffi.d"
	y_10 = ((parse_List)tmp__120);
	# line 420 "../../../../Macaulay2/d/ffi.d"
	n_5 = y_10->v->len;
	# line 421 "../../../../Macaulay2/d/ffi.d"
	bytes = ((ffi_type *)x_11->v)->size;
	# line 422 "../../../../Macaulay2/d/ffi.d"
	arr = getMem((n_5 * bytes));
	# line 423 "../../../../Macaulay2/d/ffi.d"
	tmp__121 = (n_5 - 1);
	# line 423 "../../../../Macaulay2/d/ffi.d"
	i_3 = 0;
	# line 423 "../../../../Macaulay2/d/ffi.d"
	goto L118_;
	# line 423 "../../../../Macaulay2/d/ffi.d"
	L116_:;
	# line 423 "../../../../Macaulay2/d/ffi.d"
	i_3 = (i_3 + 1);
	# line 423 "../../../../Macaulay2/d/ffi.d"
	L118_:;
	# line 423 "../../../../Macaulay2/d/ffi.d"
	if ((((i_3 > tmp__121) && (1 >= 0)) || ((i_3 < tmp__121) && (1 < 0)))) goto L117_;
	# line 424 "../../../../Macaulay2/d/ffi.d"
	tmp__122 = y_10->v->array[i_3];
	# line 424 "../../../../Macaulay2/d/ffi.d"
	switch (tmp__122->type_) {;
	  # line 424 "../../../../Macaulay2/d/ffi.d"
	  case 81:;
	  # line 424 "../../../../Macaulay2/d/ffi.d"
	  z_5 = ((parse_pointerCell)tmp__122);
	  # line 425 "../../../../Macaulay2/d/ffi.d"
	  memcpy(arr + (i_3 * bytes), z_5->v, bytes);
	  # line 427 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 427 "../../../../Macaulay2/d/ffi.d"
	  default:;
	  # line 428 "../../../../Macaulay2/d/ffi.d"
	  tmp__123 = expr_buildErrorPacket(str__34);
	  # line 428 "../../../../Macaulay2/d/ffi.d"
	  return tmp__123;
	  # line 428 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 428 "../../../../Macaulay2/d/ffi.d"
	  };
	# line 428 "../../../../Macaulay2/d/ffi.d"
	goto L116_;
	# line 428 "../../../../Macaulay2/d/ffi.d"
	L117_:;
	# line 430 "../../../../Macaulay2/d/ffi.d"
	ptr_3 = getMem(pointerSize);
	# line 431 "../../../../Macaulay2/d/ffi.d"
	*(void **)ptr_3 = arr;
	# line 432 "../../../../Macaulay2/d/ffi.d"
	tmp__124 = toExpr_3(ptr_3);
	# line 432 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 432 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 433 "../../../../Macaulay2/d/ffi.d"
	tmp__124 = expr_WrongArg_1(2, str__35);
	# line 433 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 433 "../../../../Macaulay2/d/ffi.d"
	};
      # line 433 "../../../../Macaulay2/d/ffi.d"
      tmp__125 = tmp__124;
      # line 433 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 433 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 434 "../../../../Macaulay2/d/ffi.d"
      tmp__125 = WrongArgPointer_1(1);
      # line 434 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 434 "../../../../Macaulay2/d/ffi.d"
      };
    # line 434 "../../../../Macaulay2/d/ffi.d"
    tmp__118 = tmp__125;
    # line 434 "../../../../Macaulay2/d/ffi.d"
    L115_:;
    # line 434 "../../../../Macaulay2/d/ffi.d"
    tmp__117 = tmp__118;
    # line 434 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 434 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 436 "../../../../Macaulay2/d/ffi.d"
    tmp__117 = expr_WrongArg(str__36);
    # line 436 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 436 "../../../../Macaulay2/d/ffi.d"
    };
  # line 436 "../../../../Macaulay2/d/ffi.d"
  return tmp__117;
  # line 436 "../../../../Macaulay2/d/ffi.d"
  }
# line 436 "../../../../Macaulay2/d/ffi.d"
static M2_string str__37;
# line 440 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiPointerValue(parse_Expr e){
  # line 440 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_12;
  # line 440 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__126;
  # line 440 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 440 "../../../../Macaulay2/d/ffi.d"
    case 81:;
    # line 440 "../../../../Macaulay2/d/ffi.d"
    x_12 = ((parse_pointerCell)e);
    # line 441 "../../../../Macaulay2/d/ffi.d"
    tmp__126 = toExpr_3(*(void **)x_12->v);
    # line 441 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 441 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 442 "../../../../Macaulay2/d/ffi.d"
    tmp__126 = WrongArgPointer();
    # line 442 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 442 "../../../../Macaulay2/d/ffi.d"
    };
  # line 442 "../../../../Macaulay2/d/ffi.d"
  return tmp__126;
  # line 442 "../../../../Macaulay2/d/ffi.d"
  }
# line 442 "../../../../Macaulay2/d/ffi.d"
static M2_string str__38;
# line 446 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiStringValue(parse_Expr e){
  # line 446 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_13;
  # line 446 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__127;
  # line 446 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 446 "../../../../Macaulay2/d/ffi.d"
    case 81:;
    # line 446 "../../../../Macaulay2/d/ffi.d"
    x_13 = ((parse_pointerCell)e);
    # line 447 "../../../../Macaulay2/d/ffi.d"
    tmp__127 = util_toExpr_12(M2_tostring_2(*(char **)x_13->v));
    # line 447 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 447 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 448 "../../../../Macaulay2/d/ffi.d"
    tmp__127 = WrongArgPointer();
    # line 448 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 448 "../../../../Macaulay2/d/ffi.d"
    };
  # line 448 "../../../../Macaulay2/d/ffi.d"
  return tmp__127;
  # line 448 "../../../../Macaulay2/d/ffi.d"
  }
# line 448 "../../../../Macaulay2/d/ffi.d"
static M2_string str__39;
# line 452 "../../../../Macaulay2/d/ffi.d"
static void ptrfinalizer(void * x,parse_Sequence a){
  # line 452 "../../../../Macaulay2/d/ffi.d"
  if ((a->len == 2)) goto L119_;
  # line 452 "../../../../Macaulay2/d/ffi.d"
  goto L120_;
  # line 452 "../../../../Macaulay2/d/ffi.d"
  L119_:;
  # line 453 "../../../../Macaulay2/d/ffi.d"
  evaluate_applyEE(a->array[0], a->array[1]);
  # line 453 "../../../../Macaulay2/d/ffi.d"
  L120_:;
  # line 453 "../../../../Macaulay2/d/ffi.d"
  }
# line 458 "../../../../Macaulay2/d/ffi.d"
static parse_Expr registerFinalizerForPointer(parse_Expr e){
  # line 458 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence s_1;
  # line 458 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_14;
  # line 458 "../../../../Macaulay2/d/ffi.d"
  int i_4;
  # line 458 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_10;
  # line 458 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__128;
  # line 458 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__129;
  # line 458 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence tmp__130;
  # line 458 "../../../../Macaulay2/d/ffi.d"
  int tmp__131;
  # line 458 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__132;
  # line 458 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__133;
  # line 458 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 458 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 458 "../../../../Macaulay2/d/ffi.d"
    s_1 = ((parse_Sequence)e);
    # line 459 "../../../../Macaulay2/d/ffi.d"
    if ((s_1->len == 3)) goto L121_;
    # line 467 "../../../../Macaulay2/d/ffi.d"
    tmp__128 = expr_WrongNumArgs_1(3);
    # line 467 "../../../../Macaulay2/d/ffi.d"
    goto L122_;
    # line 467 "../../../../Macaulay2/d/ffi.d"
    L121_:;
    # line 460 "../../../../Macaulay2/d/ffi.d"
    tmp__129 = s_1->array[0];
    # line 460 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__129->type_) {;
      # line 460 "../../../../Macaulay2/d/ffi.d"
      case 81:;
      # line 460 "../../../../Macaulay2/d/ffi.d"
      x_14 = ((parse_pointerCell)tmp__129);
      # line 460 "../../../../Macaulay2/d/ffi.d"
      i_4 = 0;
      # line 462 "../../../../Macaulay2/d/ffi.d"
      tmp__131 = 2;
      # line 462 "../../../../Macaulay2/d/ffi.d"
      ;
      # line 462 "../../../../Macaulay2/d/ffi.d"
      tmp__130 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (tmp__131)*sizeof(parse_Expr)-sizeof(parse_Expr));
      if (0 == tmp__130) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (tmp__131)*sizeof(parse_Expr)-sizeof(parse_Expr));
      # line 462 "../../../../Macaulay2/d/ffi.d"
      tmp__130->type_ = 7;
      # line 462 "../../../../Macaulay2/d/ffi.d"
      tmp__130->len = tmp__131;
      # line 462 "../../../../Macaulay2/d/ffi.d"
      if ((tmp__131 == 0)) goto L124_;
      # line 462 "../../../../Macaulay2/d/ffi.d"
      L123_:;
      # line 462 "../../../../Macaulay2/d/ffi.d"
      tmp__130->array[i_4] = s_1->array[(i_4 + 1)];
      # line 462 "../../../../Macaulay2/d/ffi.d"
      if (((++ i_4) < tmp__131)) goto L125_;
      # line 462 "../../../../Macaulay2/d/ffi.d"
      goto L124_;
      # line 462 "../../../../Macaulay2/d/ffi.d"
      L125_:;
      # line 462 "../../../../Macaulay2/d/ffi.d"
      goto L123_;
      # line 462 "../../../../Macaulay2/d/ffi.d"
      L124_:;
      # line 462 "../../../../Macaulay2/d/ffi.d"
      a_10 = tmp__130;
      # line 463 "../../../../Macaulay2/d/ffi.d"
      GC_REGISTER_FINALIZER(x_14->v, (GC_finalization_proc)ptrfinalizer, a_10, 0, 0);
      # line 465 "../../../../Macaulay2/d/ffi.d"
      tmp__132 = parse_nullE;
      # line 465 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 465 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 466 "../../../../Macaulay2/d/ffi.d"
      tmp__132 = WrongArgPointer_1(1);
      # line 466 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 466 "../../../../Macaulay2/d/ffi.d"
      };
    # line 466 "../../../../Macaulay2/d/ffi.d"
    tmp__128 = tmp__132;
    # line 466 "../../../../Macaulay2/d/ffi.d"
    L122_:;
    # line 466 "../../../../Macaulay2/d/ffi.d"
    tmp__133 = tmp__128;
    # line 466 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 466 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 468 "../../../../Macaulay2/d/ffi.d"
    tmp__133 = expr_WrongNumArgs_1(3);
    # line 468 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 468 "../../../../Macaulay2/d/ffi.d"
    };
  # line 468 "../../../../Macaulay2/d/ffi.d"
  return tmp__133;
  # line 468 "../../../../Macaulay2/d/ffi.d"
  }
# line 468 "../../../../Macaulay2/d/ffi.d"
static M2_string str__40;
# line 468 "../../../../Macaulay2/d/ffi.d"
static M2_string str__41;
# line 476 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiStructType(parse_Expr e){
  # line 476 "../../../../Macaulay2/d/ffi.d"
  parse_List a_11;
  # line 476 "../../../../Macaulay2/d/ffi.d"
  void * x_15;
  # line 476 "../../../../Macaulay2/d/ffi.d"
  int n_6;
  # line 476 "../../../../Macaulay2/d/ffi.d"
  int i_5;
  # line 476 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell p_1;
  # line 476 "../../../../Macaulay2/d/ffi.d"
  struct M2_1129 * elmnts;
  # line 476 "../../../../Macaulay2/d/ffi.d"
  struct M2_1129 * tmp__134;
  # line 476 "../../../../Macaulay2/d/ffi.d"
  int tmp__135;
  # line 476 "../../../../Macaulay2/d/ffi.d"
  void * tmp__136;
  # line 476 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__137;
  # line 476 "../../../../Macaulay2/d/ffi.d"
  void * tmp__138;
  # line 476 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__139;
  # line 476 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 476 "../../../../Macaulay2/d/ffi.d"
    case 45:;
    # line 476 "../../../../Macaulay2/d/ffi.d"
    a_11 = ((parse_List)e);
    # line 478 "../../../../Macaulay2/d/ffi.d"
    x_15 = getMem(sizeof(ffi_type));
    # line 479 "../../../../Macaulay2/d/ffi.d"
    ((ffi_type *)x_15)->size = 0;
    # line 480 "../../../../Macaulay2/d/ffi.d"
    ((ffi_type *)x_15)->alignment = 0;
    # line 481 "../../../../Macaulay2/d/ffi.d"
    ((ffi_type *)x_15)->type = FFI_TYPE_STRUCT;
    # line 482 "../../../../Macaulay2/d/ffi.d"
    n_6 = a_11->v->len;
    # line 482 "../../../../Macaulay2/d/ffi.d"
    i_5 = 0;
    # line 483 "../../../../Macaulay2/d/ffi.d"
    tmp__135 = (n_6 + 1);
    # line 483 "../../../../Macaulay2/d/ffi.d"
    ;
    # line 483 "../../../../Macaulay2/d/ffi.d"
    tmp__134 = (struct M2_1129 *) GC_MALLOC(sizeof(struct M2_1129) + (tmp__135)*sizeof(void *)-sizeof(void *));
    if (0 == tmp__134) outofmem2((size_t)sizeof(struct M2_1129) + (tmp__135)*sizeof(void *)-sizeof(void *));
    # line 483 "../../../../Macaulay2/d/ffi.d"
    tmp__134->len = tmp__135;
    # line 483 "../../../../Macaulay2/d/ffi.d"
    if ((tmp__135 == 0)) goto L127_;
    # line 483 "../../../../Macaulay2/d/ffi.d"
    L126_:;
    # line 484 "../../../../Macaulay2/d/ffi.d"
    if ((i_5 < n_6)) goto L128_;
    # line 488 "../../../../Macaulay2/d/ffi.d"
    tmp__136 = ((void *)0);
    # line 488 "../../../../Macaulay2/d/ffi.d"
    goto L129_;
    # line 488 "../../../../Macaulay2/d/ffi.d"
    L128_:;
    # line 485 "../../../../Macaulay2/d/ffi.d"
    tmp__137 = a_11->v->array[i_5];
    # line 485 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__137->type_) {;
      # line 485 "../../../../Macaulay2/d/ffi.d"
      case 81:;
      # line 485 "../../../../Macaulay2/d/ffi.d"
      p_1 = ((parse_pointerCell)tmp__137);
      # line 486 "../../../../Macaulay2/d/ffi.d"
      tmp__138 = p_1->v;
      # line 486 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 486 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 487 "../../../../Macaulay2/d/ffi.d"
      tmp__138 = ((void *)0);
      # line 487 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 487 "../../../../Macaulay2/d/ffi.d"
      };
    # line 487 "../../../../Macaulay2/d/ffi.d"
    tmp__136 = tmp__138;
    # line 487 "../../../../Macaulay2/d/ffi.d"
    L129_:;
    # line 487 "../../../../Macaulay2/d/ffi.d"
    tmp__134->array[i_5] = tmp__136;
    # line 483 "../../../../Macaulay2/d/ffi.d"
    if (((++ i_5) < tmp__135)) goto L130_;
    # line 483 "../../../../Macaulay2/d/ffi.d"
    goto L127_;
    # line 483 "../../../../Macaulay2/d/ffi.d"
    L130_:;
    # line 483 "../../../../Macaulay2/d/ffi.d"
    goto L126_;
    # line 483 "../../../../Macaulay2/d/ffi.d"
    L127_:;
    # line 483 "../../../../Macaulay2/d/ffi.d"
    elmnts = tmp__134;
    # line 489 "../../../../Macaulay2/d/ffi.d"
    ((ffi_type *)x_15)->elements = (ffi_type **)elmnts->array;
    # line 491 "../../../../Macaulay2/d/ffi.d"
    tmp__139 = toExpr_3(x_15);
    # line 491 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 491 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 492 "../../../../Macaulay2/d/ffi.d"
    tmp__139 = expr_WrongArg(str__41);
    # line 492 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 492 "../../../../Macaulay2/d/ffi.d"
    };
  # line 492 "../../../../Macaulay2/d/ffi.d"
  return tmp__139;
  # line 492 "../../../../Macaulay2/d/ffi.d"
  }
# line 492 "../../../../Macaulay2/d/ffi.d"
static M2_string str__42;
# line 496 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiGetStructOffsets(parse_Expr e){
  # line 496 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_16;
  # line 496 "../../../../Macaulay2/d/ffi.d"
  int n_7;
  # line 496 "../../../../Macaulay2/d/ffi.d"
  void * offsets;
  # line 496 "../../../../Macaulay2/d/ffi.d"
  int r_5;
  # line 496 "../../../../Macaulay2/d/ffi.d"
  int i_6;
  # line 496 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__140;
  # line 496 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence tmp__141;
  # line 496 "../../../../Macaulay2/d/ffi.d"
  int tmp__142;
  # line 496 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__143;
  # line 496 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 496 "../../../../Macaulay2/d/ffi.d"
    case 81:;
    # line 496 "../../../../Macaulay2/d/ffi.d"
    x_16 = ((parse_pointerCell)e);
    # line 498 "../../../../Macaulay2/d/ffi.d"
    n_7 = 0;
    # line 498 "../../../../Macaulay2/d/ffi.d"
    L131_:;
    # line 499 "../../../../Macaulay2/d/ffi.d"
    if ((! ((((ffi_type *)x_16->v)->elements)[n_7] != ((void *)0)))) goto L132_;
    # line 500 "../../../../Macaulay2/d/ffi.d"
    n_7 = (n_7 + 1);
    # line 500 "../../../../Macaulay2/d/ffi.d"
    goto L131_;
    # line 500 "../../../../Macaulay2/d/ffi.d"
    L132_:;
    # line 501 "../../../../Macaulay2/d/ffi.d"
    offsets = getmem((n_7) * sizeof(size_t));
    # line 502 "../../../../Macaulay2/d/ffi.d"
    r_5 = ffi_get_struct_offsets(FFI_DEFAULT_ABI, (ffi_type *)x_16->v, (size_t *)offsets);
    # line 504 "../../../../Macaulay2/d/ffi.d"
    if ((r_5 != ffiOk)) goto L134_;
    # line 504 "../../../../Macaulay2/d/ffi.d"
    goto L135_;
    # line 504 "../../../../Macaulay2/d/ffi.d"
    L134_:;
    # line 504 "../../../../Macaulay2/d/ffi.d"
    tmp__140 = ffiError(r_5);
    # line 504 "../../../../Macaulay2/d/ffi.d"
    return tmp__140;
    # line 504 "../../../../Macaulay2/d/ffi.d"
    L135_:;
    # line 504 "../../../../Macaulay2/d/ffi.d"
    i_6 = 0;
    # line 505 "../../../../Macaulay2/d/ffi.d"
    tmp__142 = n_7;
    # line 505 "../../../../Macaulay2/d/ffi.d"
    ;
    # line 505 "../../../../Macaulay2/d/ffi.d"
    tmp__141 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (tmp__142)*sizeof(parse_Expr)-sizeof(parse_Expr));
    if (0 == tmp__141) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (tmp__142)*sizeof(parse_Expr)-sizeof(parse_Expr));
    # line 505 "../../../../Macaulay2/d/ffi.d"
    tmp__141->type_ = 7;
    # line 505 "../../../../Macaulay2/d/ffi.d"
    tmp__141->len = tmp__142;
    # line 505 "../../../../Macaulay2/d/ffi.d"
    if ((tmp__142 == 0)) goto L137_;
    # line 505 "../../../../Macaulay2/d/ffi.d"
    L136_:;
    # line 506 "../../../../Macaulay2/d/ffi.d"
    tmp__141->array[i_6] = util_toExpr(((size_t *)offsets)[i_6]);
    # line 505 "../../../../Macaulay2/d/ffi.d"
    if (((++ i_6) < tmp__142)) goto L138_;
    # line 505 "../../../../Macaulay2/d/ffi.d"
    goto L137_;
    # line 505 "../../../../Macaulay2/d/ffi.d"
    L138_:;
    # line 505 "../../../../Macaulay2/d/ffi.d"
    goto L136_;
    # line 505 "../../../../Macaulay2/d/ffi.d"
    L137_:;
    # line 505 "../../../../Macaulay2/d/ffi.d"
    tmp__143 = basic_list(tmp__141);
    # line 505 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 505 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 507 "../../../../Macaulay2/d/ffi.d"
    tmp__143 = WrongArgPointer();
    # line 507 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 507 "../../../../Macaulay2/d/ffi.d"
    };
  # line 507 "../../../../Macaulay2/d/ffi.d"
  return tmp__143;
  # line 507 "../../../../Macaulay2/d/ffi.d"
  }
# line 507 "../../../../Macaulay2/d/ffi.d"
static M2_string str__43;
# line 507 "../../../../Macaulay2/d/ffi.d"
static M2_string str__44;
# line 511 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiStructAddress(parse_Expr e){
  # line 511 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_12;
  # line 511 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_17;
  # line 511 "../../../../Macaulay2/d/ffi.d"
  parse_List y_11;
  # line 511 "../../../../Macaulay2/d/ffi.d"
  int n_8;
  # line 511 "../../../../Macaulay2/d/ffi.d"
  void * offsets_1;
  # line 511 "../../../../Macaulay2/d/ffi.d"
  int r_6;
  # line 511 "../../../../Macaulay2/d/ffi.d"
  void * result;
  # line 511 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell elmnt;
  # line 511 "../../../../Macaulay2/d/ffi.d"
  int tocopy;
  # line 511 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__144;
  # line 511 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__145;
  # line 511 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__146;
  # line 511 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__147;
  # line 511 "../../../../Macaulay2/d/ffi.d"
  int i_7;
  # line 511 "../../../../Macaulay2/d/ffi.d"
  int tmp__148;
  # line 511 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__149;
  # line 511 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__150;
  # line 511 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__151;
  # line 511 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__152;
  # line 511 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 511 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 511 "../../../../Macaulay2/d/ffi.d"
    a_12 = ((parse_Sequence)e);
    # line 513 "../../../../Macaulay2/d/ffi.d"
    if ((a_12->len == 2)) goto L139_;
    # line 539 "../../../../Macaulay2/d/ffi.d"
    tmp__144 = expr_WrongNumArgs_1(2);
    # line 539 "../../../../Macaulay2/d/ffi.d"
    goto L140_;
    # line 539 "../../../../Macaulay2/d/ffi.d"
    L139_:;
    # line 514 "../../../../Macaulay2/d/ffi.d"
    tmp__145 = a_12->array[0];
    # line 514 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__145->type_) {;
      # line 514 "../../../../Macaulay2/d/ffi.d"
      case 81:;
      # line 514 "../../../../Macaulay2/d/ffi.d"
      x_17 = ((parse_pointerCell)tmp__145);
      # line 516 "../../../../Macaulay2/d/ffi.d"
      tmp__146 = a_12->array[1];
      # line 516 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__146->type_) {;
	# line 516 "../../../../Macaulay2/d/ffi.d"
	case 45:;
	# line 516 "../../../../Macaulay2/d/ffi.d"
	y_11 = ((parse_List)tmp__146);
	# line 517 "../../../../Macaulay2/d/ffi.d"
	n_8 = 0;
	# line 517 "../../../../Macaulay2/d/ffi.d"
	L141_:;
	# line 518 "../../../../Macaulay2/d/ffi.d"
	if ((! ((((ffi_type *)x_17->v)->elements)[n_8] != ((void *)0)))) goto L142_;
	# line 519 "../../../../Macaulay2/d/ffi.d"
	n_8 = (n_8 + 1);
	# line 519 "../../../../Macaulay2/d/ffi.d"
	goto L141_;
	# line 519 "../../../../Macaulay2/d/ffi.d"
	L142_:;
	# line 520 "../../../../Macaulay2/d/ffi.d"
	offsets_1 = getmem((n_8) * sizeof(size_t));
	# line 522 "../../../../Macaulay2/d/ffi.d"
	r_6 = ffi_get_struct_offsets(FFI_DEFAULT_ABI, (ffi_type *)x_17->v, (size_t *)offsets_1);
	# line 524 "../../../../Macaulay2/d/ffi.d"
	if ((r_6 != ffiOk)) goto L144_;
	# line 524 "../../../../Macaulay2/d/ffi.d"
	goto L145_;
	# line 524 "../../../../Macaulay2/d/ffi.d"
	L144_:;
	# line 524 "../../../../Macaulay2/d/ffi.d"
	tmp__147 = ffiError(r_6);
	# line 524 "../../../../Macaulay2/d/ffi.d"
	return tmp__147;
	# line 524 "../../../../Macaulay2/d/ffi.d"
	L145_:;
	# line 525 "../../../../Macaulay2/d/ffi.d"
	result = getMem(((ffi_type *)x_17->v)->size);
	# line 527 "../../../../Macaulay2/d/ffi.d"
	tmp__148 = (n_8 - 1);
	# line 527 "../../../../Macaulay2/d/ffi.d"
	i_7 = 0;
	# line 527 "../../../../Macaulay2/d/ffi.d"
	goto L148_;
	# line 527 "../../../../Macaulay2/d/ffi.d"
	L146_:;
	# line 527 "../../../../Macaulay2/d/ffi.d"
	i_7 = (i_7 + 1);
	# line 527 "../../../../Macaulay2/d/ffi.d"
	L148_:;
	# line 527 "../../../../Macaulay2/d/ffi.d"
	if ((((i_7 > tmp__148) && (1 >= 0)) || ((i_7 < tmp__148) && (1 < 0)))) goto L147_;
	# line 528 "../../../../Macaulay2/d/ffi.d"
	tmp__149 = y_11->v->array[i_7];
	# line 528 "../../../../Macaulay2/d/ffi.d"
	switch (tmp__149->type_) {;
	  # line 528 "../../../../Macaulay2/d/ffi.d"
	  case 81:;
	  # line 528 "../../../../Macaulay2/d/ffi.d"
	  elmnt = ((parse_pointerCell)tmp__149);
	  # line 530 "../../../../Macaulay2/d/ffi.d"
	  tocopy = (((ffi_type *)x_17->v)->elements)[i_7]->size;
	  # line 532 "../../../../Macaulay2/d/ffi.d"
	  memcpy(result + ((size_t *)offsets_1)[i_7],elmnt->v, tocopy);
	  # line 533 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 533 "../../../../Macaulay2/d/ffi.d"
	  default:;
	  # line 533 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 533 "../../../../Macaulay2/d/ffi.d"
	  };
	# line 533 "../../../../Macaulay2/d/ffi.d"
	goto L146_;
	# line 533 "../../../../Macaulay2/d/ffi.d"
	L147_:;
	# line 536 "../../../../Macaulay2/d/ffi.d"
	tmp__150 = toExpr_3(result);
	# line 536 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 536 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 537 "../../../../Macaulay2/d/ffi.d"
	tmp__150 = expr_WrongArg_1(2, str__44);
	# line 537 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 537 "../../../../Macaulay2/d/ffi.d"
	};
      # line 537 "../../../../Macaulay2/d/ffi.d"
      tmp__151 = tmp__150;
      # line 537 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 537 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 538 "../../../../Macaulay2/d/ffi.d"
      tmp__151 = WrongArgPointer_1(1);
      # line 538 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 538 "../../../../Macaulay2/d/ffi.d"
      };
    # line 538 "../../../../Macaulay2/d/ffi.d"
    tmp__144 = tmp__151;
    # line 538 "../../../../Macaulay2/d/ffi.d"
    L140_:;
    # line 538 "../../../../Macaulay2/d/ffi.d"
    tmp__152 = tmp__144;
    # line 538 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 538 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 540 "../../../../Macaulay2/d/ffi.d"
    tmp__152 = expr_WrongNumArgs_1(2);
    # line 540 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 540 "../../../../Macaulay2/d/ffi.d"
    };
  # line 540 "../../../../Macaulay2/d/ffi.d"
  return tmp__152;
  # line 540 "../../../../Macaulay2/d/ffi.d"
  }
# line 540 "../../../../Macaulay2/d/ffi.d"
static M2_string str__45;
# line 540 "../../../../Macaulay2/d/ffi.d"
static M2_string str__46;
# line 549 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiUnionType(parse_Expr e){
  # line 549 "../../../../Macaulay2/d/ffi.d"
  parse_List a_13;
  # line 549 "../../../../Macaulay2/d/ffi.d"
  void * x_18;
  # line 549 "../../../../Macaulay2/d/ffi.d"
  struct M2_1129 * elmnts_1;
  # line 549 "../../../../Macaulay2/d/ffi.d"
  void * cif_3;
  # line 549 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell p_2;
  # line 549 "../../../../Macaulay2/d/ffi.d"
  int tmp__153;
  # line 549 "../../../../Macaulay2/d/ffi.d"
  struct M2_1129 * tmp__154;
  # line 549 "../../../../Macaulay2/d/ffi.d"
  int tmp__155;
  # line 549 "../../../../Macaulay2/d/ffi.d"
  int i_8;
  # line 549 "../../../../Macaulay2/d/ffi.d"
  int tmp__156;
  # line 549 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__157;
  # line 549 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__158;
  # line 549 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__159;
  # line 549 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 549 "../../../../Macaulay2/d/ffi.d"
    case 45:;
    # line 549 "../../../../Macaulay2/d/ffi.d"
    a_13 = ((parse_List)e);
    # line 552 "../../../../Macaulay2/d/ffi.d"
    x_18 = getMem(sizeof(ffi_type));
    # line 553 "../../../../Macaulay2/d/ffi.d"
    ((ffi_type *)x_18)->size = 0;
    # line 554 "../../../../Macaulay2/d/ffi.d"
    ((ffi_type *)x_18)->alignment = 0;
    # line 555 "../../../../Macaulay2/d/ffi.d"
    ((ffi_type *)x_18)->type = FFI_TYPE_STRUCT;
    # line 555 "../../../../Macaulay2/d/ffi.d"
    tmp__153 = 0;
    # line 556 "../../../../Macaulay2/d/ffi.d"
    tmp__155 = 2;
    # line 556 "../../../../Macaulay2/d/ffi.d"
    ;
    # line 556 "../../../../Macaulay2/d/ffi.d"
    tmp__154 = (struct M2_1129 *) GC_MALLOC(sizeof(struct M2_1129) + (tmp__155)*sizeof(void *)-sizeof(void *));
    if (0 == tmp__154) outofmem2((size_t)sizeof(struct M2_1129) + (tmp__155)*sizeof(void *)-sizeof(void *));
    # line 556 "../../../../Macaulay2/d/ffi.d"
    tmp__154->len = tmp__155;
    # line 556 "../../../../Macaulay2/d/ffi.d"
    if ((tmp__155 == 0)) goto L150_;
    # line 556 "../../../../Macaulay2/d/ffi.d"
    L149_:;
    # line 556 "../../../../Macaulay2/d/ffi.d"
    tmp__154->array[tmp__153] = ((void *)0);
    # line 556 "../../../../Macaulay2/d/ffi.d"
    if (((++ tmp__153) < tmp__155)) goto L151_;
    # line 556 "../../../../Macaulay2/d/ffi.d"
    goto L150_;
    # line 556 "../../../../Macaulay2/d/ffi.d"
    L151_:;
    # line 556 "../../../../Macaulay2/d/ffi.d"
    goto L149_;
    # line 556 "../../../../Macaulay2/d/ffi.d"
    L150_:;
    # line 556 "../../../../Macaulay2/d/ffi.d"
    elmnts_1 = tmp__154;
    # line 557 "../../../../Macaulay2/d/ffi.d"
    ((ffi_type *)x_18)->elements = (ffi_type **)elmnts_1->array;
    # line 559 "../../../../Macaulay2/d/ffi.d"
    cif_3 = getMem(sizeof(ffi_cif));
    # line 560 "../../../../Macaulay2/d/ffi.d"
    tmp__156 = (a_13->v->len - 1);
    # line 560 "../../../../Macaulay2/d/ffi.d"
    i_8 = 0;
    # line 560 "../../../../Macaulay2/d/ffi.d"
    goto L154_;
    # line 560 "../../../../Macaulay2/d/ffi.d"
    L152_:;
    # line 560 "../../../../Macaulay2/d/ffi.d"
    i_8 = (i_8 + 1);
    # line 560 "../../../../Macaulay2/d/ffi.d"
    L154_:;
    # line 560 "../../../../Macaulay2/d/ffi.d"
    if ((((i_8 > tmp__156) && (1 >= 0)) || ((i_8 < tmp__156) && (1 < 0)))) goto L153_;
    # line 561 "../../../../Macaulay2/d/ffi.d"
    tmp__157 = a_13->v->array[i_8];
    # line 561 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__157->type_) {;
      # line 561 "../../../../Macaulay2/d/ffi.d"
      case 81:;
      # line 561 "../../../../Macaulay2/d/ffi.d"
      p_2 = ((parse_pointerCell)tmp__157);
      # line 563 "../../../../Macaulay2/d/ffi.d"
      if ((ffi_prep_cif((ffi_cif *)cif_3, FFI_DEFAULT_ABI, 0, p_2->v, NULL) == ffiOk)) goto L155_;
      # line 564 "../../../../Macaulay2/d/ffi.d"
      goto L156_;
      # line 564 "../../../../Macaulay2/d/ffi.d"
      L155_:;
      # line 566 "../../../../Macaulay2/d/ffi.d"
      if ((((ffi_type *)p_2->v)->size > ((ffi_type *)x_18)->size)) goto L157_;
      # line 565 "../../../../Macaulay2/d/ffi.d"
      goto L158_;
      # line 565 "../../../../Macaulay2/d/ffi.d"
      L157_:;
      # line 567 "../../../../Macaulay2/d/ffi.d"
      ((ffi_type *)x_18)->size = ((ffi_type *)p_2->v)->size;
      # line 568 "../../../../Macaulay2/d/ffi.d"
      L158_:;
      # line 570 "../../../../Macaulay2/d/ffi.d"
      if ((((ffi_type *)p_2->v)->alignment > ((ffi_type *)x_18)->alignment)) goto L159_;
      # line 569 "../../../../Macaulay2/d/ffi.d"
      goto L160_;
      # line 569 "../../../../Macaulay2/d/ffi.d"
      L159_:;
      # line 571 "../../../../Macaulay2/d/ffi.d"
      ((ffi_type *)x_18)->alignment = ((ffi_type *)p_2->v)->alignment;
      # line 572 "../../../../Macaulay2/d/ffi.d"
      L160_:;
      # line 572 "../../../../Macaulay2/d/ffi.d"
      L156_:;
      # line 572 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 572 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 574 "../../../../Macaulay2/d/ffi.d"
      tmp__158 = WrongArgPointer_1((i_8 + 1));
      # line 574 "../../../../Macaulay2/d/ffi.d"
      return tmp__158;
      # line 574 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 574 "../../../../Macaulay2/d/ffi.d"
      };
    # line 574 "../../../../Macaulay2/d/ffi.d"
    goto L152_;
    # line 574 "../../../../Macaulay2/d/ffi.d"
    L153_:;
    # line 575 "../../../../Macaulay2/d/ffi.d"
    tmp__159 = toExpr_3(x_18);
    # line 575 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 575 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 576 "../../../../Macaulay2/d/ffi.d"
    tmp__159 = expr_WrongArg(str__46);
    # line 576 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 576 "../../../../Macaulay2/d/ffi.d"
    };
  # line 576 "../../../../Macaulay2/d/ffi.d"
  return tmp__159;
  # line 576 "../../../../Macaulay2/d/ffi.d"
  }
# line 576 "../../../../Macaulay2/d/ffi.d"
static M2_string str__47;
# line 585 "../../../../Macaulay2/d/ffi.d"
static void ffiClosureFunction(ffi_cif * cif,void * ret,void ** args,void * userData){
  # line 585 "../../../../Macaulay2/d/ffi.d"
  int nargs;
  # line 585 "../../../../Macaulay2/d/ffi.d"
  parse_Expr f;
  # line 585 "../../../../Macaulay2/d/ffi.d"
  int i_9;
  # line 585 "../../../../Macaulay2/d/ffi.d"
  parse_Expr x_19;
  # line 585 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell ptr_4;
  # line 585 "../../../../Macaulay2/d/ffi.d"
  parse_Error err_1;
  # line 585 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence tmp__160;
  # line 585 "../../../../Macaulay2/d/ffi.d"
  int tmp__161;
  # line 585 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell tmp__162;
  # line 585 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__163;
  # line 585 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell tmp__164;
  # line 585 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__165;
  # line 585 "../../../../Macaulay2/d/ffi.d"
  nargs = cif->nargs;
  # line 586 "../../../../Macaulay2/d/ffi.d"
  f = ((parse_Expr)userData);
  # line 588 "../../../../Macaulay2/d/ffi.d"
  if ((nargs == 1)) goto L161_;
  # line 588 "../../../../Macaulay2/d/ffi.d"
  i_9 = 0;
  # line 589 "../../../../Macaulay2/d/ffi.d"
  tmp__161 = nargs;
  # line 589 "../../../../Macaulay2/d/ffi.d"
  ;
  # line 589 "../../../../Macaulay2/d/ffi.d"
  tmp__160 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (tmp__161)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__160) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (tmp__161)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 589 "../../../../Macaulay2/d/ffi.d"
  tmp__160->type_ = 7;
  # line 589 "../../../../Macaulay2/d/ffi.d"
  tmp__160->len = tmp__161;
  # line 589 "../../../../Macaulay2/d/ffi.d"
  if ((tmp__161 == 0)) goto L163_;
  # line 589 "../../../../Macaulay2/d/ffi.d"
  L162_:;
  # line 589 "../../../../Macaulay2/d/ffi.d"
  tmp__162 = (parse_pointerCell) GC_MALLOC(sizeof(struct parse_pointerCell_struct));
  if (0 == tmp__162) outofmem2((size_t)sizeof(struct parse_pointerCell_struct));
  # line 589 "../../../../Macaulay2/d/ffi.d"
  tmp__162->type_ = 81;
  # line 590 "../../../../Macaulay2/d/ffi.d"
  tmp__162->v = args[i_9];
  # line 590 "../../../../Macaulay2/d/ffi.d"
  tmp__160->array[i_9] = ((parse_Expr)tmp__162);
  # line 589 "../../../../Macaulay2/d/ffi.d"
  if (((++ i_9) < tmp__161)) goto L164_;
  # line 589 "../../../../Macaulay2/d/ffi.d"
  goto L163_;
  # line 589 "../../../../Macaulay2/d/ffi.d"
  L164_:;
  # line 589 "../../../../Macaulay2/d/ffi.d"
  goto L162_;
  # line 589 "../../../../Macaulay2/d/ffi.d"
  L163_:;
  # line 589 "../../../../Macaulay2/d/ffi.d"
  tmp__163 = ((parse_Expr)tmp__160);
  # line 589 "../../../../Macaulay2/d/ffi.d"
  goto L165_;
  # line 589 "../../../../Macaulay2/d/ffi.d"
  L161_:;
  # line 589 "../../../../Macaulay2/d/ffi.d"
  tmp__164 = (parse_pointerCell) GC_MALLOC(sizeof(struct parse_pointerCell_struct));
  if (0 == tmp__164) outofmem2((size_t)sizeof(struct parse_pointerCell_struct));
  # line 589 "../../../../Macaulay2/d/ffi.d"
  tmp__164->type_ = 81;
  # line 588 "../../../../Macaulay2/d/ffi.d"
  tmp__164->v = *args;
  # line 588 "../../../../Macaulay2/d/ffi.d"
  tmp__163 = ((parse_Expr)tmp__164);
  # line 588 "../../../../Macaulay2/d/ffi.d"
  L165_:;
  # line 588 "../../../../Macaulay2/d/ffi.d"
  x_19 = tmp__163;
  # line 591 "../../../../Macaulay2/d/ffi.d"
  tmp__165 = evaluate_applyEE(f, x_19);
  # line 591 "../../../../Macaulay2/d/ffi.d"
  switch (tmp__165->type_) {;
    # line 591 "../../../../Macaulay2/d/ffi.d"
    case 81:;
    # line 591 "../../../../Macaulay2/d/ffi.d"
    ptr_4 = ((parse_pointerCell)tmp__165);
    # line 593 "../../../../Macaulay2/d/ffi.d"
    memcpy(endianAdjust(ret, ((ffi_cif *)cif)->rtype), ptr_4->v, cif->rtype->size);
    # line 595 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 595 "../../../../Macaulay2/d/ffi.d"
    case 15:;
    # line 595 "../../../../Macaulay2/d/ffi.d"
    err_1 = ((parse_Error)tmp__165);
    # line 596 "../../../../Macaulay2/d/ffi.d"
    tokens_printErrorMessage(err_1);
    # line 596 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 596 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 596 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 596 "../../../../Macaulay2/d/ffi.d"
    };
  # line 596 "../../../../Macaulay2/d/ffi.d"
  }
# line 600 "../../../../Macaulay2/d/ffi.d"
static void ffiClosureFinalizer(void * ptr,void * closure){
  # line 600 "../../../../Macaulay2/d/ffi.d"
  ffi_closure_free(closure);
  # line 600 "../../../../Macaulay2/d/ffi.d"
  }
# line 600 "../../../../Macaulay2/d/ffi.d"
static M2_string str__48;
# line 600 "../../../../Macaulay2/d/ffi.d"
static M2_string str__49;
# line 603 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiFunctionPointerAddress(parse_Expr e){
  # line 603 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_14;
  # line 603 "../../../../Macaulay2/d/ffi.d"
  parse_FunctionClosure f_1;
  # line 603 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell cif_4;
  # line 603 "../../../../Macaulay2/d/ffi.d"
  void * code;
  # line 603 "../../../../Macaulay2/d/ffi.d"
  void * closure_1;
  # line 603 "../../../../Macaulay2/d/ffi.d"
  int r_7;
  # line 603 "../../../../Macaulay2/d/ffi.d"
  void * ptr_5;
  # line 603 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__166;
  # line 603 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__167;
  # line 603 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__168;
  # line 603 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__169;
  # line 603 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__170;
  # line 603 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__171;
  # line 603 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__172;
  # line 603 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 603 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 603 "../../../../Macaulay2/d/ffi.d"
    a_14 = ((parse_Sequence)e);
    # line 605 "../../../../Macaulay2/d/ffi.d"
    tmp__166 = a_14->array[0];
    # line 605 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__166->type_) {;
      # line 605 "../../../../Macaulay2/d/ffi.d"
      case 54:;
      # line 605 "../../../../Macaulay2/d/ffi.d"
      f_1 = ((parse_FunctionClosure)tmp__166);
      # line 607 "../../../../Macaulay2/d/ffi.d"
      tmp__167 = a_14->array[1];
      # line 607 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__167->type_) {;
	# line 607 "../../../../Macaulay2/d/ffi.d"
	case 81:;
	# line 607 "../../../../Macaulay2/d/ffi.d"
	cif_4 = ((parse_pointerCell)tmp__167);
	# line 609 "../../../../Macaulay2/d/ffi.d"
	code = ((void *)0);
	# line 610 "../../../../Macaulay2/d/ffi.d"
	closure_1 = ffi_closure_alloc(sizeof(ffi_closure), &code);
	# line 612 "../../../../Macaulay2/d/ffi.d"
	if ((closure_1 == ((void *)0))) goto L166_;
	# line 612 "../../../../Macaulay2/d/ffi.d"
	goto L167_;
	# line 612 "../../../../Macaulay2/d/ffi.d"
	L166_:;
	# line 612 "../../../../Macaulay2/d/ffi.d"
	tmp__168 = expr_buildErrorPacket(str__48);
	# line 612 "../../../../Macaulay2/d/ffi.d"
	return tmp__168;
	# line 612 "../../../../Macaulay2/d/ffi.d"
	L167_:;
	# line 614 "../../../../Macaulay2/d/ffi.d"
	r_7 = ffi_prep_closure_loc(closure_1, cif_4->v, ffiClosureFunction, f_1, code);
	# line 616 "../../../../Macaulay2/d/ffi.d"
	if ((r_7 != ffiOk)) goto L168_;
	# line 616 "../../../../Macaulay2/d/ffi.d"
	goto L169_;
	# line 616 "../../../../Macaulay2/d/ffi.d"
	L168_:;
	# line 616 "../../../../Macaulay2/d/ffi.d"
	tmp__169 = ffiError(r_7);
	# line 616 "../../../../Macaulay2/d/ffi.d"
	return tmp__169;
	# line 616 "../../../../Macaulay2/d/ffi.d"
	L169_:;
	# line 617 "../../../../Macaulay2/d/ffi.d"
	ptr_5 = getMem(pointerSize);
	# line 618 "../../../../Macaulay2/d/ffi.d"
	*(void **)ptr_5 = closure_1;
	# line 619 "../../../../Macaulay2/d/ffi.d"
	GC_REGISTER_FINALIZER(ptr_5, (GC_finalization_proc)ffiClosureFinalizer, closure_1, 0, 0);
	# line 622 "../../../../Macaulay2/d/ffi.d"
	tmp__170 = toExpr_3(ptr_5);
	# line 622 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 622 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 623 "../../../../Macaulay2/d/ffi.d"
	tmp__170 = WrongArgPointer_1(2);
	# line 623 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 623 "../../../../Macaulay2/d/ffi.d"
	};
      # line 623 "../../../../Macaulay2/d/ffi.d"
      tmp__171 = tmp__170;
      # line 623 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 623 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 624 "../../../../Macaulay2/d/ffi.d"
      tmp__171 = expr_WrongArg_1(1, str__49);
      # line 624 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 624 "../../../../Macaulay2/d/ffi.d"
      };
    # line 624 "../../../../Macaulay2/d/ffi.d"
    tmp__172 = tmp__171;
    # line 624 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 624 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 625 "../../../../Macaulay2/d/ffi.d"
    tmp__172 = expr_WrongNumArgs_1(2);
    # line 625 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 625 "../../../../Macaulay2/d/ffi.d"
    };
  # line 625 "../../../../Macaulay2/d/ffi.d"
  return tmp__172;
  # line 625 "../../../../Macaulay2/d/ffi.d"
  }
# line 625 "../../../../Macaulay2/d/ffi.d"
static M2_string str__50;
# line 625 "../../../../Macaulay2/d/ffi.d"
static void ffi__thread_prepare();
# line 625 "../../../../Macaulay2/d/ffi.d"
static void ffi__final();
# line 49 "../../../../Macaulay2/d/ffi.d"
void ffi__prepare(){
  # line 49 "../../../../Macaulay2/d/ffi.d"
  static struct FUNCTION_CELL this_final, this_thread_prepare;
  # line 49 "../../../../Macaulay2/d/ffi.d"
  static int called_yet = 0;
  # line 49 "../../../../Macaulay2/d/ffi.d"
  if (called_yet) return; else called_yet = 1;
  # line 49 "../../../../Macaulay2/d/ffi.d"
  str_ = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (9)*sizeof(signed char)-sizeof(signed char));
  if (0 == str_) outofmem2((size_t)sizeof(struct M2_string_struct) + (9)*sizeof(signed char)-sizeof(signed char));
  # line 49 "../../../../Macaulay2/d/ffi.d"
  str_->len = 9;
  # line 49 "../../../../Macaulay2/d/ffi.d"
  memcpy(str_->array, "a pointer", 9);
  # line 49 "../../../../Macaulay2/d/ffi.d"
  str__1 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (9)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__1) outofmem2((size_t)sizeof(struct M2_string_struct) + (9)*sizeof(signed char)-sizeof(signed char));
  # line 49 "../../../../Macaulay2/d/ffi.d"
  str__1->len = 9;
  # line 50 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__1->array, "a pointer", 9);
  # line 50 "../../../../Macaulay2/d/ffi.d"
  str__2 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (11)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__2) outofmem2((size_t)sizeof(struct M2_string_struct) + (11)*sizeof(signed char)-sizeof(signed char));
  # line 50 "../../../../Macaulay2/d/ffi.d"
  str__2->len = 11;
  # line 51 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__2->array, "nullPointer", 11);
  # line 51 "../../../../Macaulay2/d/ffi.d"
  str__3 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__3) outofmem2((size_t)sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  # line 51 "../../../../Macaulay2/d/ffi.d"
  str__3->len = 6;
  # line 67 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__3->array, "dlopen", 6);
  # line 67 "../../../../Macaulay2/d/ffi.d"
  str__4 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (34)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__4) outofmem2((size_t)sizeof(struct M2_string_struct) + (34)*sizeof(signed char)-sizeof(signed char));
  # line 67 "../../../../Macaulay2/d/ffi.d"
  str__4->len = 34;
  # line 89 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__4->array, "a string or a pointer and a string", 34);
  # line 89 "../../../../Macaulay2/d/ffi.d"
  str__5 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (5)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__5) outofmem2((size_t)sizeof(struct M2_string_struct) + (5)*sizeof(signed char)-sizeof(signed char));
  # line 89 "../../../../Macaulay2/d/ffi.d"
  str__5->len = 5;
  # line 90 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__5->array, "dlsym", 5);
  # line 90 "../../../../Macaulay2/d/ffi.d"
  str__6 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (11)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__6) outofmem2((size_t)sizeof(struct M2_string_struct) + (11)*sizeof(signed char)-sizeof(signed char));
  # line 90 "../../../../Macaulay2/d/ffi.d"
  str__6->len = 11;
  # line 99 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__6->array, "ffiTypeSize", 11);
  # line 99 "../../../../Macaulay2/d/ffi.d"
  str__7 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__7) outofmem2((size_t)sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  # line 99 "../../../../Macaulay2/d/ffi.d"
  str__7->len = 15;
  # line 108 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__7->array, "libffi: unknown", 15);
  # line 108 "../../../../Macaulay2/d/ffi.d"
  str__8 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (19)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__8) outofmem2((size_t)sizeof(struct M2_string_struct) + (19)*sizeof(signed char)-sizeof(signed char));
  # line 108 "../../../../Macaulay2/d/ffi.d"
  str__8->len = 19;
  # line 107 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__8->array, "libffi: bad argtype", 19);
  # line 107 "../../../../Macaulay2/d/ffi.d"
  str__9 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__9) outofmem2((size_t)sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  # line 107 "../../../../Macaulay2/d/ffi.d"
  str__9->len = 15;
  # line 105 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__9->array, "libffi: bad ABI", 15);
  # line 105 "../../../../Macaulay2/d/ffi.d"
  str__10 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (19)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__10) outofmem2((size_t)sizeof(struct M2_string_struct) + (19)*sizeof(signed char)-sizeof(signed char));
  # line 105 "../../../../Macaulay2/d/ffi.d"
  str__10->len = 19;
  # line 103 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__10->array, "libffi: bad typedef", 19);
  # line 103 "../../../../Macaulay2/d/ffi.d"
  str__11 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__11) outofmem2((size_t)sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  # line 103 "../../../../Macaulay2/d/ffi.d"
  str__11->len = 6;
  # line 128 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__11->array, "a list", 6);
  # line 128 "../../../../Macaulay2/d/ffi.d"
  str__12 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (10)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__12) outofmem2((size_t)sizeof(struct M2_string_struct) + (10)*sizeof(signed char)-sizeof(signed char));
  # line 128 "../../../../Macaulay2/d/ffi.d"
  str__12->len = 10;
  # line 131 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__12->array, "ffiPrepCif", 10);
  # line 131 "../../../../Macaulay2/d/ffi.d"
  str__13 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__13) outofmem2((size_t)sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  # line 131 "../../../../Macaulay2/d/ffi.d"
  str__13->len = 6;
  # line 153 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__13->array, "a list", 6);
  # line 153 "../../../../Macaulay2/d/ffi.d"
  str__14 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (13)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__14) outofmem2((size_t)sizeof(struct M2_string_struct) + (13)*sizeof(signed char)-sizeof(signed char));
  # line 153 "../../../../Macaulay2/d/ffi.d"
  str__14->len = 13;
  # line 157 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__14->array, "ffiPrepCifVar", 13);
  # line 157 "../../../../Macaulay2/d/ffi.d"
  str__15 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__15) outofmem2((size_t)sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  # line 157 "../../../../Macaulay2/d/ffi.d"
  str__15->len = 6;
  # line 193 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__15->array, "a list", 6);
  # line 193 "../../../../Macaulay2/d/ffi.d"
  str__16 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (7)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__16) outofmem2((size_t)sizeof(struct M2_string_struct) + (7)*sizeof(signed char)-sizeof(signed char));
  # line 193 "../../../../Macaulay2/d/ffi.d"
  str__16->len = 7;
  # line 198 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__16->array, "ffiCall", 7);
  # line 198 "../../../../Macaulay2/d/ffi.d"
  str__17 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (11)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__17) outofmem2((size_t)sizeof(struct M2_string_struct) + (11)*sizeof(signed char)-sizeof(signed char));
  # line 198 "../../../../Macaulay2/d/ffi.d"
  str__17->len = 11;
  # line 203 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__17->array, "ffiVoidType", 11);
  # line 203 "../../../../Macaulay2/d/ffi.d"
  str__18 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__18) outofmem2((size_t)sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  # line 203 "../../../../Macaulay2/d/ffi.d"
  str__18->len = 30;
  # line 237 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__18->array, "expected 8, 16, 32, or 64 bits", 30);
  # line 237 "../../../../Macaulay2/d/ffi.d"
  str__19 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__19) outofmem2((size_t)sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  # line 237 "../../../../Macaulay2/d/ffi.d"
  str__19->len = 30;
  # line 227 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__19->array, "expected 8, 16, 32, or 64 bits", 30);
  # line 227 "../../../../Macaulay2/d/ffi.d"
  str__20 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__20) outofmem2((size_t)sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  # line 227 "../../../../Macaulay2/d/ffi.d"
  str__20->len = 14;
  # line 243 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__20->array, "ffiIntegerType", 14);
  # line 243 "../../../../Macaulay2/d/ffi.d"
  str__21 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__21) outofmem2((size_t)sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  # line 243 "../../../../Macaulay2/d/ffi.d"
  str__21->len = 30;
  # line 287 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__21->array, "expected 8, 16, 32, or 64 bits", 30);
  # line 287 "../../../../Macaulay2/d/ffi.d"
  str__22 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__22) outofmem2((size_t)sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  # line 287 "../../../../Macaulay2/d/ffi.d"
  str__22->len = 30;
  # line 271 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__22->array, "expected 8, 16, 32, or 64 bits", 30);
  # line 271 "../../../../Macaulay2/d/ffi.d"
  str__23 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (17)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__23) outofmem2((size_t)sizeof(struct M2_string_struct) + (17)*sizeof(signed char)-sizeof(signed char));
  # line 271 "../../../../Macaulay2/d/ffi.d"
  str__23->len = 17;
  # line 294 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__23->array, "ffiIntegerAddress", 17);
  # line 294 "../../../../Macaulay2/d/ffi.d"
  str__24 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__24) outofmem2((size_t)sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  # line 294 "../../../../Macaulay2/d/ffi.d"
  str__24->len = 30;
  # line 328 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__24->array, "expected 8, 16, 32, or 64 bits", 30);
  # line 328 "../../../../Macaulay2/d/ffi.d"
  str__25 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__25) outofmem2((size_t)sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  # line 328 "../../../../Macaulay2/d/ffi.d"
  str__25->len = 30;
  # line 317 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__25->array, "expected 8, 16, 32, or 64 bits", 30);
  # line 317 "../../../../Macaulay2/d/ffi.d"
  str__26 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__26) outofmem2((size_t)sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  # line 317 "../../../../Macaulay2/d/ffi.d"
  str__26->len = 15;
  # line 334 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__26->array, "ffiIntegerValue", 15);
  # line 334 "../../../../Macaulay2/d/ffi.d"
  str__27 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (22)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__27) outofmem2((size_t)sizeof(struct M2_string_struct) + (22)*sizeof(signed char)-sizeof(signed char));
  # line 334 "../../../../Macaulay2/d/ffi.d"
  str__27->len = 22;
  # line 346 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__27->array, "expected 32 or 64 bits", 22);
  # line 346 "../../../../Macaulay2/d/ffi.d"
  str__28 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (11)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__28) outofmem2((size_t)sizeof(struct M2_string_struct) + (11)*sizeof(signed char)-sizeof(signed char));
  # line 346 "../../../../Macaulay2/d/ffi.d"
  str__28->len = 11;
  # line 348 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__28->array, "ffiRealType", 11);
  # line 348 "../../../../Macaulay2/d/ffi.d"
  str__29 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (22)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__29) outofmem2((size_t)sizeof(struct M2_string_struct) + (22)*sizeof(signed char)-sizeof(signed char));
  # line 348 "../../../../Macaulay2/d/ffi.d"
  str__29->len = 22;
  # line 368 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__29->array, "expected 32 or 64 bits", 22);
  # line 368 "../../../../Macaulay2/d/ffi.d"
  str__30 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__30) outofmem2((size_t)sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  # line 368 "../../../../Macaulay2/d/ffi.d"
  str__30->len = 14;
  # line 374 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__30->array, "ffiRealAddress", 14);
  # line 374 "../../../../Macaulay2/d/ffi.d"
  str__31 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (22)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__31) outofmem2((size_t)sizeof(struct M2_string_struct) + (22)*sizeof(signed char)-sizeof(signed char));
  # line 374 "../../../../Macaulay2/d/ffi.d"
  str__31->len = 22;
  # line 389 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__31->array, "expected 32 or 64 bits", 22);
  # line 389 "../../../../Macaulay2/d/ffi.d"
  str__32 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (12)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__32) outofmem2((size_t)sizeof(struct M2_string_struct) + (12)*sizeof(signed char)-sizeof(signed char));
  # line 389 "../../../../Macaulay2/d/ffi.d"
  str__32->len = 12;
  # line 394 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__32->array, "ffiRealValue", 12);
  # line 394 "../../../../Macaulay2/d/ffi.d"
  str__33 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__33) outofmem2((size_t)sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  # line 394 "../../../../Macaulay2/d/ffi.d"
  str__33->len = 14;
  # line 402 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__33->array, "ffiPointerType", 14);
  # line 402 "../../../../Macaulay2/d/ffi.d"
  str__34 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (27)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__34) outofmem2((size_t)sizeof(struct M2_string_struct) + (27)*sizeof(signed char)-sizeof(signed char));
  # line 402 "../../../../Macaulay2/d/ffi.d"
  str__34->len = 27;
  # line 429 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__34->array, "expected a list of pointers", 27);
  # line 429 "../../../../Macaulay2/d/ffi.d"
  str__35 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__35) outofmem2((size_t)sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  # line 429 "../../../../Macaulay2/d/ffi.d"
  str__35->len = 6;
  # line 433 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__35->array, "a list", 6);
  # line 433 "../../../../Macaulay2/d/ffi.d"
  str__36 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (42)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__36) outofmem2((size_t)sizeof(struct M2_string_struct) + (42)*sizeof(signed char)-sizeof(signed char));
  # line 433 "../../../../Macaulay2/d/ffi.d"
  str__36->len = 42;
  # line 436 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__36->array, "a pointer, string, or a pointer and a list", 42);
  # line 436 "../../../../Macaulay2/d/ffi.d"
  str__37 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (17)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__37) outofmem2((size_t)sizeof(struct M2_string_struct) + (17)*sizeof(signed char)-sizeof(signed char));
  # line 436 "../../../../Macaulay2/d/ffi.d"
  str__37->len = 17;
  # line 437 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__37->array, "ffiPointerAddress", 17);
  # line 437 "../../../../Macaulay2/d/ffi.d"
  str__38 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__38) outofmem2((size_t)sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  # line 437 "../../../../Macaulay2/d/ffi.d"
  str__38->len = 15;
  # line 443 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__38->array, "ffiPointerValue", 15);
  # line 443 "../../../../Macaulay2/d/ffi.d"
  str__39 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__39) outofmem2((size_t)sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  # line 443 "../../../../Macaulay2/d/ffi.d"
  str__39->len = 14;
  # line 449 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__39->array, "ffiStringValue", 14);
  # line 449 "../../../../Macaulay2/d/ffi.d"
  str__40 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (27)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__40) outofmem2((size_t)sizeof(struct M2_string_struct) + (27)*sizeof(signed char)-sizeof(signed char));
  # line 449 "../../../../Macaulay2/d/ffi.d"
  str__40->len = 27;
  # line 469 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__40->array, "registerFinalizerForPointer", 27);
  # line 469 "../../../../Macaulay2/d/ffi.d"
  str__41 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__41) outofmem2((size_t)sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  # line 469 "../../../../Macaulay2/d/ffi.d"
  str__41->len = 6;
  # line 492 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__41->array, "a list", 6);
  # line 492 "../../../../Macaulay2/d/ffi.d"
  str__42 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (13)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__42) outofmem2((size_t)sizeof(struct M2_string_struct) + (13)*sizeof(signed char)-sizeof(signed char));
  # line 492 "../../../../Macaulay2/d/ffi.d"
  str__42->len = 13;
  # line 493 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__42->array, "ffiStructType", 13);
  # line 493 "../../../../Macaulay2/d/ffi.d"
  str__43 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (19)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__43) outofmem2((size_t)sizeof(struct M2_string_struct) + (19)*sizeof(signed char)-sizeof(signed char));
  # line 493 "../../../../Macaulay2/d/ffi.d"
  str__43->len = 19;
  # line 508 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__43->array, "ffiGetStructOffsets", 19);
  # line 508 "../../../../Macaulay2/d/ffi.d"
  str__44 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__44) outofmem2((size_t)sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  # line 508 "../../../../Macaulay2/d/ffi.d"
  str__44->len = 6;
  # line 537 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__44->array, "a list", 6);
  # line 537 "../../../../Macaulay2/d/ffi.d"
  str__45 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (16)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__45) outofmem2((size_t)sizeof(struct M2_string_struct) + (16)*sizeof(signed char)-sizeof(signed char));
  # line 537 "../../../../Macaulay2/d/ffi.d"
  str__45->len = 16;
  # line 541 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__45->array, "ffiStructAddress", 16);
  # line 541 "../../../../Macaulay2/d/ffi.d"
  str__46 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__46) outofmem2((size_t)sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  # line 541 "../../../../Macaulay2/d/ffi.d"
  str__46->len = 6;
  # line 576 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__46->array, "a list", 6);
  # line 576 "../../../../Macaulay2/d/ffi.d"
  str__47 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (12)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__47) outofmem2((size_t)sizeof(struct M2_string_struct) + (12)*sizeof(signed char)-sizeof(signed char));
  # line 576 "../../../../Macaulay2/d/ffi.d"
  str__47->len = 12;
  # line 577 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__47->array, "ffiUnionType", 12);
  # line 577 "../../../../Macaulay2/d/ffi.d"
  str__48 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (33)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__48) outofmem2((size_t)sizeof(struct M2_string_struct) + (33)*sizeof(signed char)-sizeof(signed char));
  # line 577 "../../../../Macaulay2/d/ffi.d"
  str__48->len = 33;
  # line 613 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__48->array, "ffi_closure_alloc() returned NULL", 33);
  # line 613 "../../../../Macaulay2/d/ffi.d"
  str__49 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (10)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__49) outofmem2((size_t)sizeof(struct M2_string_struct) + (10)*sizeof(signed char)-sizeof(signed char));
  # line 613 "../../../../Macaulay2/d/ffi.d"
  str__49->len = 10;
  # line 624 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__49->array, "a function", 10);
  # line 624 "../../../../Macaulay2/d/ffi.d"
  str__50 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (25)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__50) outofmem2((size_t)sizeof(struct M2_string_struct) + (25)*sizeof(signed char)-sizeof(signed char));
  # line 624 "../../../../Macaulay2/d/ffi.d"
  str__50->len = 25;
  # line 626 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__50->array, "ffiFunctionPointerAddress", 25);
  # line 626 "../../../../Macaulay2/d/ffi.d"
  system__prepare();
  # line 626 "../../../../Macaulay2/d/ffi.d"
  common__prepare();
  # line 626 "../../../../Macaulay2/d/ffi.d"
  hashtables__prepare();
  # line 626 "../../../../Macaulay2/d/ffi.d"
  evaluate__prepare();
  # line 51 "../../../../Macaulay2/d/ffi.d"
  common_setupconst(str__2, toExpr_3(((void *)0)));
  # line 67 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__3, dlopen0);
  # line 90 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__5, dlsym0);
  # line 92 "../../../../Macaulay2/d/ffi.d"
  ffiTypeVoid = &ffi_type_void;
  # line 93 "../../../../Macaulay2/d/ffi.d"
  ffiOk = FFI_OK;
  # line 99 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__6, ffiTypeSize);
  # line 131 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__12, ffiPrepCif);
  # line 157 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__14, ffiPrepCifVar);
  # line 198 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__16, ffiCall);
  # line 203 "../../../../Macaulay2/d/ffi.d"
  common_setupconst(str__17, toExpr_3(&ffi_type_void));
  # line 243 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__20, ffiIntegerType);
  # line 294 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__23, ffiIntegerAddress);
  # line 334 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__26, ffiIntegerValue);
  # line 348 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__28, ffiRealType);
  # line 374 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__30, ffiRealAddress);
  # line 394 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__32, ffiRealValue);
  # line 400 "../../../../Macaulay2/d/ffi.d"
  pointerSize = sizeof(void *);
  # line 402 "../../../../Macaulay2/d/ffi.d"
  common_setupconst(str__33, toExpr_3(&ffi_type_pointer));
  # line 437 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__37, ffiPointerAddress);
  # line 443 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__38, ffiPointerValue);
  # line 449 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__39, ffiStringValue);
  # line 469 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__40, registerFinalizerForPointer);
  # line 493 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__42, ffiStructType);
  # line 508 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__43, ffiGetStructOffsets);
  # line 541 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__45, ffiStructAddress);
  # line 577 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__47, ffiUnionType);
  # line 626 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__50, ffiFunctionPointerAddress);
  # line 626 "../../../../Macaulay2/d/ffi.d"
  this_thread_prepare.func = ffi__thread_prepare;
  # line 626 "../../../../Macaulay2/d/ffi.d"
  this_thread_prepare.next = thread_prepare_list;
  # line 626 "../../../../Macaulay2/d/ffi.d"
  thread_prepare_list = &this_thread_prepare;
  # line 626 "../../../../Macaulay2/d/ffi.d"
  this_final.func = ffi__final;
  # line 626 "../../../../Macaulay2/d/ffi.d"
  this_final.next = final_list;
  # line 626 "../../../../Macaulay2/d/ffi.d"
  final_list = &this_final;
  # line 626 "../../../../Macaulay2/d/ffi.d"
  }
# line 626 "../../../../Macaulay2/d/ffi.d"
static void ffi__thread_prepare(){
  # line 626 "../../../../Macaulay2/d/ffi.d"
  }
# line 626 "../../../../Macaulay2/d/ffi.d"
static void ffi__final(){
  # line 626 "../../../../Macaulay2/d/ffi.d"
  }
